/* Device.c generated by valac 0.56.18, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gudev/gudev.h>
#include <gst/gst.h>

#define DVB_DEVICE_PRIME 31
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_DEVICE_ERROR (dvb_device_error_get_type ())
typedef enum  {
	DVB_ADAPTER_TYPE_UNKNOWN,
	DVB_ADAPTER_TYPE_TERRESTRIAL,
	DVB_ADAPTER_TYPE_SATELLITE,
	DVB_ADAPTER_TYPE_CABLE
} DVBAdapterType;

#define DVB_TYPE_ADAPTER_TYPE (dvb_adapter_type_get_type ())

#define DVB_TYPE_DEVICE (dvb_device_get_type ())
#define DVB_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE, DVBDevice))
#define DVB_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE, DVBDeviceClass))
#define DVB_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE))
#define DVB_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE))
#define DVB_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE, DVBDeviceClass))

typedef struct _DVBDevice DVBDevice;
typedef struct _DVBDeviceClass DVBDeviceClass;
typedef struct _DVBDevicePrivate DVBDevicePrivate;
typedef enum  {
	DVB_DVB_SRC_DELSYS_SYS_UNDEFINED,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B,
	DVB_DVB_SRC_DELSYS_SYS_DVBT,
	DVB_DVB_SRC_DELSYS_SYS_DSS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS2,
	DVB_DVB_SRC_DELSYS_SYS_DVBH,
	DVB_DVB_SRC_DELSYS_SYS_ISDBT,
	DVB_DVB_SRC_DELSYS_SYS_ISDBS,
	DVB_DVB_SRC_DELSYS_SYS_ISDBC,
	DVB_DVB_SRC_DELSYS_SYS_ATSC,
	DVB_DVB_SRC_DELSYS_SYS_ATSCMH,
	DVB_DVB_SRC_DELSYS_SYS_DTMB,
	DVB_DVB_SRC_DELSYS_SYS_CMMB,
	DVB_DVB_SRC_DELSYS_SYS_DAB,
	DVB_DVB_SRC_DELSYS_SYS_DVBT2,
	DVB_DVB_SRC_DELSYS_SYS_TURBO,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C
} DVBDvbSrcDelsys;

#define DVB_TYPE_DVB_SRC_DELSYS (dvb_dvb_src_delsys_get_type ())
enum  {
	DVB_DEVICE_0_PROPERTY,
	DVB_DEVICE_ADAPTER_PROPERTY,
	DVB_DEVICE_FRONTEND_PROPERTY,
	DVB_DEVICE_DEV_FILE_PROPERTY,
	DVB_DEVICE_UID_PROPERTY,
	DVB_DEVICE_NAME_PROPERTY,
	DVB_DEVICE_NUM_PROPERTIES
};
static GParamSpec* dvb_device_properties[DVB_DEVICE_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_message_unref0(var) ((var == NULL) ? NULL : (var = (gst_message_unref (var), NULL)))

typedef enum  {
	DVB_DEVICE_ERROR_UNKNOWN_TYPE
} DVBDeviceError;
#define DVB_DEVICE_ERROR dvb_device_error_quark ()

struct _DVBDevice {
	GObject parent_instance;
	DVBDevicePrivate * priv;
};

struct _DVBDeviceClass {
	GObjectClass parent_class;
};

struct _DVBDevicePrivate {
	guint _Adapter;
	guint _Frontend;
	gchar* _DevFile;
	gchar* _UID;
	gchar* _Name;
	GeeArrayList* delsys;
};

static gint DVBDevice_private_offset;
static gpointer dvb_device_parent_class = NULL;
static DVBLoggingLogger* dvb_device_log;
static DVBLoggingLogger* dvb_device_log = NULL;

VALA_EXTERN GQuark dvb_device_error_quark (void);
VALA_EXTERN GType dvb_device_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_adapter_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDevice, g_object_unref)
VALA_EXTERN GType dvb_dvb_src_delsys_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
VALA_EXTERN DVBDevice* dvb_device_new (guint adapter,
                           guint frontend);
VALA_EXTERN DVBDevice* dvb_device_construct (GType object_type,
                                 guint adapter,
                                 guint frontend);
static gboolean dvb_device_setAdapterTypeAndName (DVBDevice* self,
                                           guint adapter,
                                           guint frontend);
VALA_EXTERN DVBDevice* dvb_device_new_with_udev (GUdevDevice* device,
                                     const gchar* dev_file,
                                     guint adapter,
                                     guint frontend);
VALA_EXTERN DVBDevice* dvb_device_construct_with_udev (GType object_type,
                                           GUdevDevice* device,
                                           const gchar* dev_file,
                                           guint adapter,
                                           guint frontend);
VALA_EXTERN const gchar* dvb_device_get_Name (DVBDevice* self);
static void dvb_device_set_Name (DVBDevice* self,
                          const gchar* value);
VALA_EXTERN void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
static void dvb_device_set_DevFile (DVBDevice* self,
                             const gchar* value);
static void dvb_device_set_UID (DVBDevice* self,
                         const gchar* value);
VALA_EXTERN gboolean dvb_device_equal (DVBDevice* dev1,
                           DVBDevice* dev2);
VALA_EXTERN guint dvb_device_get_Adapter (DVBDevice* self);
VALA_EXTERN guint dvb_device_get_Frontend (DVBDevice* self);
VALA_EXTERN guint dvb_device_hash (DVBDevice* device);
VALA_EXTERN guint dvb_device_hash_without_device (guint adapter,
                                      guint frontend);
VALA_EXTERN gboolean dvb_device_isTerrestrial (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isCable (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isSatellite (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isDVB (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isATSC (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isISDB (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isDelsys (DVBDevice* self,
                              DVBDvbSrcDelsys delsys);
VALA_EXTERN gboolean dvb_device_is_busy (DVBDevice* self);
VALA_EXTERN void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
static void dvb_device_set_Adapter (DVBDevice* self,
                             guint value);
static void dvb_device_set_Frontend (DVBDevice* self,
                              guint value);
VALA_EXTERN const gchar* dvb_device_get_DevFile (DVBDevice* self);
VALA_EXTERN const gchar* dvb_device_get_UID (DVBDevice* self);
static void dvb_device_finalize (GObject * obj);
static GType dvb_device_get_type_once (void);
static void _vala_dvb_device_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_dvb_device_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GQuark
dvb_device_error_quark (void)
{
	return g_quark_from_static_string ("dvb-device-error-quark");
}

static GType
dvb_device_error_get_type_once (void)
{
	static const GEnumValue values[] = {{DVB_DEVICE_ERROR_UNKNOWN_TYPE, "DVB_DEVICE_ERROR_UNKNOWN_TYPE", "unknown-type"}, {0, NULL, NULL}};
	GType dvb_device_error_type_id;
	dvb_device_error_type_id = g_enum_register_static ("DVBDeviceError", values);
	return dvb_device_error_type_id;
}

GType
dvb_device_error_get_type (void)
{
	static volatile gsize dvb_device_error_type_id__once = 0;
	if (g_once_init_enter (&dvb_device_error_type_id__once)) {
		GType dvb_device_error_type_id;
		dvb_device_error_type_id = dvb_device_error_get_type_once ();
		g_once_init_leave (&dvb_device_error_type_id__once, dvb_device_error_type_id);
	}
	return dvb_device_error_type_id__once;
}

static GType
dvb_adapter_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DVB_ADAPTER_TYPE_UNKNOWN, "DVB_ADAPTER_TYPE_UNKNOWN", "unknown"}, {DVB_ADAPTER_TYPE_TERRESTRIAL, "DVB_ADAPTER_TYPE_TERRESTRIAL", "terrestrial"}, {DVB_ADAPTER_TYPE_SATELLITE, "DVB_ADAPTER_TYPE_SATELLITE", "satellite"}, {DVB_ADAPTER_TYPE_CABLE, "DVB_ADAPTER_TYPE_CABLE", "cable"}, {0, NULL, NULL}};
	GType dvb_adapter_type_type_id;
	dvb_adapter_type_type_id = g_enum_register_static ("DVBAdapterType", values);
	return dvb_adapter_type_type_id;
}

GType
dvb_adapter_type_get_type (void)
{
	static volatile gsize dvb_adapter_type_type_id__once = 0;
	if (g_once_init_enter (&dvb_adapter_type_type_id__once)) {
		GType dvb_adapter_type_type_id;
		dvb_adapter_type_type_id = dvb_adapter_type_get_type_once ();
		g_once_init_leave (&dvb_adapter_type_type_id__once, dvb_adapter_type_type_id);
	}
	return dvb_adapter_type_type_id__once;
}

static inline gpointer
dvb_device_get_instance_private (DVBDevice* self)
{
	return G_STRUCT_MEMBER_P (self, DVBDevice_private_offset);
}

DVBDevice*
dvb_device_construct (GType object_type,
                      guint adapter,
                      guint frontend)
{
	DVBDevice * self = NULL;
	self = (DVBDevice*) g_object_new (object_type, "Adapter", adapter, "Frontend", frontend, NULL);
	dvb_device_setAdapterTypeAndName (self, adapter, frontend);
	return self;
}

DVBDevice*
dvb_device_new (guint adapter,
                guint frontend)
{
	return dvb_device_construct (DVB_TYPE_DEVICE, adapter, frontend);
}

DVBDevice*
dvb_device_construct_with_udev (GType object_type,
                                GUdevDevice* device,
                                const gchar* dev_file,
                                guint adapter,
                                guint frontend)
{
	DVBDevice * self = NULL;
	GUdevDevice* parent = NULL;
	GUdevDevice* _tmp0_;
	gchar* name = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* tmp = NULL;
	GUdevDevice* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	DVBLoggingLogger* _tmp14_;
	const gchar* _tmp15_;
	GUdevDevice* _tmp16_;
	const gchar* _tmp17_;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (dev_file != NULL, NULL);
	self = (DVBDevice*) g_object_new (object_type, "Adapter", adapter, "Frontend", frontend, NULL);
	dvb_device_setAdapterTypeAndName (self, adapter, frontend);
	_tmp0_ = g_udev_device_get_parent (device);
	parent = _tmp0_;
	_tmp1_ = self->priv->_Name;
	_tmp2_ = g_strdup (_tmp1_);
	name = _tmp2_;
	_tmp3_ = parent;
	_tmp4_ = g_udev_device_get_property (_tmp3_, "ID_MODEL_FROM_DATABASE");
	_tmp5_ = g_strdup (_tmp4_);
	tmp = _tmp5_;
	_tmp6_ = tmp;
	if (_tmp6_ == NULL) {
		const gchar* _tmp7_;
		_tmp7_ = name;
		dvb_device_set_Name (self, _tmp7_);
	} else {
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp8_ = tmp;
		_tmp9_ = g_strconcat (_tmp8_, ": ", NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = name;
		_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
		_tmp13_ = _tmp12_;
		dvb_device_set_Name (self, _tmp13_);
		_g_free0 (_tmp13_);
		_g_free0 (_tmp10_);
	}
	_tmp14_ = dvb_device_log;
	_tmp15_ = self->priv->_Name;
	dvb_logging_logger_debug (_tmp14_, "Device.vala:75: Adding Device: %s", _tmp15_);
	dvb_device_set_DevFile (self, dev_file);
	_tmp16_ = parent;
	_tmp17_ = g_udev_device_get_subsystem (_tmp16_);
	if (g_strcmp0 (_tmp17_, "pci") == 0) {
		gchar* uid = NULL;
		GUdevDevice* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		GUdevDevice* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		DVBLoggingLogger* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		_tmp18_ = parent;
		_tmp19_ = g_udev_device_get_property (_tmp18_, "PCI_SLOT_NAME");
		_tmp20_ = g_strdup (_tmp19_);
		uid = _tmp20_;
		_tmp21_ = uid;
		_tmp22_ = parent;
		_tmp23_ = g_udev_device_get_property (_tmp22_, "PCI_SUBSYS_ID");
		_tmp24_ = g_strconcat (":", _tmp23_, NULL);
		_tmp25_ = _tmp24_;
		_tmp26_ = g_strconcat (_tmp21_, _tmp25_, NULL);
		_g_free0 (uid);
		uid = _tmp26_;
		_g_free0 (_tmp25_);
		_tmp27_ = uid;
		_tmp28_ = name;
		_tmp29_ = g_strconcat (":", _tmp28_, NULL);
		_tmp30_ = _tmp29_;
		_tmp31_ = g_strconcat (_tmp27_, _tmp30_, NULL);
		_g_free0 (uid);
		uid = _tmp31_;
		_g_free0 (_tmp30_);
		_tmp32_ = dvb_device_log;
		_tmp33_ = uid;
		dvb_logging_logger_debug (_tmp32_, "Device.vala:84: UID: %s", _tmp33_);
		_tmp34_ = uid;
		dvb_device_set_UID (self, _tmp34_);
		_g_free0 (uid);
	} else {
		GUdevDevice* _tmp35_;
		const gchar* _tmp36_;
		_tmp35_ = parent;
		_tmp36_ = g_udev_device_get_subsystem (_tmp35_);
		if (g_strcmp0 (_tmp36_, "usb") == 0) {
			gchar* uid = NULL;
			GUdevDevice* _tmp37_;
			const gchar* _tmp38_;
			gchar* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			DVBLoggingLogger* _tmp45_;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			_tmp37_ = parent;
			_tmp38_ = g_udev_device_get_property (_tmp37_, "ID_SERIAL");
			_tmp39_ = g_strdup (_tmp38_);
			uid = _tmp39_;
			_tmp40_ = uid;
			_tmp41_ = name;
			_tmp42_ = g_strconcat (":", _tmp41_, NULL);
			_tmp43_ = _tmp42_;
			_tmp44_ = g_strconcat (_tmp40_, _tmp43_, NULL);
			_g_free0 (uid);
			uid = _tmp44_;
			_g_free0 (_tmp43_);
			_tmp45_ = dvb_device_log;
			_tmp46_ = uid;
			dvb_logging_logger_debug (_tmp45_, "Device.vala:89: UID: %s", _tmp46_);
			_tmp47_ = uid;
			dvb_device_set_UID (self, _tmp47_);
			_g_free0 (uid);
		}
	}
	_g_free0 (tmp);
	_g_free0 (name);
	_g_object_unref0 (parent);
	return self;
}

DVBDevice*
dvb_device_new_with_udev (GUdevDevice* device,
                          const gchar* dev_file,
                          guint adapter,
                          guint frontend)
{
	return dvb_device_construct_with_udev (DVB_TYPE_DEVICE, device, dev_file, adapter, frontend);
}

gboolean
dvb_device_equal (DVBDevice* dev1,
                  DVBDevice* dev2)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint _tmp2_;
	guint _tmp3_;
	gboolean result;
	g_return_val_if_fail (dev1 != NULL, FALSE);
	g_return_val_if_fail (dev2 != NULL, FALSE);
	if (dev1 == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = dev2 == NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = dev1->priv->_Adapter;
	_tmp3_ = dev2->priv->_Adapter;
	if (_tmp2_ == _tmp3_) {
		guint _tmp4_;
		guint _tmp5_;
		_tmp4_ = dev1->priv->_Frontend;
		_tmp5_ = dev2->priv->_Frontend;
		_tmp1_ = _tmp4_ == _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	result = _tmp1_;
	return result;
}

guint
dvb_device_hash (DVBDevice* device)
{
	guint _tmp0_;
	guint _tmp1_;
	guint result;
	g_return_val_if_fail (device != NULL, 0U);
	if (device == NULL) {
		result = (guint) 0;
		return result;
	}
	_tmp0_ = device->priv->_Adapter;
	_tmp1_ = device->priv->_Frontend;
	result = dvb_device_hash_without_device (_tmp0_, _tmp1_);
	return result;
}

guint
dvb_device_hash_without_device (guint adapter,
                                guint frontend)
{
	guint result;
	result = ((2 * DVB_DEVICE_PRIME) + (DVB_DEVICE_PRIME * adapter)) + frontend;
	return result;
}

gboolean
dvb_device_isTerrestrial (DVBDevice* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_delsys_list = _tmp0_;
		_tmp1_ = _delsys_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_delsys_size = _tmp3_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			_delsys_index = _delsys_index + 1;
			_tmp4_ = _delsys_index;
			_tmp5_ = _delsys_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _delsys_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _delsys_index);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp7_);
			switch (delsys) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBT:
				case DVB_DVB_SRC_DELSYS_SYS_DVBT2:
				case DVB_DVB_SRC_DELSYS_SYS_DVBH:
				case DVB_DVB_SRC_DELSYS_SYS_ATSC:
				case DVB_DVB_SRC_DELSYS_SYS_ATSCMH:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBT:
				{
					result = TRUE;
					return result;
				}
				default:
				{
					break;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

gboolean
dvb_device_isCable (DVBDevice* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_delsys_list = _tmp0_;
		_tmp1_ = _delsys_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_delsys_size = _tmp3_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			_delsys_index = _delsys_index + 1;
			_tmp4_ = _delsys_index;
			_tmp5_ = _delsys_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _delsys_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _delsys_index);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp7_);
			switch (delsys) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A:
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B:
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBC:
				{
					result = TRUE;
					return result;
				}
				default:
				{
					break;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

gboolean
dvb_device_isSatellite (DVBDevice* self)
{
	gboolean ret = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	ret = FALSE;
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_delsys_list = _tmp0_;
		_tmp1_ = _delsys_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_delsys_size = _tmp3_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			_delsys_index = _delsys_index + 1;
			_tmp4_ = _delsys_index;
			_tmp5_ = _delsys_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _delsys_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _delsys_index);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp7_);
			switch (delsys) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBS:
				case DVB_DVB_SRC_DELSYS_SYS_DVBS2:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBS:
				case DVB_DVB_SRC_DELSYS_SYS_DSS:
				case DVB_DVB_SRC_DELSYS_SYS_TURBO:
				{
					result = TRUE;
					return result;
				}
				default:
				{
					break;
				}
			}
		}
	}
	result = ret;
	return result;
}

gboolean
dvb_device_isDVB (DVBDevice* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_delsys_list = _tmp0_;
		_tmp1_ = _delsys_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_delsys_size = _tmp3_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			_delsys_index = _delsys_index + 1;
			_tmp4_ = _delsys_index;
			_tmp5_ = _delsys_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _delsys_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _delsys_index);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp7_);
			switch (delsys) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBT:
				case DVB_DVB_SRC_DELSYS_SYS_DVBT2:
				case DVB_DVB_SRC_DELSYS_SYS_DVBS:
				case DVB_DVB_SRC_DELSYS_SYS_DVBS2:
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A:
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C:
				case DVB_DVB_SRC_DELSYS_SYS_DVBH:
				{
					result = TRUE;
					return result;
				}
				default:
				{
					break;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

gboolean
dvb_device_isATSC (DVBDevice* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_delsys_list = _tmp0_;
		_tmp1_ = _delsys_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_delsys_size = _tmp3_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			_delsys_index = _delsys_index + 1;
			_tmp4_ = _delsys_index;
			_tmp5_ = _delsys_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _delsys_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _delsys_index);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp7_);
			switch (delsys) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B:
				case DVB_DVB_SRC_DELSYS_SYS_ATSC:
				case DVB_DVB_SRC_DELSYS_SYS_ATSCMH:
				{
					result = TRUE;
					return result;
				}
				default:
				{
					break;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

gboolean
dvb_device_isISDB (DVBDevice* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_delsys_list = _tmp0_;
		_tmp1_ = _delsys_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_delsys_size = _tmp3_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			_delsys_index = _delsys_index + 1;
			_tmp4_ = _delsys_index;
			_tmp5_ = _delsys_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _delsys_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _delsys_index);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp7_);
			switch (delsys) {
				case DVB_DVB_SRC_DELSYS_SYS_ISDBT:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBC:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBS:
				{
					result = TRUE;
					return result;
				}
				default:
				{
					break;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

gboolean
dvb_device_isDelsys (DVBDevice* self,
                     DVBDvbSrcDelsys delsys)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _d_list = NULL;
		GeeArrayList* _tmp0_;
		gint _d_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _d_index = 0;
		_tmp0_ = self->priv->delsys;
		_d_list = _tmp0_;
		_tmp1_ = _d_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_d_size = _tmp3_;
		_d_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			DVBDvbSrcDelsys d = 0;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			_d_index = _d_index + 1;
			_tmp4_ = _d_index;
			_tmp5_ = _d_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _d_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _d_index);
			d = (DVBDvbSrcDelsys) ((gintptr) _tmp7_);
			if (d == delsys) {
				result = TRUE;
				return result;
			}
		}
	}
	result = FALSE;
	return result;
}

gboolean
dvb_device_is_busy (DVBDevice* self)
{
	GstElement* dvbsrc = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp3_;
	guint _tmp4_;
	GstElement* _tmp5_;
	guint _tmp6_;
	GstElement* pipeline = NULL;
	GstPipeline* _tmp7_;
	GstElement* _tmp8_;
	GstElement* _tmp9_;
	GstElement* _tmp10_;
	GstBus* bus = NULL;
	GstElement* _tmp11_;
	GstBus* _tmp12_;
	gboolean busy_val = FALSE;
	GstElement* _tmp28_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gst_element_factory_make ("dvbsrc", "text_dvbsrc");
	if (_tmp0_ != NULL) {
		g_object_ref_sink (_tmp0_);
	}
	dvbsrc = _tmp0_;
	_tmp1_ = dvbsrc;
	if (_tmp1_ == NULL) {
		DVBLoggingLogger* _tmp2_;
		_tmp2_ = dvb_device_log;
		dvb_logging_logger_error (_tmp2_, "Device.vala:217: Could not create dvbsrc element");
		result = TRUE;
		_g_object_unref0 (dvbsrc);
		return result;
	}
	_tmp3_ = dvbsrc;
	_tmp4_ = self->priv->_Adapter;
	g_object_set ((GObject*) _tmp3_, "adapter", _tmp4_, NULL);
	_tmp5_ = dvbsrc;
	_tmp6_ = self->priv->_Frontend;
	g_object_set ((GObject*) _tmp5_, "frontend", _tmp6_, NULL);
	_tmp7_ = (GstPipeline*) gst_pipeline_new ("");
	g_object_ref_sink (_tmp7_);
	pipeline = (GstElement*) _tmp7_;
	_tmp8_ = pipeline;
	_tmp9_ = dvbsrc;
	gst_bin_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gst_bin_get_type (), GstBin), _tmp9_);
	_tmp10_ = pipeline;
	gst_element_set_state (_tmp10_, GST_STATE_READY);
	_tmp11_ = pipeline;
	_tmp12_ = gst_element_get_bus (_tmp11_);
	bus = _tmp12_;
	busy_val = FALSE;
	while (TRUE) {
		GstBus* _tmp13_;
		GstMessage* msg = NULL;
		GstBus* _tmp14_;
		GstMessage* _tmp15_;
		gboolean _tmp16_ = FALSE;
		GstMessage* _tmp17_;
		_tmp13_ = bus;
		if (!gst_bus_have_pending (_tmp13_)) {
			break;
		}
		_tmp14_ = bus;
		_tmp15_ = gst_bus_pop (_tmp14_);
		msg = _tmp15_;
		_tmp17_ = msg;
		if (_tmp17_->type == GST_MESSAGE_ERROR) {
			GstMessage* _tmp18_;
			GstObject* _tmp19_;
			GstElement* _tmp20_;
			_tmp18_ = msg;
			_tmp19_ = _tmp18_->src;
			_tmp20_ = dvbsrc;
			_tmp16_ = _tmp19_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gst_object_get_type (), GstObject);
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			GError* gerror = NULL;
			gchar* debug_text = NULL;
			GstMessage* _tmp21_;
			GError* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			DVBLoggingLogger* _tmp24_;
			GError* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			_tmp21_ = msg;
			gst_message_parse_error (_tmp21_, &_tmp22_, &_tmp23_);
			_g_error_free0 (gerror);
			gerror = _tmp22_;
			_g_free0 (debug_text);
			debug_text = _tmp23_;
			_tmp24_ = dvb_device_log;
			_tmp25_ = gerror;
			_tmp26_ = _tmp25_->message;
			_tmp27_ = debug_text;
			dvb_logging_logger_debug (_tmp24_, "Device.vala:239: Error tuning: %s; %s", _tmp26_, _tmp27_);
			busy_val = TRUE;
			_g_free0 (debug_text);
			_g_error_free0 (gerror);
		}
		_gst_message_unref0 (msg);
	}
	_tmp28_ = pipeline;
	gst_element_set_state (_tmp28_, GST_STATE_NULL);
	result = busy_val;
	_g_object_unref0 (bus);
	_g_object_unref0 (pipeline);
	_g_object_unref0 (dvbsrc);
	return result;
}

static gboolean
dvb_device_setAdapterTypeAndName (DVBDevice* self,
                                  guint adapter,
                                  guint frontend)
{
	GstElement* dvbsrc = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp3_;
	GstElement* _tmp4_;
	GstElement* pipeline = NULL;
	GstPipeline* _tmp5_;
	GstElement* _tmp6_;
	GstElement* _tmp7_;
	GstElement* _tmp8_;
	GstBus* bus = NULL;
	GstElement* _tmp9_;
	GstBus* _tmp10_;
	gboolean success = FALSE;
	GeeArrayList* _tmp11_;
	GstElement* _tmp71_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gst_element_factory_make ("dvbsrc", "test_dvbsrc");
	if (_tmp0_ != NULL) {
		g_object_ref_sink (_tmp0_);
	}
	dvbsrc = _tmp0_;
	_tmp1_ = dvbsrc;
	if (_tmp1_ == NULL) {
		DVBLoggingLogger* _tmp2_;
		_tmp2_ = dvb_device_log;
		dvb_logging_logger_error (_tmp2_, "Device.vala:253: Could not create dvbsrc element");
		result = FALSE;
		_g_object_unref0 (dvbsrc);
		return result;
	}
	_tmp3_ = dvbsrc;
	g_object_set ((GObject*) _tmp3_, "adapter", adapter, NULL);
	_tmp4_ = dvbsrc;
	g_object_set ((GObject*) _tmp4_, "frontend", frontend, NULL);
	_tmp5_ = (GstPipeline*) gst_pipeline_new ("type_name");
	g_object_ref_sink (_tmp5_);
	pipeline = (GstElement*) _tmp5_;
	_tmp6_ = pipeline;
	_tmp7_ = dvbsrc;
	gst_bin_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gst_bin_get_type (), GstBin), _tmp7_);
	_tmp8_ = pipeline;
	gst_element_set_state (_tmp8_, GST_STATE_READY);
	_tmp9_ = pipeline;
	_tmp10_ = gst_element_get_bus (_tmp9_);
	bus = _tmp10_;
	success = FALSE;
	_tmp11_ = gee_array_list_new (DVB_TYPE_DVB_SRC_DELSYS, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->delsys);
	self->priv->delsys = _tmp11_;
	while (TRUE) {
		GstBus* _tmp12_;
		GstMessage* msg = NULL;
		GstBus* _tmp13_;
		GstMessage* _tmp14_;
		gboolean _tmp15_ = FALSE;
		GstMessage* _tmp16_;
		_tmp12_ = bus;
		if (!gst_bus_have_pending (_tmp12_)) {
			break;
		}
		_tmp13_ = bus;
		_tmp14_ = gst_bus_pop (_tmp13_);
		msg = _tmp14_;
		_tmp16_ = msg;
		if (_tmp16_->type == GST_MESSAGE_ELEMENT) {
			GstMessage* _tmp17_;
			GstObject* _tmp18_;
			GstElement* _tmp19_;
			_tmp17_ = msg;
			_tmp18_ = _tmp17_->src;
			_tmp19_ = dvbsrc;
			_tmp15_ = _tmp18_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gst_object_get_type (), GstObject);
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			GstStructure* structure = NULL;
			GstMessage* _tmp20_;
			GstStructure* _tmp21_;
			GstStructure* _tmp22_;
			const gchar* _tmp23_;
			_tmp20_ = msg;
			_tmp21_ = gst_message_get_structure (_tmp20_);
			structure = _tmp21_;
			_tmp22_ = structure;
			_tmp23_ = gst_structure_get_name (_tmp22_);
			if (g_strcmp0 (_tmp23_, "dvb-adapter") == 0) {
				GstStructure* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				GstStructure* _tmp28_;
				GstStructure* _tmp30_;
				GstStructure* _tmp32_;
				GstStructure* _tmp34_;
				GstStructure* _tmp36_;
				GstStructure* _tmp38_;
				GstStructure* _tmp40_;
				GstStructure* _tmp42_;
				GstStructure* _tmp44_;
				GstStructure* _tmp46_;
				GstStructure* _tmp48_;
				GstStructure* _tmp50_;
				GstStructure* _tmp52_;
				GstStructure* _tmp54_;
				GstStructure* _tmp56_;
				GstStructure* _tmp58_;
				GstStructure* _tmp60_;
				GstStructure* _tmp62_;
				_tmp24_ = structure;
				_tmp25_ = gst_structure_get_string (_tmp24_, "name");
				_tmp26_ = g_strdup_printf ("%s", _tmp25_);
				_tmp27_ = _tmp26_;
				dvb_device_set_Name (self, _tmp27_);
				_g_free0 (_tmp27_);
				_tmp28_ = structure;
				if (gst_structure_has_field (_tmp28_, "dvb-c-a")) {
					GeeArrayList* _tmp29_;
					_tmp29_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A));
				}
				_tmp30_ = structure;
				if (gst_structure_has_field (_tmp30_, "dvb-c-b")) {
					GeeArrayList* _tmp31_;
					_tmp31_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B));
				}
				_tmp32_ = structure;
				if (gst_structure_has_field (_tmp32_, "dvb-t")) {
					GeeArrayList* _tmp33_;
					_tmp33_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp33_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBT));
				}
				_tmp34_ = structure;
				if (gst_structure_has_field (_tmp34_, "dss")) {
					GeeArrayList* _tmp35_;
					_tmp35_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DSS));
				}
				_tmp36_ = structure;
				if (gst_structure_has_field (_tmp36_, "dvb-s")) {
					GeeArrayList* _tmp37_;
					_tmp37_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp37_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBS));
				}
				_tmp38_ = structure;
				if (gst_structure_has_field (_tmp38_, "dvb-s2")) {
					GeeArrayList* _tmp39_;
					_tmp39_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBS2));
				}
				_tmp40_ = structure;
				if (gst_structure_has_field (_tmp40_, "dvb-h")) {
					GeeArrayList* _tmp41_;
					_tmp41_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBH));
				}
				_tmp42_ = structure;
				if (gst_structure_has_field (_tmp42_, "isdb-t")) {
					GeeArrayList* _tmp43_;
					_tmp43_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ISDBT));
				}
				_tmp44_ = structure;
				if (gst_structure_has_field (_tmp44_, "isdb-s")) {
					GeeArrayList* _tmp45_;
					_tmp45_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp45_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ISDBS));
				}
				_tmp46_ = structure;
				if (gst_structure_has_field (_tmp46_, "isdb-c")) {
					GeeArrayList* _tmp47_;
					_tmp47_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp47_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ISDBC));
				}
				_tmp48_ = structure;
				if (gst_structure_has_field (_tmp48_, "atsc")) {
					GeeArrayList* _tmp49_;
					_tmp49_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ATSC));
				}
				_tmp50_ = structure;
				if (gst_structure_has_field (_tmp50_, "atsc-mh")) {
					GeeArrayList* _tmp51_;
					_tmp51_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp51_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ATSCMH));
				}
				_tmp52_ = structure;
				if (gst_structure_has_field (_tmp52_, "dtmb")) {
					GeeArrayList* _tmp53_;
					_tmp53_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp53_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DTMB));
				}
				_tmp54_ = structure;
				if (gst_structure_has_field (_tmp54_, "cmmb")) {
					GeeArrayList* _tmp55_;
					_tmp55_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp55_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_CMMB));
				}
				_tmp56_ = structure;
				if (gst_structure_has_field (_tmp56_, "dab")) {
					GeeArrayList* _tmp57_;
					_tmp57_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp57_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DAB));
				}
				_tmp58_ = structure;
				if (gst_structure_has_field (_tmp58_, "dvb-t2")) {
					GeeArrayList* _tmp59_;
					_tmp59_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp59_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBT2));
				}
				_tmp60_ = structure;
				if (gst_structure_has_field (_tmp60_, "turbo")) {
					GeeArrayList* _tmp61_;
					_tmp61_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_TURBO));
				}
				_tmp62_ = structure;
				if (gst_structure_has_field (_tmp62_, "dvb-c-c")) {
					GeeArrayList* _tmp63_;
					_tmp63_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp63_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C));
				}
				success = TRUE;
				_gst_message_unref0 (msg);
				break;
			}
		} else {
			GstMessage* _tmp64_;
			_tmp64_ = msg;
			if (_tmp64_->type == GST_MESSAGE_ERROR) {
				GError* gerror = NULL;
				gchar* debug = NULL;
				GstMessage* _tmp65_;
				GError* _tmp66_ = NULL;
				gchar* _tmp67_ = NULL;
				GError* _tmp68_;
				const gchar* _tmp69_;
				const gchar* _tmp70_;
				_tmp65_ = msg;
				gst_message_parse_error (_tmp65_, &_tmp66_, &_tmp67_);
				_g_error_free0 (gerror);
				gerror = _tmp66_;
				_g_free0 (debug);
				debug = _tmp67_;
				_tmp68_ = gerror;
				_tmp69_ = _tmp68_->message;
				_tmp70_ = debug;
				g_warning ("Device.vala:340: %s %s", _tmp69_, _tmp70_);
				_g_free0 (debug);
				_g_error_free0 (gerror);
			}
		}
		_gst_message_unref0 (msg);
	}
	_tmp71_ = pipeline;
	gst_element_set_state (_tmp71_, GST_STATE_NULL);
	result = success;
	_g_object_unref0 (bus);
	_g_object_unref0 (pipeline);
	_g_object_unref0 (dvbsrc);
	return result;
}

guint
dvb_device_get_Adapter (DVBDevice* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_Adapter;
	return result;
}

static void
dvb_device_set_Adapter (DVBDevice* self,
                        guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_get_Adapter (self);
	if (old_value != value) {
		self->priv->_Adapter = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_ADAPTER_PROPERTY]);
	}
}

guint
dvb_device_get_Frontend (DVBDevice* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_Frontend;
	return result;
}

static void
dvb_device_set_Frontend (DVBDevice* self,
                         guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_get_Frontend (self);
	if (old_value != value) {
		self->priv->_Frontend = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_FRONTEND_PROPERTY]);
	}
}

const gchar*
dvb_device_get_DevFile (DVBDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_DevFile;
	result = _tmp0_;
	return result;
}

static void
dvb_device_set_DevFile (DVBDevice* self,
                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_get_DevFile (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_DevFile);
		self->priv->_DevFile = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_DEV_FILE_PROPERTY]);
	}
}

const gchar*
dvb_device_get_UID (DVBDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_UID;
	result = _tmp0_;
	return result;
}

static void
dvb_device_set_UID (DVBDevice* self,
                    const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_get_UID (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_UID);
		self->priv->_UID = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_UID_PROPERTY]);
	}
}

const gchar*
dvb_device_get_Name (DVBDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Name;
	result = _tmp0_;
	return result;
}

static void
dvb_device_set_Name (DVBDevice* self,
                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_get_Name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_Name);
		self->priv->_Name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_NAME_PROPERTY]);
	}
}

static void
dvb_device_class_init (DVBDeviceClass * klass,
                       gpointer klass_data)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBDevice_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_device_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_device_set_property;
	G_OBJECT_CLASS (klass)->finalize = dvb_device_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_ADAPTER_PROPERTY, dvb_device_properties[DVB_DEVICE_ADAPTER_PROPERTY] = g_param_spec_uint ("Adapter", "Adapter", "Adapter", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_FRONTEND_PROPERTY, dvb_device_properties[DVB_DEVICE_FRONTEND_PROPERTY] = g_param_spec_uint ("Frontend", "Frontend", "Frontend", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_DEV_FILE_PROPERTY, dvb_device_properties[DVB_DEVICE_DEV_FILE_PROPERTY] = g_param_spec_string ("DevFile", "DevFile", "DevFile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_UID_PROPERTY, dvb_device_properties[DVB_DEVICE_UID_PROPERTY] = g_param_spec_string ("UID", "UID", "UID", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_NAME_PROPERTY, dvb_device_properties[DVB_DEVICE_NAME_PROPERTY] = g_param_spec_string ("Name", "Name", "Name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_device_log = _tmp1_;
}

static void
dvb_device_instance_init (DVBDevice * self,
                          gpointer klass)
{
	self->priv = dvb_device_get_instance_private (self);
}

static void
dvb_device_finalize (GObject * obj)
{
	DVBDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_DEVICE, DVBDevice);
	_g_free0 (self->priv->_DevFile);
	_g_free0 (self->priv->_UID);
	_g_free0 (self->priv->_Name);
	_g_object_unref0 (self->priv->delsys);
	G_OBJECT_CLASS (dvb_device_parent_class)->finalize (obj);
}

static GType
dvb_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBDevice), 0, (GInstanceInitFunc) dvb_device_instance_init, NULL };
	GType dvb_device_type_id;
	dvb_device_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBDevice", &g_define_type_info, 0);
	DVBDevice_private_offset = g_type_add_instance_private (dvb_device_type_id, sizeof (DVBDevicePrivate));
	return dvb_device_type_id;
}

GType
dvb_device_get_type (void)
{
	static volatile gsize dvb_device_type_id__once = 0;
	if (g_once_init_enter (&dvb_device_type_id__once)) {
		GType dvb_device_type_id;
		dvb_device_type_id = dvb_device_get_type_once ();
		g_once_init_leave (&dvb_device_type_id__once, dvb_device_type_id);
	}
	return dvb_device_type_id__once;
}

static void
_vala_dvb_device_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	DVBDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_DEVICE, DVBDevice);
	switch (property_id) {
		case DVB_DEVICE_ADAPTER_PROPERTY:
		g_value_set_uint (value, dvb_device_get_Adapter (self));
		break;
		case DVB_DEVICE_FRONTEND_PROPERTY:
		g_value_set_uint (value, dvb_device_get_Frontend (self));
		break;
		case DVB_DEVICE_DEV_FILE_PROPERTY:
		g_value_set_string (value, dvb_device_get_DevFile (self));
		break;
		case DVB_DEVICE_UID_PROPERTY:
		g_value_set_string (value, dvb_device_get_UID (self));
		break;
		case DVB_DEVICE_NAME_PROPERTY:
		g_value_set_string (value, dvb_device_get_Name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_device_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	DVBDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_DEVICE, DVBDevice);
	switch (property_id) {
		case DVB_DEVICE_ADAPTER_PROPERTY:
		dvb_device_set_Adapter (self, g_value_get_uint (value));
		break;
		case DVB_DEVICE_FRONTEND_PROPERTY:
		dvb_device_set_Frontend (self, g_value_get_uint (value));
		break;
		case DVB_DEVICE_DEV_FILE_PROPERTY:
		dvb_device_set_DevFile (self, g_value_get_string (value));
		break;
		case DVB_DEVICE_UID_PROPERTY:
		dvb_device_set_UID (self, g_value_get_string (value));
		break;
		case DVB_DEVICE_NAME_PROPERTY:
		dvb_device_set_Name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

