/* DeviceGroup.c generated by valac 0.56.18, the Vala compiler
 * generated from DeviceGroup.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#define DVB_CONSTANTS_DBUS_RECORDER_PATH "/org/gnome/DVB/DeviceGroup/%u/Recorder"
#define DVB_CONSTANTS_DBUS_CHANNEL_LIST_PATH "/org/gnome/DVB/DeviceGroup/%u/ChannelList"
#define DVB_CONSTANTS_DVB_DEVICE_PATH "/dev/dvb/adapter%u/frontend%u"
#define DVB_CONSTANTS_DBUS_SCHEDULE_PATH "/org/gnome/DVB/DeviceGroup/%u/Schedule/%u"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_ID_BUS_DEVICE_GROUP (dvb_id_bus_device_group_get_type ())
#define DVB_ID_BUS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP, DVBIDBusDeviceGroup))
#define DVB_IS_ID_BUS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP))
#define DVB_ID_BUS_DEVICE_GROUP_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_DEVICE_GROUP, DVBIDBusDeviceGroupIface))

typedef struct _DVBIDBusDeviceGroup DVBIDBusDeviceGroup;
typedef struct _DVBIDBusDeviceGroupIface DVBIDBusDeviceGroupIface;

#define DVB_TYPE_ID_BUS_DEVICE_GROUP_PROXY (dvb_id_bus_device_group_proxy_get_type ())
typedef enum  {
	DVB_ADAPTER_TYPE_UNKNOWN,
	DVB_ADAPTER_TYPE_TERRESTRIAL,
	DVB_ADAPTER_TYPE_SATELLITE,
	DVB_ADAPTER_TYPE_CABLE
} DVBAdapterType;

#define DVB_TYPE_ADAPTER_TYPE (dvb_adapter_type_get_type ())

#define DVB_TYPE_DEVICE_GROUP (dvb_device_group_get_type ())
#define DVB_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup))
#define DVB_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))
#define DVB_IS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE_GROUP))
#define DVB_IS_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE_GROUP))
#define DVB_DEVICE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))

typedef struct _DVBDeviceGroup DVBDeviceGroup;
typedef struct _DVBDeviceGroupClass DVBDeviceGroupClass;
typedef struct _DVBDeviceGroupPrivate DVBDeviceGroupPrivate;

#define DVB_TYPE_CHANNEL_LIST (dvb_channel_list_get_type ())
#define DVB_CHANNEL_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_LIST, DVBChannelList))
#define DVB_CHANNEL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_LIST, DVBChannelListClass))
#define DVB_IS_CHANNEL_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_LIST))
#define DVB_IS_CHANNEL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_LIST))
#define DVB_CHANNEL_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_LIST, DVBChannelListClass))

typedef struct _DVBChannelList DVBChannelList;
typedef struct _DVBChannelListClass DVBChannelListClass;

#define DVB_TYPE_DEVICE (dvb_device_get_type ())
#define DVB_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE, DVBDevice))
#define DVB_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE, DVBDeviceClass))
#define DVB_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE))
#define DVB_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE))
#define DVB_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE, DVBDeviceClass))

typedef struct _DVBDevice DVBDevice;
typedef struct _DVBDeviceClass DVBDeviceClass;

#define DVB_TYPE_RECORDER (dvb_recorder_get_type ())
#define DVB_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_RECORDER, DVBRecorder))
#define DVB_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_RECORDER, DVBRecorderClass))
#define DVB_IS_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_RECORDER))
#define DVB_IS_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_RECORDER))
#define DVB_RECORDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_RECORDER, DVBRecorderClass))

typedef struct _DVBRecorder DVBRecorder;
typedef struct _DVBRecorderClass DVBRecorderClass;

#define DVB_TYPE_EPG_SCANNER (dvb_epg_scanner_get_type ())
#define DVB_EPG_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_EPG_SCANNER, DVBEPGScanner))
#define DVB_EPG_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_EPG_SCANNER, DVBEPGScannerClass))
#define DVB_IS_EPG_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_EPG_SCANNER))
#define DVB_IS_EPG_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_EPG_SCANNER))
#define DVB_EPG_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_EPG_SCANNER, DVBEPGScannerClass))

typedef struct _DVBEPGScanner DVBEPGScanner;
typedef struct _DVBEPGScannerClass DVBEPGScannerClass;

#define DVB_TYPE_CHANNEL_FACTORY (dvb_channel_factory_get_type ())
#define DVB_CHANNEL_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_FACTORY, DVBChannelFactory))
#define DVB_CHANNEL_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_FACTORY, DVBChannelFactoryClass))
#define DVB_IS_CHANNEL_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_FACTORY))
#define DVB_IS_CHANNEL_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_FACTORY))
#define DVB_CHANNEL_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_FACTORY, DVBChannelFactoryClass))

typedef struct _DVBChannelFactory DVBChannelFactory;
typedef struct _DVBChannelFactoryClass DVBChannelFactoryClass;
enum  {
	DVB_DEVICE_GROUP_0_PROPERTY,
	DVB_DEVICE_GROUP_SIZE_PROPERTY,
	DVB_DEVICE_GROUP_DEVICES_PROPERTY,
	DVB_DEVICE_GROUP_ID_PROPERTY,
	DVB_DEVICE_GROUP_CHANNELS_PROPERTY,
	DVB_DEVICE_GROUP_RECORDINGS_DIRECTORY_PROPERTY,
	DVB_DEVICE_GROUP_TYPE_PROPERTY,
	DVB_DEVICE_GROUP_RECORDER_PROPERTY,
	DVB_DEVICE_GROUP_EPGSCANNER_PROPERTY,
	DVB_DEVICE_GROUP_CHANNEL_FACTORY_PROPERTY,
	DVB_DEVICE_GROUP_NAME_PROPERTY,
	DVB_DEVICE_GROUP_ELEMENT_TYPE_PROPERTY,
	DVB_DEVICE_GROUP_NUM_PROPERTIES
};
static GParamSpec* dvb_device_group_properties[DVB_DEVICE_GROUP_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_TYPE_MANAGER (dvb_manager_get_type ())
#define DVB_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_MANAGER, DVBManager))
#define DVB_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_MANAGER, DVBManagerClass))
#define DVB_IS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_MANAGER))
#define DVB_IS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_MANAGER))
#define DVB_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_MANAGER, DVBManagerClass))

typedef struct _DVBManager DVBManager;
typedef struct _DVBManagerClass DVBManagerClass;

#define DVB_TYPE_FACTORY (dvb_factory_get_type ())
#define DVB_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_FACTORY, DVBFactory))
#define DVB_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_FACTORY, DVBFactoryClass))
#define DVB_IS_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_FACTORY))
#define DVB_IS_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_FACTORY))
#define DVB_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_FACTORY, DVBFactoryClass))

typedef struct _DVBFactory DVBFactory;
typedef struct _DVBFactoryClass DVBFactoryClass;

#define DVB_DATABASE_TYPE_CONFIG_STORE (dvb_database_config_store_get_type ())
#define DVB_DATABASE_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStore))
#define DVB_DATABASE_IS_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE))
#define DVB_DATABASE_CONFIG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStoreIface))

typedef struct _DVBdatabaseConfigStore DVBdatabaseConfigStore;
typedef struct _DVBdatabaseConfigStoreIface DVBdatabaseConfigStoreIface;

#define DVB_DATABASE_TYPE_SQL_ERROR (dvb_database_sql_error_get_type ())

#define DVB_TYPE_CHANNEL_GROUP (dvb_channel_group_get_type ())
#define DVB_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroup))
#define DVB_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))
#define DVB_IS_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_GROUP))
#define DVB_IS_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_GROUP))
#define DVB_CHANNEL_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))

typedef struct _DVBChannelGroup DVBChannelGroup;
typedef struct _DVBChannelGroupClass DVBChannelGroupClass;

#define DVB_TYPE_CHANNEL (dvb_channel_get_type ())
#define DVB_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL, DVBChannel))
#define DVB_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL, DVBChannelClass))
#define DVB_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL))
#define DVB_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL))
#define DVB_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL, DVBChannelClass))

typedef struct _DVBChannel DVBChannel;
typedef struct _DVBChannelClass DVBChannelClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DVB_TYPE_ID_BUS_RECORDER (dvb_id_bus_recorder_get_type ())
#define DVB_ID_BUS_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_RECORDER, DVBIDBusRecorder))
#define DVB_IS_ID_BUS_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_RECORDER))
#define DVB_ID_BUS_RECORDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_RECORDER, DVBIDBusRecorderIface))

typedef struct _DVBIDBusRecorder DVBIDBusRecorder;
typedef struct _DVBIDBusRecorderIface DVBIDBusRecorderIface;

#define DVB_TYPE_ID_BUS_RECORDER_PROXY (dvb_id_bus_recorder_proxy_get_type ())

#define DVB_TYPE_TIMER_INFO (dvb_timer_info_get_type ())
typedef struct _DVBTimerInfo DVBTimerInfo;
typedef enum  {
	DVB_OVERLAP_TYPE_UNKNOWN,
	DVB_OVERLAP_TYPE_NONE,
	DVB_OVERLAP_TYPE_PARTIAL,
	DVB_OVERLAP_TYPE_COMPLETE
} DVBOverlapType;

#define DVB_TYPE_OVERLAP_TYPE (dvb_overlap_type_get_type ())

#define DVB_TYPE_ID_BUS_CHANNEL_LIST (dvb_id_bus_channel_list_get_type ())
#define DVB_ID_BUS_CHANNEL_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_CHANNEL_LIST, DVBIDBusChannelList))
#define DVB_IS_ID_BUS_CHANNEL_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_CHANNEL_LIST))
#define DVB_ID_BUS_CHANNEL_LIST_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_CHANNEL_LIST, DVBIDBusChannelListIface))

typedef struct _DVBIDBusChannelList DVBIDBusChannelList;
typedef struct _DVBIDBusChannelListIface DVBIDBusChannelListIface;

#define DVB_TYPE_ID_BUS_CHANNEL_LIST_PROXY (dvb_id_bus_channel_list_proxy_get_type ())

#define DVB_TYPE_CHANNEL_INFO (dvb_channel_info_get_type ())
typedef struct _DVBChannelInfo DVBChannelInfo;

#define DVB_TYPE_SCHEDULE (dvb_schedule_get_type ())
#define DVB_SCHEDULE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_SCHEDULE, DVBSchedule))
#define DVB_SCHEDULE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_SCHEDULE, DVBScheduleClass))
#define DVB_IS_SCHEDULE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_SCHEDULE))
#define DVB_IS_SCHEDULE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_SCHEDULE))
#define DVB_SCHEDULE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_SCHEDULE, DVBScheduleClass))

typedef struct _DVBSchedule DVBSchedule;
typedef struct _DVBScheduleClass DVBScheduleClass;

#define DVB_TYPE_ID_BUS_SCHEDULE (dvb_id_bus_schedule_get_type ())
#define DVB_ID_BUS_SCHEDULE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_SCHEDULE, DVBIDBusSchedule))
#define DVB_IS_ID_BUS_SCHEDULE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_SCHEDULE))
#define DVB_ID_BUS_SCHEDULE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_SCHEDULE, DVBIDBusScheduleIface))

typedef struct _DVBIDBusSchedule DVBIDBusSchedule;
typedef struct _DVBIDBusScheduleIface DVBIDBusScheduleIface;

#define DVB_TYPE_ID_BUS_SCHEDULE_PROXY (dvb_id_bus_schedule_proxy_get_type ())

#define DVB_TYPE_EVENT_INFO (dvb_event_info_get_type ())
typedef struct _DVBEventInfo DVBEventInfo;

struct _DVBIDBusDeviceGroupIface {
	GTypeInterface parent_iface;
	DVBAdapterType (*GetType) (DVBIDBusDeviceGroup* self, GError** error);
	char* (*GetRecorder) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*AddDevice) (DVBIDBusDeviceGroup* self, guint adapter, guint frontend, GError** error);
	gboolean (*RemoveDevice) (DVBIDBusDeviceGroup* self, guint adapter, guint frontend, GError** error);
	char* (*GetChannelList) (DVBIDBusDeviceGroup* self, GError** error);
	gchar* (*GetName) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*SetName) (DVBIDBusDeviceGroup* self, const gchar* name, GError** error);
	gchar** (*GetMembers) (DVBIDBusDeviceGroup* self, gint* result_length1, GError** error);
	gboolean (*GetSchedule) (DVBIDBusDeviceGroup* self, guint channel_sid, char** opath, GError** error);
	gchar* (*GetRecordingsDirectory) (DVBIDBusDeviceGroup* self, GError** error);
	gboolean (*SetRecordingsDirectory) (DVBIDBusDeviceGroup* self, const gchar* location, GError** error);
};

struct _DVBDeviceGroup {
	GObject parent_instance;
	DVBDeviceGroupPrivate * priv;
};

struct _DVBDeviceGroupClass {
	GObjectClass parent_class;
};

struct _DVBDeviceGroupPrivate {
	guint _Id;
	DVBChannelList* _Channels;
	GFile* _RecordingsDirectory;
	DVBAdapterType _Type;
	gchar* _Name;
	GeeSet* devices;
	GRecMutex __lock_devices;
	DVBRecorder* _recorder;
	DVBEPGScanner* _epgscanner;
	DVBChannelFactory* _channelfactory;
	GeeHashSet* schedules;
};

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()

struct _DVBdatabaseConfigStoreIface {
	GTypeInterface parent_iface;
	GeeList* (*get_all_device_groups) (DVBdatabaseConfigStore* self, GError** error);
	DVBDeviceGroup* (*get_device_group) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_last_device) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_group_member) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* group, GError** error);
	gboolean (*add_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* dev_group, GError** error);
	gboolean (*remove_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*add_device_to_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*remove_device_from_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*update_from_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*get_parent_groups) (DVBdatabaseConfigStore* self, guint adapter, guint frontend, guint** group_ids, gint* group_ids_length1, GError** error);
	gboolean (*add_channel_group) (DVBdatabaseConfigStore* self, const gchar* name, gint* channel_group_id, GError** error);
	gboolean (*remove_channel_group) (DVBdatabaseConfigStore* self, gint group_id, GError** error);
	GeeList* (*get_channel_groups) (DVBdatabaseConfigStore* self, GError** error);
	GeeList* (*get_channels_of_group) (DVBdatabaseConfigStore* self, guint dev_group_id, gint channel_group_id, GError** error);
	gboolean (*add_channel_to_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
	gboolean (*remove_channel_from_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
};

struct _DVBTimerInfo {
	guint32 id;
	guint duration;
	gboolean active;
	gchar* channel_name;
	gchar* title;
};

struct _DVBIDBusRecorderIface {
	GTypeInterface parent_iface;
	gboolean (*AddTimer) (DVBIDBusRecorder* self, guint channel, gint start_year, gint start_month, gint start_day, gint start_hour, gint start_minute, guint duration, guint32* timer_id, GError** error);
	gboolean (*AddTimerWithMargin) (DVBIDBusRecorder* self, guint channel, gint start_year, gint start_month, gint start_day, gint start_hour, gint start_minute, guint duration, guint32* timer_id, GError** error);
	gboolean (*AddTimerForEPGEvent) (DVBIDBusRecorder* self, guint event_id, guint channel_sid, guint32* timer_id, GError** error);
	gboolean (*DeleteTimer) (DVBIDBusRecorder* self, guint32 timer_id, GError** error);
	guint32* (*GetTimers) (DVBIDBusRecorder* self, gint* result_length1, GError** error);
	gboolean (*GetStartTime) (DVBIDBusRecorder* self, guint32 timer_id, guint32** start_time, gint* start_time_length1, GError** error);
	gboolean (*SetStartTime) (DVBIDBusRecorder* self, guint32 timer_id, gint start_year, gint start_month, gint start_day, gint start_hour, gint start_minute, GError** error);
	gboolean (*GetEndTime) (DVBIDBusRecorder* self, guint32 timer_id, guint** end_time, gint* end_time_length1, GError** error);
	gboolean (*GetDuration) (DVBIDBusRecorder* self, guint32 timer_id, guint* duration, GError** error);
	gboolean (*SetDuration) (DVBIDBusRecorder* self, guint32 timer_id, guint duration, GError** error);
	gboolean (*GetChannelName) (DVBIDBusRecorder* self, guint32 timer_id, gchar** name, GError** error);
	gboolean (*GetTitle) (DVBIDBusRecorder* self, guint32 timer_id, gchar** title, GError** error);
	gboolean (*GetAllInformations) (DVBIDBusRecorder* self, guint32 timer_id, DVBTimerInfo* info, GError** error);
	guint32* (*GetActiveTimers) (DVBIDBusRecorder* self, gint* result_length1, GError** error);
	gboolean (*IsTimerActive) (DVBIDBusRecorder* self, guint32 timer_id, GError** error);
	gboolean (*HasTimer) (DVBIDBusRecorder* self, guint start_year, guint start_month, guint start_day, guint start_hour, guint start_minute, guint duration, GError** error);
	DVBOverlapType (*HasTimerForEvent) (DVBIDBusRecorder* self, guint event_id, guint channel_sid, GError** error);
};

struct _DVBChannelInfo {
	guint id;
	gchar* name;
	gboolean is_radio;
};

struct _DVBIDBusChannelListIface {
	GTypeInterface parent_iface;
	guint* (*GetChannels) (DVBIDBusChannelList* self, gint* result_length1, GError** error);
	guint* (*GetRadioChannels) (DVBIDBusChannelList* self, gint* result_length1, GError** error);
	guint* (*GetTVChannels) (DVBIDBusChannelList* self, gint* result_length1, GError** error);
	gboolean (*GetChannelName) (DVBIDBusChannelList* self, guint channel_id, gchar** channel_name, GError** error);
	gboolean (*GetChannelNetwork) (DVBIDBusChannelList* self, guint channel_id, gchar** network, GError** error);
	gboolean (*IsRadioChannel) (DVBIDBusChannelList* self, guint channel_id, gboolean* radio, GError** error);
	gboolean (*GetChannelURL) (DVBIDBusChannelList* self, guint channel_id, gchar** url, GError** error);
	DVBChannelInfo* (*GetChannelInfos) (DVBIDBusChannelList* self, gint* result_length1, GError** error);
	gboolean (*GetChannelsOfGroup) (DVBIDBusChannelList* self, gint channel_group_id, guint** channel_ids, gint* channel_ids_length1, GError** error);
	gboolean (*AddChannelToGroup) (DVBIDBusChannelList* self, guint channel_id, gint channel_group_id, GError** error);
	gboolean (*RemoveChannelFromGroup) (DVBIDBusChannelList* self, guint channel_id, gint channel_group_id, GError** error);
};

struct _DVBEventInfo {
	guint32 id;
	guint32 next;
	gchar* name;
	guint duration;
	gchar* short_description;
};

struct _DVBIDBusScheduleIface {
	GTypeInterface parent_iface;
	guint32* (*GetAllEvents) (DVBIDBusSchedule* self, gint* result_length1, GError** error);
	DVBEventInfo* (*GetAllEventInfos) (DVBIDBusSchedule* self, gint* result_length1, GError** error);
	gboolean (*GetInformations) (DVBIDBusSchedule* self, guint32 event_id, DVBEventInfo* event_info, GError** error);
	guint32 (*NowPlaying) (DVBIDBusSchedule* self, GError** error);
	guint32 (*Next) (DVBIDBusSchedule* self, guint32 event_id, GError** error);
	gboolean (*GetName) (DVBIDBusSchedule* self, guint32 event_id, gchar** name, GError** error);
	gboolean (*GetShortDescription) (DVBIDBusSchedule* self, guint32 event_id, gchar** description, GError** error);
	gboolean (*GetExtendedDescription) (DVBIDBusSchedule* self, guint32 event_id, gchar** description, GError** error);
	gboolean (*GetDuration) (DVBIDBusSchedule* self, guint32 event_id, guint* duration, GError** error);
	gboolean (*GetLocalStartTime) (DVBIDBusSchedule* self, guint32 event_id, guint** start_time, gint* start_time_length1, GError** error);
	gboolean (*GetLocalStartTimestamp) (DVBIDBusSchedule* self, guint32 event_id, gint64* timestamp, GError** error);
	gboolean (*IsRunning) (DVBIDBusSchedule* self, guint32 event_id, gboolean* running, GError** error);
	gboolean (*IsScrambled) (DVBIDBusSchedule* self, guint32 event_id, gboolean* scrambled, GError** error);
};

static gint DVBDeviceGroup_private_offset;
static gpointer dvb_device_group_parent_class = NULL;
static DVBLoggingLogger* dvb_device_group_log;
static DVBLoggingLogger* dvb_device_group_log = NULL;
VALA_EXTERN GDBusConnection* main_conn;
static DVBIDBusDeviceGroupIface * dvb_device_group_dvb_id_bus_device_group_parent_iface = NULL;
static GeeTraversableIface * dvb_device_group_gee_traversable_parent_iface = NULL;
static GeeIterableIface * dvb_device_group_gee_iterable_parent_iface = NULL;

VALA_EXTERN GType dvb_id_bus_device_group_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_device_group_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GType dvb_adapter_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_id_bus_device_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusDeviceGroup, g_object_unref)
VALA_EXTERN GType dvb_device_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDeviceGroup, g_object_unref)
VALA_EXTERN GType dvb_channel_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannelList, g_object_unref)
VALA_EXTERN GType dvb_device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDevice, g_object_unref)
VALA_EXTERN GType dvb_recorder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBRecorder, g_object_unref)
VALA_EXTERN GType dvb_epg_scanner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEPGScanner, g_object_unref)
VALA_EXTERN GType dvb_channel_factory_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannelFactory, g_object_unref)
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
VALA_EXTERN DVBDeviceGroup* dvb_device_group_new (guint id,
                                      GFile* channels_conf,
                                      GFile* recordings_dir,
                                      DVBAdapterType type,
                                      gboolean with_epg_scanner);
VALA_EXTERN DVBDeviceGroup* dvb_device_group_construct (GType object_type,
                                            guint id,
                                            GFile* channels_conf,
                                            GFile* recordings_dir,
                                            DVBAdapterType type,
                                            gboolean with_epg_scanner);
VALA_EXTERN DVBChannelList* dvb_channel_list_new (GFile* channels);
VALA_EXTERN DVBChannelList* dvb_channel_list_construct (GType object_type,
                                            GFile* channels);
VALA_EXTERN DVBChannelList* dvb_device_group_get_Channels (DVBDeviceGroup* self);
VALA_EXTERN guint dvb_device_group_get_Id (DVBDeviceGroup* self);
VALA_EXTERN void dvb_channel_list_set_GroupId (DVBChannelList* self,
                                   guint value);
VALA_EXTERN DVBEPGScanner* dvb_epg_scanner_new (DVBDeviceGroup* device);
VALA_EXTERN DVBEPGScanner* dvb_epg_scanner_construct (GType object_type,
                                          DVBDeviceGroup* device);
VALA_EXTERN gboolean dvb_device_group_register_channel_list (DVBDeviceGroup* self);
VALA_EXTERN gboolean dvb_device_group_register_recorder (DVBDeviceGroup* self);
VALA_EXTERN void dvb_device_group_destroy (DVBDeviceGroup* self);
VALA_EXTERN void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN void dvb_device_group_stop_epg_scanner (DVBDeviceGroup* self);
VALA_EXTERN void dvb_recorder_stop (DVBRecorder* self);
VALA_EXTERN void dvb_channel_factory_destroy (DVBChannelFactory* self);
VALA_EXTERN void dvb_device_group_start_epg_scanner (DVBDeviceGroup* self);
VALA_EXTERN gboolean dvb_epg_scanner_start (DVBEPGScanner* self);
VALA_EXTERN void dvb_epg_scanner_stop (DVBEPGScanner* self);
VALA_EXTERN gboolean dvb_device_group_add (DVBDeviceGroup* self,
                               DVBDevice* device);
VALA_EXTERN DVBAdapterType dvb_device_group_get_Type (DVBDeviceGroup* self);
VALA_EXTERN gboolean dvb_device_isTerrestrial (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isSatellite (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_isCable (DVBDevice* self);
VALA_EXTERN gboolean dvb_device_group_contains (DVBDeviceGroup* self,
                                    DVBDevice* device);
VALA_EXTERN gboolean dvb_device_group_remove (DVBDeviceGroup* self,
                                  DVBDevice* device);
VALA_EXTERN DVBDevice* dvb_device_group_get_next_free_device (DVBDeviceGroup* self);
VALA_EXTERN gboolean dvb_device_is_busy (DVBDevice* self);
static DVBAdapterType dvb_device_group_real_GetType (DVBIDBusDeviceGroup* base,
                                              GError** error);
static gboolean dvb_device_group_real_AddDevice (DVBIDBusDeviceGroup* base,
                                          guint adapter,
                                          guint frontend,
                                          GError** error);
VALA_EXTERN GType dvb_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBManager, g_object_unref)
VALA_EXTERN DVBManager* dvb_manager_get_instance (void);
VALA_EXTERN DVBDevice* dvb_manager_get_device (DVBManager* self,
                                   guint adapter,
                                   guint frontend);
VALA_EXTERN gboolean dvb_manager_device_is_in_any_group (DVBManager* self,
                                             DVBDevice* device,
                                             DVBAdapterType type);
VALA_EXTERN DVBFactory* dvb_factory_new (void);
VALA_EXTERN DVBFactory* dvb_factory_construct (GType object_type);
VALA_EXTERN GType dvb_factory_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBFactory, g_object_unref)
VALA_EXTERN GQuark dvb_database_sql_error_quark (void);
VALA_EXTERN GType dvb_database_sql_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_channel_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannelGroup, g_object_unref)
VALA_EXTERN GType dvb_channel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannel, g_object_unref)
VALA_EXTERN GType dvb_database_config_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseConfigStore, g_object_unref)
VALA_EXTERN DVBdatabaseConfigStore* dvb_factory_get_config_store (DVBFactory* self);
VALA_EXTERN gboolean dvb_database_config_store_add_device_to_group (DVBdatabaseConfigStore* self,
                                                        DVBDevice* dev,
                                                        DVBDeviceGroup* devgroup,
                                                        GError** error);
VALA_EXTERN void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
static char* dvb_device_group_real_GetRecorder (DVBIDBusDeviceGroup* base,
                                         GError** error);
VALA_EXTERN DVBRecorder* dvb_device_group_get_recorder (DVBDeviceGroup* self);
VALA_EXTERN void dvb_utils_dbus_register_object (GType t_type,
                                     GBoxedCopyFunc t_dup_func,
                                     GDestroyNotify t_destroy_func,
                                     GDBusConnection* conn,
                                     const gchar* object_path,
                                     gconstpointer obj);
VALA_EXTERN GType dvb_id_bus_recorder_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_recorder_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN GType dvb_timer_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBTimerInfo* dvb_timer_info_dup (const DVBTimerInfo* self);
VALA_EXTERN void dvb_timer_info_free (DVBTimerInfo* self);
VALA_EXTERN void dvb_timer_info_copy (const DVBTimerInfo* self,
                          DVBTimerInfo* dest);
VALA_EXTERN void dvb_timer_info_destroy (DVBTimerInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBTimerInfo, dvb_timer_info_destroy)
VALA_EXTERN GType dvb_overlap_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_id_bus_recorder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusRecorder, g_object_unref)
static gboolean dvb_device_group_real_RemoveDevice (DVBIDBusDeviceGroup* base,
                                             guint adapter,
                                             guint frontend,
                                             GError** error);
VALA_EXTERN gboolean dvb_database_config_store_remove_device_from_group (DVBdatabaseConfigStore* self,
                                                             DVBDevice* dev,
                                                             DVBDeviceGroup* devgroup,
                                                             GError** error);
VALA_EXTERN gint dvb_device_group_get_size (DVBDeviceGroup* self);
static gchar* dvb_device_group_real_GetName (DVBIDBusDeviceGroup* base,
                                      GError** error);
VALA_EXTERN const gchar* dvb_device_group_get_Name (DVBDeviceGroup* self);
static gboolean dvb_device_group_real_SetName (DVBIDBusDeviceGroup* base,
                                        const gchar* name,
                                        GError** error);
VALA_EXTERN void dvb_device_group_set_Name (DVBDeviceGroup* self,
                                const gchar* value);
VALA_EXTERN gboolean dvb_database_config_store_update_from_group (DVBdatabaseConfigStore* self,
                                                      DVBDeviceGroup* devgroup,
                                                      GError** error);
static char* dvb_device_group_real_GetChannelList (DVBIDBusDeviceGroup* base,
                                            GError** error);
VALA_EXTERN GType dvb_id_bus_channel_list_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_channel_list_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GType dvb_channel_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBChannelInfo* dvb_channel_info_dup (const DVBChannelInfo* self);
VALA_EXTERN void dvb_channel_info_free (DVBChannelInfo* self);
VALA_EXTERN void dvb_channel_info_copy (const DVBChannelInfo* self,
                            DVBChannelInfo* dest);
VALA_EXTERN void dvb_channel_info_destroy (DVBChannelInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBChannelInfo, dvb_channel_info_destroy)
VALA_EXTERN GType dvb_id_bus_channel_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusChannelList, g_object_unref)
static gchar** dvb_device_group_real_GetMembers (DVBIDBusDeviceGroup* base,
                                          gint* result_length1,
                                          GError** error);
VALA_EXTERN guint dvb_device_get_Adapter (DVBDevice* self);
VALA_EXTERN guint dvb_device_get_Frontend (DVBDevice* self);
static gboolean dvb_device_group_real_GetSchedule (DVBIDBusDeviceGroup* base,
                                            guint channel_sid,
                                            char** opath,
                                            GError** error);
VALA_EXTERN gboolean dvb_channel_list_contains (DVBChannelList* self,
                                    guint sid);
VALA_EXTERN GType dvb_schedule_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBSchedule, g_object_unref)
VALA_EXTERN DVBChannel* dvb_channel_list_get_channel (DVBChannelList* self,
                                          guint sid);
VALA_EXTERN DVBSchedule* dvb_channel_get_Schedule (DVBChannel* self);
VALA_EXTERN GType dvb_id_bus_schedule_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_schedule_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN GType dvb_event_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBEventInfo* dvb_event_info_dup (const DVBEventInfo* self);
VALA_EXTERN void dvb_event_info_free (DVBEventInfo* self);
VALA_EXTERN void dvb_event_info_copy (const DVBEventInfo* self,
                          DVBEventInfo* dest);
VALA_EXTERN void dvb_event_info_destroy (DVBEventInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBEventInfo, dvb_event_info_destroy)
VALA_EXTERN GType dvb_id_bus_schedule_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusSchedule, g_object_unref)
static gchar* dvb_device_group_real_GetRecordingsDirectory (DVBIDBusDeviceGroup* base,
                                                     GError** error);
VALA_EXTERN GFile* dvb_device_group_get_RecordingsDirectory (DVBDeviceGroup* self);
static gboolean dvb_device_group_real_SetRecordingsDirectory (DVBIDBusDeviceGroup* base,
                                                       const gchar* location,
                                                       GError** error);
VALA_EXTERN void dvb_device_group_set_RecordingsDirectory (DVBDeviceGroup* self,
                                               GFile* value);
static GeeIterator* dvb_device_group_real_iterator (GeeIterable* base);
static gboolean dvb_device_group_real_foreach (GeeTraversable* base,
                                        GeeForallFunc f,
                                        gpointer f_target);
VALA_EXTERN GeeSet* dvb_device_group_get_Devices (DVBDeviceGroup* self);
static void dvb_device_group_set_Id (DVBDeviceGroup* self,
                              guint value);
static void dvb_device_group_set_Channels (DVBDeviceGroup* self,
                                    DVBChannelList* value);
static void dvb_device_group_set_Type (DVBDeviceGroup* self,
                                DVBAdapterType value);
VALA_EXTERN DVBEPGScanner* dvb_device_group_get_epgscanner (DVBDeviceGroup* self);
VALA_EXTERN DVBChannelFactory* dvb_device_group_get_channel_factory (DVBDeviceGroup* self);
static GObject * dvb_device_group_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
VALA_EXTERN guint dvb_device_hash (DVBDevice* device);
static guint _dvb_device_hash_gee_hash_data_func (gconstpointer v,
                                           gpointer self);
VALA_EXTERN gboolean dvb_device_equal (DVBDevice* dev1,
                           DVBDevice* dev2);
static gboolean _dvb_device_equal_gee_equal_data_func (gconstpointer a,
                                                gconstpointer b,
                                                gpointer self);
VALA_EXTERN DVBChannelFactory* dvb_channel_factory_new (DVBDeviceGroup* devgroup);
VALA_EXTERN DVBChannelFactory* dvb_channel_factory_construct (GType object_type,
                                                  DVBDeviceGroup* devgroup);
VALA_EXTERN DVBRecorder* dvb_recorder_new (DVBDeviceGroup* dev);
VALA_EXTERN DVBRecorder* dvb_recorder_construct (GType object_type,
                                     DVBDeviceGroup* dev);
VALA_EXTERN DVBAdapterType dvb_id_bus_device_group_GetType (DVBIDBusDeviceGroup* self,
                                                GError** error);
VALA_EXTERN gboolean dvb_id_bus_device_group_AddDevice (DVBIDBusDeviceGroup* self,
                                            guint adapter,
                                            guint frontend,
                                            GError** error);
VALA_EXTERN char* dvb_id_bus_device_group_GetRecorder (DVBIDBusDeviceGroup* self,
                                           GError** error);
VALA_EXTERN gboolean dvb_id_bus_device_group_RemoveDevice (DVBIDBusDeviceGroup* self,
                                               guint adapter,
                                               guint frontend,
                                               GError** error);
VALA_EXTERN gchar* dvb_id_bus_device_group_GetName (DVBIDBusDeviceGroup* self,
                                        GError** error);
VALA_EXTERN gboolean dvb_id_bus_device_group_SetName (DVBIDBusDeviceGroup* self,
                                          const gchar* name,
                                          GError** error);
VALA_EXTERN char* dvb_id_bus_device_group_GetChannelList (DVBIDBusDeviceGroup* self,
                                              GError** error);
VALA_EXTERN gchar** dvb_id_bus_device_group_GetMembers (DVBIDBusDeviceGroup* self,
                                            gint* result_length1,
                                            GError** error);
VALA_EXTERN gboolean dvb_id_bus_device_group_GetSchedule (DVBIDBusDeviceGroup* self,
                                              guint channel_sid,
                                              char** opath,
                                              GError** error);
VALA_EXTERN gchar* dvb_id_bus_device_group_GetRecordingsDirectory (DVBIDBusDeviceGroup* self,
                                                       GError** error);
VALA_EXTERN gboolean dvb_id_bus_device_group_SetRecordingsDirectory (DVBIDBusDeviceGroup* self,
                                                         const gchar* location,
                                                         GError** error);
static void dvb_device_group_finalize (GObject * obj);
static GType dvb_device_group_get_type_once (void);
static void _vala_dvb_device_group_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_dvb_device_group_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
dvb_device_group_get_instance_private (DVBDeviceGroup* self)
{
	return G_STRUCT_MEMBER_P (self, DVBDeviceGroup_private_offset);
}

/**
         * @id: ID of group
         * @channels_conf: the channel list file name (dvbv5 format)
         * @recordings_dir: directory in which the records are saved
         * @type: the type of this group (terrestrial, cable, satellite)
         * @with_epg_scanner: Whether to provide an EPG scanner
         */
DVBDeviceGroup*
dvb_device_group_construct (GType object_type,
                            guint id,
                            GFile* channels_conf,
                            GFile* recordings_dir,
                            DVBAdapterType type,
                            gboolean with_epg_scanner)
{
	DVBDeviceGroup * self = NULL;
	DVBChannelList* _tmp0_;
	DVBChannelList* _tmp1_;
	DVBChannelList* _tmp2_;
	guint _tmp3_;
	g_return_val_if_fail (channels_conf != NULL, NULL);
	g_return_val_if_fail (recordings_dir != NULL, NULL);
	_tmp0_ = dvb_channel_list_new (channels_conf);
	_tmp1_ = _tmp0_;
	self = (DVBDeviceGroup*) g_object_new (object_type, "Id", id, "Channels", _tmp1_, "RecordingsDirectory", recordings_dir, "Type", type, NULL);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = self->priv->_Channels;
	_tmp3_ = self->priv->_Id;
	dvb_channel_list_set_GroupId (_tmp2_, _tmp3_);
	if (with_epg_scanner) {
		DVBEPGScanner* _tmp4_;
		_tmp4_ = dvb_epg_scanner_new (self);
		_g_object_unref0 (self->priv->_epgscanner);
		self->priv->_epgscanner = _tmp4_;
	} else {
		_g_object_unref0 (self->priv->_epgscanner);
		self->priv->_epgscanner = NULL;
	}
	dvb_device_group_register_channel_list (self);
	dvb_device_group_register_recorder (self);
	return self;
}

DVBDeviceGroup*
dvb_device_group_new (guint id,
                      GFile* channels_conf,
                      GFile* recordings_dir,
                      DVBAdapterType type,
                      gboolean with_epg_scanner)
{
	return dvb_device_group_construct (DVB_TYPE_DEVICE_GROUP, id, channels_conf, recordings_dir, type, with_epg_scanner);
}

void
dvb_device_group_destroy (DVBDeviceGroup* self)
{
	DVBLoggingLogger* _tmp0_;
	guint _tmp1_;
	DVBRecorder* _tmp2_;
	DVBChannelFactory* _tmp3_;
	GeeHashSet* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = dvb_device_group_log;
	_tmp1_ = self->priv->_Id;
	dvb_logging_logger_debug (_tmp0_, "DeviceGroup.vala:98: Destroying group %u", _tmp1_);
	dvb_device_group_stop_epg_scanner (self);
	_tmp2_ = self->priv->_recorder;
	dvb_recorder_stop (_tmp2_);
	_tmp3_ = self->priv->_channelfactory;
	dvb_channel_factory_destroy (_tmp3_);
	_tmp4_ = self->priv->schedules;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp4_);
	{
		GeeSet* _tmp5_;
		_tmp5_ = self->priv->devices;
		g_rec_mutex_lock (&self->priv->__lock_devices);
		{
			GeeSet* _tmp6_;
			_tmp6_ = self->priv->devices;
			gee_collection_clear ((GeeCollection*) _tmp6_);
		}
		__finally0:
		{
			GeeSet* _tmp7_;
			_tmp7_ = self->priv->devices;
			g_rec_mutex_unlock (&self->priv->__lock_devices);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
dvb_device_group_start_epg_scanner (DVBDeviceGroup* self)
{
	DVBEPGScanner* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_epgscanner;
	if (_tmp0_ != NULL) {
		DVBEPGScanner* _tmp1_;
		_tmp1_ = self->priv->_epgscanner;
		dvb_epg_scanner_start (_tmp1_);
	}
}

void
dvb_device_group_stop_epg_scanner (DVBDeviceGroup* self)
{
	DVBEPGScanner* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_epgscanner;
	if (_tmp0_ != NULL) {
		DVBEPGScanner* _tmp1_;
		_tmp1_ = self->priv->_epgscanner;
		dvb_epg_scanner_stop (_tmp1_);
	}
}

/**
         * Add device to group. The device's settings will be overridden
         * with those of the reference device.
         */
gboolean
dvb_device_group_add (DVBDeviceGroup* self,
                      DVBDevice* device)
{
	DVBAdapterType _tmp0_;
	gboolean _result_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (device != NULL, FALSE);
	_tmp0_ = self->priv->_Type;
	switch (_tmp0_) {
		case DVB_ADAPTER_TYPE_TERRESTRIAL:
		{
			if (!dvb_device_isTerrestrial (device)) {
				g_warning ("DeviceGroup.vala:126: Cannot add device, because it is not of same typ" \
"e");
				result = FALSE;
				return result;
			}
			break;
		}
		case DVB_ADAPTER_TYPE_SATELLITE:
		{
			if (!dvb_device_isSatellite (device)) {
				g_warning ("DeviceGroup.vala:132: Cannot add device, because it is not of same typ" \
"e");
				result = FALSE;
				return result;
			}
			break;
		}
		case DVB_ADAPTER_TYPE_CABLE:
		{
			if (!dvb_device_isCable (device)) {
				g_warning ("DeviceGroup.vala:138: Cannot add device, because it is not of same typ" \
"e");
				result = FALSE;
				return result;
			}
			break;
		}
		default:
		break;
	}
	{
		GeeSet* _tmp1_;
		_tmp1_ = self->priv->devices;
		g_rec_mutex_lock (&self->priv->__lock_devices);
		{
			GeeSet* _tmp2_;
			_tmp2_ = self->priv->devices;
			_result_ = gee_collection_add ((GeeCollection*) _tmp2_, device);
		}
		__finally0:
		{
			GeeSet* _tmp3_;
			_tmp3_ = self->priv->devices;
			g_rec_mutex_unlock (&self->priv->__lock_devices);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp4_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp4_;
		}
	}
	result = _result_;
	return result;
}

gboolean
dvb_device_group_contains (DVBDeviceGroup* self,
                           DVBDevice* device)
{
	gboolean _result_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (device != NULL, FALSE);
	{
		GeeSet* _tmp0_;
		_tmp0_ = self->priv->devices;
		g_rec_mutex_lock (&self->priv->__lock_devices);
		{
			GeeSet* _tmp1_;
			_tmp1_ = self->priv->devices;
			_result_ = gee_collection_contains ((GeeCollection*) _tmp1_, device);
		}
		__finally0:
		{
			GeeSet* _tmp2_;
			_tmp2_ = self->priv->devices;
			g_rec_mutex_unlock (&self->priv->__lock_devices);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp3_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp3_;
		}
	}
	result = _result_;
	return result;
}

gboolean
dvb_device_group_remove (DVBDeviceGroup* self,
                         DVBDevice* device)
{
	gboolean _result_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (device != NULL, FALSE);
	{
		GeeSet* _tmp0_;
		_tmp0_ = self->priv->devices;
		g_rec_mutex_lock (&self->priv->__lock_devices);
		{
			GeeSet* _tmp1_;
			_tmp1_ = self->priv->devices;
			_result_ = gee_collection_remove ((GeeCollection*) _tmp1_, device);
		}
		__finally0:
		{
			GeeSet* _tmp2_;
			_tmp2_ = self->priv->devices;
			g_rec_mutex_unlock (&self->priv->__lock_devices);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp3_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp3_;
		}
	}
	result = _result_;
	return result;
}

/**
         * Get first device that isn't busy.
         * If all devices are busy NULL is returned.
         */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

DVBDevice*
dvb_device_group_get_next_free_device (DVBDeviceGroup* self)
{
	DVBDevice* _result_ = NULL;
	GError* _inner_error0_ = NULL;
	DVBDevice* result;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = NULL;
	{
		GeeSet* _tmp0_;
		_tmp0_ = self->priv->devices;
		g_rec_mutex_lock (&self->priv->__lock_devices);
		{
			{
				GeeIterator* _dev_it = NULL;
				GeeSet* _tmp1_;
				GeeIterator* _tmp2_;
				_tmp1_ = self->priv->devices;
				_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
				_dev_it = _tmp2_;
				while (TRUE) {
					GeeIterator* _tmp3_;
					DVBDevice* dev = NULL;
					GeeIterator* _tmp4_;
					gpointer _tmp5_;
					DVBDevice* _tmp6_;
					_tmp3_ = _dev_it;
					if (!gee_iterator_next (_tmp3_)) {
						break;
					}
					_tmp4_ = _dev_it;
					_tmp5_ = gee_iterator_get (_tmp4_);
					dev = (DVBDevice*) _tmp5_;
					_tmp6_ = dev;
					if (!dvb_device_is_busy (_tmp6_)) {
						DVBDevice* _tmp7_;
						DVBDevice* _tmp8_;
						_tmp7_ = dev;
						_tmp8_ = _g_object_ref0 (_tmp7_);
						_g_object_unref0 (_result_);
						_result_ = _tmp8_;
						_g_object_unref0 (dev);
						break;
					}
					_g_object_unref0 (dev);
				}
				_g_object_unref0 (_dev_it);
			}
		}
		__finally0:
		{
			GeeSet* _tmp9_;
			_tmp9_ = self->priv->devices;
			g_rec_mutex_unlock (&self->priv->__lock_devices);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_result_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = _result_;
	return result;
}

/**
         * @returns: Name of adapter type the group holds
         * or an empty string when group with given id doesn't exist.
         */
static DVBAdapterType
dvb_device_group_real_GetType (DVBIDBusDeviceGroup* base,
                               GError** error)
{
	DVBDeviceGroup * self;
	DVBAdapterType _tmp0_;
	DVBAdapterType result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = self->priv->_Type;
	result = _tmp0_;
	return result;
}

/**
         * @adapter: Number of the device's adapter
         * @frontend: Number of the device's frontend
         * @returns: TRUE when the device has been registered successfully
         *
         * Creates a new device and adds it to the DeviceGroup.
         * The new device will inherit all settings from the group's
         * reference device.
         */
static gboolean
dvb_device_group_real_AddDevice (DVBIDBusDeviceGroup* base,
                                 guint adapter,
                                 guint frontend,
                                 GError** error)
{
	DVBDeviceGroup * self;
	DVBManager* manager = NULL;
	DVBManager* _tmp0_;
	DVBManager* _tmp1_;
	DVBDevice* device = NULL;
	DVBManager* _tmp2_;
	DVBDevice* _tmp3_;
	DVBDevice* _tmp4_;
	DVBManager* _tmp5_;
	DVBDevice* _tmp6_;
	DVBAdapterType _tmp7_;
	DVBLoggingLogger* _tmp9_;
	guint _tmp10_;
	DVBDevice* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = dvb_manager_get_instance ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	manager = _tmp1_;
	_tmp2_ = manager;
	_tmp3_ = dvb_manager_get_device (_tmp2_, adapter, frontend);
	device = _tmp3_;
	_tmp4_ = device;
	if (_tmp4_ == NULL) {
		result = FALSE;
		_g_object_unref0 (device);
		_g_object_unref0 (manager);
		return result;
	}
	_tmp5_ = manager;
	_tmp6_ = device;
	_tmp7_ = self->priv->_Type;
	if (dvb_manager_device_is_in_any_group (_tmp5_, _tmp6_, _tmp7_)) {
		DVBLoggingLogger* _tmp8_;
		_tmp8_ = dvb_device_group_log;
		dvb_logging_logger_debug (_tmp8_, "Device with adapter %u, frontend %u is" "already part of a group", adapter, frontend);
		result = FALSE;
		_g_object_unref0 (device);
		_g_object_unref0 (manager);
		return result;
	}
	_tmp9_ = dvb_device_group_log;
	_tmp10_ = self->priv->_Id;
	dvb_logging_logger_debug (_tmp9_, "DeviceGroup.vala:218: Adding device with adapter %u, frontend %u to gr" \
"oup %u", adapter, frontend, _tmp10_);
	_tmp11_ = device;
	if (dvb_device_group_add (self, _tmp11_)) {
		{
			DVBFactory* _tmp12_;
			DVBFactory* _tmp13_;
			DVBdatabaseConfigStore* _tmp14_;
			DVBdatabaseConfigStore* _tmp15_;
			DVBDevice* _tmp16_;
			_tmp12_ = dvb_factory_new ();
			_tmp13_ = _tmp12_;
			_tmp14_ = dvb_factory_get_config_store (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = device;
			dvb_database_config_store_add_device_to_group (_tmp15_, _tmp16_, self, &_inner_error0_);
			_g_object_unref0 (_tmp15_);
			_g_object_unref0 (_tmp13_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp17_ = FALSE;
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					goto __catch0_dvb_database_sql_error;
				}
				_g_object_unref0 (device);
				_g_object_unref0 (manager);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp17_;
			}
		}
		goto __finally0;
		__catch0_dvb_database_sql_error:
		{
			GError* e = NULL;
			DVBLoggingLogger* _tmp18_;
			GError* _tmp19_;
			const gchar* _tmp20_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp18_ = dvb_device_group_log;
			_tmp19_ = e;
			_tmp20_ = _tmp19_->message;
			dvb_logging_logger_error (_tmp18_, "DeviceGroup.vala:226: %s", _tmp20_);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (device);
			_g_object_unref0 (manager);
			return result;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp21_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (device);
				_g_object_unref0 (manager);
				return _tmp21_;
			} else {
				gboolean _tmp22_ = FALSE;
				_g_object_unref0 (device);
				_g_object_unref0 (manager);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp22_;
			}
		}
		g_signal_emit_by_name ((DVBIDBusDeviceGroup*) self, "device-added", adapter, frontend);
		result = TRUE;
		_g_object_unref0 (device);
		_g_object_unref0 (manager);
		return result;
	}
	result = FALSE;
	_g_object_unref0 (device);
	_g_object_unref0 (manager);
	return result;
}

/**
         * @returns: Object path of the device's recorder
         *
         * Returns the object path to the device's recorder.
         */
static char*
dvb_device_group_real_GetRecorder (DVBIDBusDeviceGroup* base,
                                   GError** error)
{
	DVBDeviceGroup * self;
	guint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = self->priv->_Id;
	_tmp1_ = g_strdup_printf (DVB_CONSTANTS_DBUS_RECORDER_PATH, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}

gboolean
dvb_device_group_register_recorder (DVBDeviceGroup* self)
{
	DVBLoggingLogger* _tmp0_;
	guint _tmp1_;
	DVBRecorder* recorder = NULL;
	DVBRecorder* _tmp2_;
	DVBRecorder* _tmp3_;
	DVBRecorder* _tmp4_;
	gchar* path = NULL;
	guint _tmp5_;
	gchar* _tmp6_;
	GDBusConnection* _tmp7_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = dvb_device_group_log;
	_tmp1_ = self->priv->_Id;
	dvb_logging_logger_debug (_tmp0_, "DeviceGroup.vala:249: Creating new Recorder D-Bus service for group %u", _tmp1_);
	_tmp2_ = dvb_device_group_get_recorder (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	recorder = _tmp4_;
	_tmp5_ = self->priv->_Id;
	_tmp6_ = g_strdup_printf (DVB_CONSTANTS_DBUS_RECORDER_PATH, _tmp5_);
	path = _tmp6_;
	_tmp7_ = main_conn;
	dvb_utils_dbus_register_object (DVB_TYPE_ID_BUS_RECORDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp7_, path, (DVBIDBusRecorder*) recorder);
	result = TRUE;
	_g_free0 (path);
	_g_object_unref0 (recorder);
	return result;
}

/**
         * @adapter: Number of the device's adapter
         * @frontend: Number of the device's frontend
         * @returns: TRUE when device has been removed successfully
         *
         * Removes the device from the group. If the group contains
         * no devices after the removal it's removed as well.
         */
static gboolean
dvb_device_group_real_RemoveDevice (DVBIDBusDeviceGroup* base,
                                    guint adapter,
                                    guint frontend,
                                    GError** error)
{
	DVBDeviceGroup * self;
	DVBManager* m = NULL;
	DVBManager* _tmp0_;
	DVBManager* _tmp1_;
	DVBDevice* dev = NULL;
	DVBManager* _tmp2_;
	DVBDevice* _tmp3_;
	DVBDevice* _tmp4_;
	DVBDevice* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = dvb_manager_get_instance ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	m = _tmp1_;
	_tmp2_ = m;
	_tmp3_ = dvb_manager_get_device (_tmp2_, adapter, frontend);
	dev = _tmp3_;
	_tmp4_ = dev;
	if (_tmp4_ == NULL) {
		result = FALSE;
		_g_object_unref0 (dev);
		_g_object_unref0 (m);
		return result;
	}
	_tmp5_ = dev;
	if (dvb_device_group_contains (self, _tmp5_)) {
		DVBDevice* _tmp6_;
		_tmp6_ = dev;
		if (dvb_device_group_remove (self, _tmp6_)) {
			gint _tmp18_;
			gint _tmp19_;
			dvb_device_group_stop_epg_scanner (self);
			{
				DVBFactory* _tmp7_;
				DVBFactory* _tmp8_;
				DVBdatabaseConfigStore* _tmp9_;
				DVBdatabaseConfigStore* _tmp10_;
				DVBDevice* _tmp11_;
				_tmp7_ = dvb_factory_new ();
				_tmp8_ = _tmp7_;
				_tmp9_ = dvb_factory_get_config_store (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = dev;
				dvb_database_config_store_remove_device_from_group (_tmp10_, _tmp11_, self, &_inner_error0_);
				_g_object_unref0 (_tmp10_);
				_g_object_unref0 (_tmp8_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					gboolean _tmp12_ = FALSE;
					if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
						goto __catch0_dvb_database_sql_error;
					}
					_g_object_unref0 (dev);
					_g_object_unref0 (m);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp12_;
				}
			}
			goto __finally0;
			__catch0_dvb_database_sql_error:
			{
				GError* e = NULL;
				DVBLoggingLogger* _tmp13_;
				GError* _tmp14_;
				const gchar* _tmp15_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp13_ = dvb_device_group_log;
				_tmp14_ = e;
				_tmp15_ = _tmp14_->message;
				dvb_logging_logger_error (_tmp13_, "DeviceGroup.vala:286: %s", _tmp15_);
				result = FALSE;
				_g_error_free0 (e);
				_g_object_unref0 (dev);
				_g_object_unref0 (m);
				return result;
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_DBUS_ERROR) {
					gboolean _tmp16_ = FALSE;
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (dev);
					_g_object_unref0 (m);
					return _tmp16_;
				} else {
					gboolean _tmp17_ = FALSE;
					_g_object_unref0 (dev);
					_g_object_unref0 (m);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp17_;
				}
			}
			_tmp18_ = dvb_device_group_get_size (self);
			_tmp19_ = _tmp18_;
			if (_tmp19_ > 0) {
				dvb_device_group_start_epg_scanner (self);
			}
			g_signal_emit_by_name ((DVBIDBusDeviceGroup*) self, "device-removed", adapter, frontend);
			result = TRUE;
			_g_object_unref0 (dev);
			_g_object_unref0 (m);
			return result;
		}
	}
	result = FALSE;
	_g_object_unref0 (dev);
	_g_object_unref0 (m);
	return result;
}

/**
         * @returns: Name of the device group
         */
static gchar*
dvb_device_group_real_GetName (DVBIDBusDeviceGroup* base,
                               GError** error)
{
	DVBDeviceGroup * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = self->priv->_Name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
         * @name: Name of the group
         * @returns: TRUE on success
         */
static gboolean
dvb_device_group_real_SetName (DVBIDBusDeviceGroup* base,
                               const gchar* name,
                               GError** error)
{
	DVBDeviceGroup * self;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBDeviceGroup*) base;
	g_return_val_if_fail (name != NULL, FALSE);
	dvb_device_group_set_Name (self, name);
	{
		DVBdatabaseConfigStore* config = NULL;
		DVBFactory* _tmp0_;
		DVBFactory* _tmp1_;
		DVBdatabaseConfigStore* _tmp2_;
		DVBdatabaseConfigStore* _tmp3_;
		DVBdatabaseConfigStore* _tmp4_;
		_tmp0_ = dvb_factory_new ();
		_tmp1_ = _tmp0_;
		_tmp2_ = dvb_factory_get_config_store (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		config = _tmp3_;
		_tmp4_ = config;
		dvb_database_config_store_update_from_group (_tmp4_, self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp5_ = FALSE;
			_g_object_unref0 (config);
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp5_;
		}
		_g_object_unref0 (config);
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = dvb_device_group_log;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		dvb_logging_logger_error (_tmp6_, "DeviceGroup.vala:321: %s", _tmp8_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			gboolean _tmp9_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			return _tmp9_;
		} else {
			gboolean _tmp10_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp10_;
		}
	}
	result = TRUE;
	return result;
}

/**
         * @returns: Object path to the ChannelList service for this device
         */
static char*
dvb_device_group_real_GetChannelList (DVBIDBusDeviceGroup* base,
                                      GError** error)
{
	DVBDeviceGroup * self;
	guint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = self->priv->_Id;
	_tmp1_ = g_strdup_printf (DVB_CONSTANTS_DBUS_CHANNEL_LIST_PATH, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}

gboolean
dvb_device_group_register_channel_list (DVBDeviceGroup* self)
{
	DVBLoggingLogger* _tmp0_;
	guint _tmp1_;
	DVBChannelList* channels = NULL;
	DVBChannelList* _tmp2_;
	DVBChannelList* _tmp3_;
	gchar* path = NULL;
	guint _tmp4_;
	gchar* _tmp5_;
	GDBusConnection* _tmp6_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = dvb_device_group_log;
	_tmp1_ = self->priv->_Id;
	dvb_logging_logger_debug (_tmp0_, "DeviceGroup.vala:336: Creating new ChannelList D-Bus service for group" \
" %u", _tmp1_);
	_tmp2_ = self->priv->_Channels;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	channels = _tmp3_;
	_tmp4_ = self->priv->_Id;
	_tmp5_ = g_strdup_printf (DVB_CONSTANTS_DBUS_CHANNEL_LIST_PATH, _tmp4_);
	path = _tmp5_;
	_tmp6_ = main_conn;
	dvb_utils_dbus_register_object (DVB_TYPE_ID_BUS_CHANNEL_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp6_, path, (DVBIDBusChannelList*) channels);
	result = TRUE;
	_g_free0 (path);
	_g_object_unref0 (channels);
	return result;
}

/**
         * @returns: List of paths to the devices that are part of
         * the group (e.g. /dev/dvb/adapter0/frontend0)
         */
static gchar**
dvb_device_group_real_GetMembers (DVBIDBusDeviceGroup* base,
                                  gint* result_length1,
                                  GError** error)
{
	DVBDeviceGroup * self;
	gchar** groupdevs = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar** _tmp2_;
	gint groupdevs_length1;
	gint _groupdevs_size_;
	gint i = 0;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = dvb_device_group_get_size (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_new0 (gchar*, _tmp1_ + 1);
	groupdevs = _tmp2_;
	groupdevs_length1 = _tmp1_;
	_groupdevs_size_ = groupdevs_length1;
	i = 0;
	{
		GeeSet* _tmp3_;
		_tmp3_ = self->priv->devices;
		g_rec_mutex_lock (&self->priv->__lock_devices);
		{
			{
				GeeIterator* _dev_it = NULL;
				GeeSet* _tmp4_;
				GeeIterator* _tmp5_;
				_tmp4_ = self->priv->devices;
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
				_dev_it = _tmp5_;
				while (TRUE) {
					GeeIterator* _tmp6_;
					DVBDevice* dev = NULL;
					GeeIterator* _tmp7_;
					gpointer _tmp8_;
					gchar** _tmp9_;
					gint _tmp9__length1;
					DVBDevice* _tmp10_;
					guint _tmp11_;
					guint _tmp12_;
					DVBDevice* _tmp13_;
					guint _tmp14_;
					guint _tmp15_;
					gchar* _tmp16_;
					gint _tmp17_;
					_tmp6_ = _dev_it;
					if (!gee_iterator_next (_tmp6_)) {
						break;
					}
					_tmp7_ = _dev_it;
					_tmp8_ = gee_iterator_get (_tmp7_);
					dev = (DVBDevice*) _tmp8_;
					_tmp9_ = groupdevs;
					_tmp9__length1 = groupdevs_length1;
					_tmp10_ = dev;
					_tmp11_ = dvb_device_get_Adapter (_tmp10_);
					_tmp12_ = _tmp11_;
					_tmp13_ = dev;
					_tmp14_ = dvb_device_get_Frontend (_tmp13_);
					_tmp15_ = _tmp14_;
					_tmp16_ = g_strdup_printf (DVB_CONSTANTS_DVB_DEVICE_PATH, _tmp12_, _tmp15_);
					_g_free0 (_tmp9_[i]);
					_tmp9_[i] = _tmp16_;
					_tmp17_ = i;
					i = _tmp17_ + 1;
					_g_object_unref0 (dev);
				}
				_g_object_unref0 (_dev_it);
			}
		}
		__finally0:
		{
			GeeSet* _tmp18_;
			_tmp18_ = self->priv->devices;
			g_rec_mutex_unlock (&self->priv->__lock_devices);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				g_propagate_error (error, _inner_error0_);
				groupdevs = (_vala_array_free (groupdevs, groupdevs_length1, (GDestroyNotify) g_free), NULL);
				return NULL;
			} else {
				groupdevs = (_vala_array_free (groupdevs, groupdevs_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp19_ = groupdevs;
	_tmp19__length1 = groupdevs_length1;
	if (result_length1) {
		*result_length1 = _tmp19__length1;
	}
	result = _tmp19_;
	return result;
}

/**
         * @channel_sid: ID of the channel
         * @opath: Device group's DBus path
         * @returns: TRUE on success
         */
static gboolean
dvb_device_group_real_GetSchedule (DVBIDBusDeviceGroup* base,
                                   guint channel_sid,
                                   char** opath,
                                   GError** error)
{
	DVBDeviceGroup * self;
	char* _vala_opath = NULL;
	DVBChannelList* _tmp0_;
	char* _tmp19_;
	gboolean result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = self->priv->_Channels;
	if (dvb_channel_list_contains (_tmp0_, channel_sid)) {
		gchar* path = NULL;
		guint _tmp1_;
		gchar* _tmp2_;
		GeeHashSet* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp17_;
		char* _tmp18_;
		_tmp1_ = self->priv->_Id;
		_tmp2_ = g_strdup_printf (DVB_CONSTANTS_DBUS_SCHEDULE_PATH, _tmp1_, channel_sid);
		path = _tmp2_;
		_tmp3_ = self->priv->schedules;
		_tmp4_ = path;
		if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, _tmp4_)) {
			DVBSchedule* schedule = NULL;
			DVBChannelList* _tmp5_;
			DVBChannel* _tmp6_;
			DVBChannel* _tmp7_;
			DVBSchedule* _tmp8_;
			DVBSchedule* _tmp9_;
			DVBSchedule* _tmp10_;
			DVBSchedule* _tmp11_;
			GDBusConnection* _tmp12_;
			const gchar* _tmp13_;
			DVBSchedule* _tmp14_;
			GeeHashSet* _tmp15_;
			const gchar* _tmp16_;
			_tmp5_ = self->priv->_Channels;
			_tmp6_ = dvb_channel_list_get_channel (_tmp5_, channel_sid);
			_tmp7_ = _tmp6_;
			_tmp8_ = dvb_channel_get_Schedule (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = _g_object_ref0 (_tmp9_);
			_tmp11_ = _tmp10_;
			_g_object_unref0 (_tmp7_);
			schedule = _tmp11_;
			_tmp12_ = main_conn;
			_tmp13_ = path;
			_tmp14_ = schedule;
			dvb_utils_dbus_register_object (DVB_TYPE_ID_BUS_SCHEDULE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp12_, _tmp13_, (DVBIDBusSchedule*) _tmp14_);
			_tmp15_ = self->priv->schedules;
			_tmp16_ = path;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
			_g_object_unref0 (schedule);
		}
		_tmp17_ = path;
		_tmp18_ = g_strdup (_tmp17_);
		_g_free0 (_vala_opath);
		_vala_opath = _tmp18_;
		result = TRUE;
		_g_free0 (path);
		if (opath) {
			*opath = _vala_opath;
		} else {
			_g_free0 (_vala_opath);
		}
		return result;
	}
	_tmp19_ = g_strdup ("");
	_g_free0 (_vala_opath);
	_vala_opath = _tmp19_;
	result = FALSE;
	if (opath) {
		*opath = _vala_opath;
	} else {
		_g_free0 (_vala_opath);
	}
	return result;
}

/**
         * @returns: Location of the recordings directory
         */
static gchar*
dvb_device_group_real_GetRecordingsDirectory (DVBIDBusDeviceGroup* base,
                                              GError** error)
{
	DVBDeviceGroup * self;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = self->priv->_RecordingsDirectory;
	_tmp1_ = g_file_get_path (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
         * @location: Location of the recordings directory
         * @returns: TRUE on success
         */
static gboolean
dvb_device_group_real_SetRecordingsDirectory (DVBIDBusDeviceGroup* base,
                                              const gchar* location,
                                              GError** error)
{
	DVBDeviceGroup * self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBDeviceGroup*) base;
	g_return_val_if_fail (location != NULL, FALSE);
	_tmp0_ = g_file_new_for_path (location);
	_tmp1_ = _tmp0_;
	dvb_device_group_set_RecordingsDirectory (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	{
		DVBdatabaseConfigStore* config = NULL;
		DVBFactory* _tmp2_;
		DVBFactory* _tmp3_;
		DVBdatabaseConfigStore* _tmp4_;
		DVBdatabaseConfigStore* _tmp5_;
		DVBdatabaseConfigStore* _tmp6_;
		_tmp2_ = dvb_factory_new ();
		_tmp3_ = _tmp2_;
		_tmp4_ = dvb_factory_get_config_store (_tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		config = _tmp5_;
		_tmp6_ = config;
		dvb_database_config_store_update_from_group (_tmp6_, self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp7_ = FALSE;
			_g_object_unref0 (config);
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp7_;
		}
		_g_object_unref0 (config);
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = dvb_device_group_log;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		dvb_logging_logger_error (_tmp8_, "DeviceGroup.vala:410: %s", _tmp10_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == G_DBUS_ERROR) {
			gboolean _tmp11_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			return _tmp11_;
		} else {
			gboolean _tmp12_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp12_;
		}
	}
	result = TRUE;
	return result;
}

static GeeIterator*
dvb_device_group_real_iterator (GeeIterable* base)
{
	DVBDeviceGroup * self;
	GeeSet* _tmp0_;
	GeeIterator* _tmp1_;
	GeeIterator* result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = self->priv->devices;
	_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
	result = _tmp1_;
	return result;
}

static gboolean
dvb_device_group_real_foreach (GeeTraversable* base,
                               GeeForallFunc f,
                               gpointer f_target)
{
	DVBDeviceGroup * self;
	GeeSet* _tmp0_;
	GeeIterator* _tmp1_;
	GeeIterator* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
	self = (DVBDeviceGroup*) base;
	_tmp0_ = self->priv->devices;
	_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_traversable_foreach ((GeeTraversable*) _tmp2_, f, f_target);
	_g_object_unref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

gint
dvb_device_group_get_size (DVBDeviceGroup* self)
{
	gint result;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->devices;
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

GeeSet*
dvb_device_group_get_Devices (DVBDeviceGroup* self)
{
	GeeSet* result;
	GeeSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->devices;
	result = _tmp0_;
	return result;
}

guint
dvb_device_group_get_Id (DVBDeviceGroup* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_Id;
	return result;
}

static void
dvb_device_group_set_Id (DVBDeviceGroup* self,
                         guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_group_get_Id (self);
	if (old_value != value) {
		self->priv->_Id = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_group_properties[DVB_DEVICE_GROUP_ID_PROPERTY]);
	}
}

DVBChannelList*
dvb_device_group_get_Channels (DVBDeviceGroup* self)
{
	DVBChannelList* result;
	DVBChannelList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Channels;
	result = _tmp0_;
	return result;
}

static void
dvb_device_group_set_Channels (DVBDeviceGroup* self,
                               DVBChannelList* value)
{
	DVBChannelList* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_group_get_Channels (self);
	if (old_value != value) {
		DVBChannelList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_Channels);
		self->priv->_Channels = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_group_properties[DVB_DEVICE_GROUP_CHANNELS_PROPERTY]);
	}
}

GFile*
dvb_device_group_get_RecordingsDirectory (DVBDeviceGroup* self)
{
	GFile* result;
	GFile* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_RecordingsDirectory;
	result = _tmp0_;
	return result;
}

void
dvb_device_group_set_RecordingsDirectory (DVBDeviceGroup* self,
                                          GFile* value)
{
	GFile* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_group_get_RecordingsDirectory (self);
	if (old_value != value) {
		GFile* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_RecordingsDirectory);
		self->priv->_RecordingsDirectory = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_group_properties[DVB_DEVICE_GROUP_RECORDINGS_DIRECTORY_PROPERTY]);
	}
}

DVBAdapterType
dvb_device_group_get_Type (DVBDeviceGroup* self)
{
	DVBAdapterType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_Type;
	return result;
}

static void
dvb_device_group_set_Type (DVBDeviceGroup* self,
                           DVBAdapterType value)
{
	DVBAdapterType old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_group_get_Type (self);
	if (old_value != value) {
		self->priv->_Type = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_group_properties[DVB_DEVICE_GROUP_TYPE_PROPERTY]);
	}
}

DVBRecorder*
dvb_device_group_get_recorder (DVBDeviceGroup* self)
{
	DVBRecorder* result;
	DVBRecorder* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_recorder;
	result = _tmp0_;
	return result;
}

DVBEPGScanner*
dvb_device_group_get_epgscanner (DVBDeviceGroup* self)
{
	DVBEPGScanner* result;
	DVBEPGScanner* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_epgscanner;
	result = _tmp0_;
	return result;
}

DVBChannelFactory*
dvb_device_group_get_channel_factory (DVBDeviceGroup* self)
{
	DVBChannelFactory* result;
	DVBChannelFactory* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_channelfactory;
	result = _tmp0_;
	return result;
}

const gchar*
dvb_device_group_get_Name (DVBDeviceGroup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Name;
	result = _tmp0_;
	return result;
}

void
dvb_device_group_set_Name (DVBDeviceGroup* self,
                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_device_group_get_Name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_Name);
		self->priv->_Name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_group_properties[DVB_DEVICE_GROUP_NAME_PROPERTY]);
	}
}

static GType
dvb_device_group_real_get_element_type (GeeTraversable* base)
{
	GType result;
	DVBDeviceGroup* self;
	self = (DVBDeviceGroup*) base;
	result = DVB_TYPE_DEVICE;
	return result;
}

static guint
_dvb_device_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self)
{
	guint result;
	result = dvb_device_hash ((DVBDevice*) v);
	return result;
}

static gboolean
_dvb_device_equal_gee_equal_data_func (gconstpointer a,
                                       gconstpointer b,
                                       gpointer self)
{
	gboolean result;
	result = dvb_device_equal ((DVBDevice*) a, (DVBDevice*) b);
	return result;
}

static GObject *
dvb_device_group_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DVBDeviceGroup * self;
	GeeHashSet* _tmp0_;
	gpointer _tmp1_ = NULL;
	GDestroyNotify _tmp2_ = NULL;
	GeeHashDataFunc _tmp3_;
	gpointer _tmp4_ = NULL;
	GDestroyNotify _tmp5_ = NULL;
	GeeEqualDataFunc _tmp6_;
	GeeHashSet* _tmp7_;
	DVBChannelFactory* _tmp8_;
	DVBRecorder* _tmp9_;
	parent_class = G_OBJECT_CLASS (dvb_device_group_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup);
	_tmp0_ = gee_hash_set_new (DVB_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _dvb_device_hash_gee_hash_data_func, NULL, NULL, _dvb_device_equal_gee_equal_data_func, NULL, NULL);
	_g_object_unref0 (self->priv->devices);
	self->priv->devices = (GeeSet*) _tmp0_;
	_tmp3_ = gee_functions_get_hash_func_for (G_TYPE_STRING, &_tmp1_, &_tmp2_);
	_tmp6_ = gee_functions_get_equal_func_for (G_TYPE_STRING, &_tmp4_, &_tmp5_);
	_tmp7_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp3_, _tmp1_, _tmp2_, _tmp6_, _tmp4_, _tmp5_);
	_g_object_unref0 (self->priv->schedules);
	self->priv->schedules = _tmp7_;
	_tmp8_ = dvb_channel_factory_new (self);
	_g_object_unref0 (self->priv->_channelfactory);
	self->priv->_channelfactory = _tmp8_;
	_tmp9_ = dvb_recorder_new (self);
	_g_object_unref0 (self->priv->_recorder);
	self->priv->_recorder = _tmp9_;
	return obj;
}

static void
dvb_device_group_class_init (DVBDeviceGroupClass * klass,
                             gpointer klass_data)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_device_group_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBDeviceGroup_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_device_group_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_device_group_set_property;
	G_OBJECT_CLASS (klass)->constructor = dvb_device_group_constructor;
	G_OBJECT_CLASS (klass)->finalize = dvb_device_group_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_SIZE_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_DEVICES_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_DEVICES_PROPERTY] = g_param_spec_object ("Devices", "Devices", "Devices", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_ID_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_ID_PROPERTY] = g_param_spec_uint ("Id", "Id", "Id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_CHANNELS_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_CHANNELS_PROPERTY] = g_param_spec_object ("Channels", "Channels", "Channels", DVB_TYPE_CHANNEL_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_RECORDINGS_DIRECTORY_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_RECORDINGS_DIRECTORY_PROPERTY] = g_param_spec_object ("RecordingsDirectory", "RecordingsDirectory", "RecordingsDirectory", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_TYPE_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_TYPE_PROPERTY] = g_param_spec_enum ("Type", "Type", "Type", DVB_TYPE_ADAPTER_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_RECORDER_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_RECORDER_PROPERTY] = g_param_spec_object ("recorder", "recorder", "recorder", DVB_TYPE_RECORDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_EPGSCANNER_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_EPGSCANNER_PROPERTY] = g_param_spec_object ("epgscanner", "epgscanner", "epgscanner", DVB_TYPE_EPG_SCANNER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_CHANNEL_FACTORY_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_CHANNEL_FACTORY_PROPERTY] = g_param_spec_object ("channel-factory", "channel-factory", "channel-factory", DVB_TYPE_CHANNEL_FACTORY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_NAME_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_NAME_PROPERTY] = g_param_spec_string ("Name", "Name", "Name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_GROUP_ELEMENT_TYPE_PROPERTY, dvb_device_group_properties[DVB_DEVICE_GROUP_ELEMENT_TYPE_PROPERTY] = g_param_spec_gtype ("element-type", "element-type", "element-type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_device_group_log = _tmp1_;
}

static void
dvb_device_group_dvb_id_bus_device_group_interface_init (DVBIDBusDeviceGroupIface * iface,
                                                         gpointer iface_data)
{
	dvb_device_group_dvb_id_bus_device_group_parent_iface = g_type_interface_peek_parent (iface);
	iface->GetType = (DVBAdapterType (*) (DVBIDBusDeviceGroup*, GError**)) dvb_device_group_real_GetType;
	iface->AddDevice = (gboolean (*) (DVBIDBusDeviceGroup*, guint, guint, GError**)) dvb_device_group_real_AddDevice;
	iface->GetRecorder = (char* (*) (DVBIDBusDeviceGroup*, GError**)) dvb_device_group_real_GetRecorder;
	iface->RemoveDevice = (gboolean (*) (DVBIDBusDeviceGroup*, guint, guint, GError**)) dvb_device_group_real_RemoveDevice;
	iface->GetName = (gchar* (*) (DVBIDBusDeviceGroup*, GError**)) dvb_device_group_real_GetName;
	iface->SetName = (gboolean (*) (DVBIDBusDeviceGroup*, const gchar*, GError**)) dvb_device_group_real_SetName;
	iface->GetChannelList = (char* (*) (DVBIDBusDeviceGroup*, GError**)) dvb_device_group_real_GetChannelList;
	iface->GetMembers = (gchar** (*) (DVBIDBusDeviceGroup*, gint*, GError**)) dvb_device_group_real_GetMembers;
	iface->GetSchedule = (gboolean (*) (DVBIDBusDeviceGroup*, guint, char**, GError**)) dvb_device_group_real_GetSchedule;
	iface->GetRecordingsDirectory = (gchar* (*) (DVBIDBusDeviceGroup*, GError**)) dvb_device_group_real_GetRecordingsDirectory;
	iface->SetRecordingsDirectory = (gboolean (*) (DVBIDBusDeviceGroup*, const gchar*, GError**)) dvb_device_group_real_SetRecordingsDirectory;
}

static GType
dvb_device_group_gee_traversable_get_g_type (DVBDeviceGroup* self)
{
	return (GType) DVB_TYPE_DEVICE;
}

static GBoxedCopyFunc
dvb_device_group_gee_traversable_get_g_dup_func (DVBDeviceGroup* self)
{
	return (GBoxedCopyFunc) g_object_ref;
}

static GDestroyNotify
dvb_device_group_gee_traversable_get_g_destroy_func (DVBDeviceGroup* self)
{
	return (GDestroyNotify) g_object_unref;
}

static void
dvb_device_group_gee_traversable_interface_init (GeeTraversableIface * iface,
                                                 gpointer iface_data)
{
	dvb_device_group_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) dvb_device_group_real_foreach;
	iface->get_g_type = (GType (*) (GeeTraversable *)) dvb_device_group_gee_traversable_get_g_type;
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) dvb_device_group_gee_traversable_get_g_dup_func;
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) dvb_device_group_gee_traversable_get_g_destroy_func;
	iface->get_element_type = dvb_device_group_real_get_element_type;
}

static GType
dvb_device_group_gee_iterable_get_g_type (DVBDeviceGroup* self)
{
	return (GType) DVB_TYPE_DEVICE;
}

static GBoxedCopyFunc
dvb_device_group_gee_iterable_get_g_dup_func (DVBDeviceGroup* self)
{
	return (GBoxedCopyFunc) g_object_ref;
}

static GDestroyNotify
dvb_device_group_gee_iterable_get_g_destroy_func (DVBDeviceGroup* self)
{
	return (GDestroyNotify) g_object_unref;
}

static void
dvb_device_group_gee_iterable_interface_init (GeeIterableIface * iface,
                                              gpointer iface_data)
{
	dvb_device_group_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
	iface->iterator = (GeeIterator* (*) (GeeIterable*)) dvb_device_group_real_iterator;
	iface->get_g_type = (GType (*) (GeeIterable *)) dvb_device_group_gee_iterable_get_g_type;
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeIterable *)) dvb_device_group_gee_iterable_get_g_dup_func;
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeIterable *)) dvb_device_group_gee_iterable_get_g_destroy_func;
}

static void
dvb_device_group_instance_init (DVBDeviceGroup * self,
                                gpointer klass)
{
	self->priv = dvb_device_group_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_devices);
}

static void
dvb_device_group_finalize (GObject * obj)
{
	DVBDeviceGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup);
	_g_object_unref0 (self->priv->_Channels);
	_g_object_unref0 (self->priv->_RecordingsDirectory);
	_g_free0 (self->priv->_Name);
	g_rec_mutex_clear (&self->priv->__lock_devices);
	_g_object_unref0 (self->priv->devices);
	_g_object_unref0 (self->priv->_recorder);
	_g_object_unref0 (self->priv->_epgscanner);
	_g_object_unref0 (self->priv->_channelfactory);
	_g_object_unref0 (self->priv->schedules);
	G_OBJECT_CLASS (dvb_device_group_parent_class)->finalize (obj);
}

/**
     * A group of devices that share the same settings
     * (list of channels, recordings dir)
     */
static GType
dvb_device_group_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBDeviceGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_device_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBDeviceGroup), 0, (GInstanceInitFunc) dvb_device_group_instance_init, NULL };
	static const GInterfaceInfo dvb_id_bus_device_group_info = { (GInterfaceInitFunc) dvb_device_group_dvb_id_bus_device_group_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) dvb_device_group_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) dvb_device_group_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dvb_device_group_type_id;
	dvb_device_group_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBDeviceGroup", &g_define_type_info, 0);
	g_type_add_interface_static (dvb_device_group_type_id, DVB_TYPE_ID_BUS_DEVICE_GROUP, &dvb_id_bus_device_group_info);
	g_type_add_interface_static (dvb_device_group_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
	g_type_add_interface_static (dvb_device_group_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
	DVBDeviceGroup_private_offset = g_type_add_instance_private (dvb_device_group_type_id, sizeof (DVBDeviceGroupPrivate));
	return dvb_device_group_type_id;
}

GType
dvb_device_group_get_type (void)
{
	static volatile gsize dvb_device_group_type_id__once = 0;
	if (g_once_init_enter (&dvb_device_group_type_id__once)) {
		GType dvb_device_group_type_id;
		dvb_device_group_type_id = dvb_device_group_get_type_once ();
		g_once_init_leave (&dvb_device_group_type_id__once, dvb_device_group_type_id);
	}
	return dvb_device_group_type_id__once;
}

static void
_vala_dvb_device_group_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	DVBDeviceGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup);
	switch (property_id) {
		case DVB_DEVICE_GROUP_SIZE_PROPERTY:
		g_value_set_int (value, dvb_device_group_get_size (self));
		break;
		case DVB_DEVICE_GROUP_DEVICES_PROPERTY:
		g_value_set_object (value, dvb_device_group_get_Devices (self));
		break;
		case DVB_DEVICE_GROUP_ID_PROPERTY:
		g_value_set_uint (value, dvb_device_group_get_Id (self));
		break;
		case DVB_DEVICE_GROUP_CHANNELS_PROPERTY:
		g_value_set_object (value, dvb_device_group_get_Channels (self));
		break;
		case DVB_DEVICE_GROUP_RECORDINGS_DIRECTORY_PROPERTY:
		g_value_set_object (value, dvb_device_group_get_RecordingsDirectory (self));
		break;
		case DVB_DEVICE_GROUP_TYPE_PROPERTY:
		g_value_set_enum (value, dvb_device_group_get_Type (self));
		break;
		case DVB_DEVICE_GROUP_RECORDER_PROPERTY:
		g_value_set_object (value, dvb_device_group_get_recorder (self));
		break;
		case DVB_DEVICE_GROUP_EPGSCANNER_PROPERTY:
		g_value_set_object (value, dvb_device_group_get_epgscanner (self));
		break;
		case DVB_DEVICE_GROUP_CHANNEL_FACTORY_PROPERTY:
		g_value_set_object (value, dvb_device_group_get_channel_factory (self));
		break;
		case DVB_DEVICE_GROUP_NAME_PROPERTY:
		g_value_set_string (value, dvb_device_group_get_Name (self));
		break;
		case DVB_DEVICE_GROUP_ELEMENT_TYPE_PROPERTY:
		g_value_set_gtype (value, gee_traversable_get_element_type ((GeeTraversable*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_device_group_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	DVBDeviceGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup);
	switch (property_id) {
		case DVB_DEVICE_GROUP_ID_PROPERTY:
		dvb_device_group_set_Id (self, g_value_get_uint (value));
		break;
		case DVB_DEVICE_GROUP_CHANNELS_PROPERTY:
		dvb_device_group_set_Channels (self, g_value_get_object (value));
		break;
		case DVB_DEVICE_GROUP_RECORDINGS_DIRECTORY_PROPERTY:
		dvb_device_group_set_RecordingsDirectory (self, g_value_get_object (value));
		break;
		case DVB_DEVICE_GROUP_TYPE_PROPERTY:
		dvb_device_group_set_Type (self, g_value_get_enum (value));
		break;
		case DVB_DEVICE_GROUP_NAME_PROPERTY:
		dvb_device_group_set_Name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

