/* Parameter.c generated by valac 0.56.18, the Vala compiler
 * generated from Parameter.vala, do not modify */

/*
 * Parameter.vala
 *
 * Copyright (C) 2014 Stefan Ringel <linuxtv@stefanringel.de>
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gst/gst.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_PARAMETER (dvb_parameter_get_type ())
#define DVB_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_PARAMETER, DVBParameter))
#define DVB_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_PARAMETER, DVBParameterClass))
#define DVB_IS_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_PARAMETER))
#define DVB_IS_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_PARAMETER))
#define DVB_PARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_PARAMETER, DVBParameterClass))

typedef struct _DVBParameter DVBParameter;
typedef struct _DVBParameterClass DVBParameterClass;
typedef struct _DVBParameterPrivate DVBParameterPrivate;
typedef enum  {
	DVB_DVB_SRC_DELSYS_SYS_UNDEFINED,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B,
	DVB_DVB_SRC_DELSYS_SYS_DVBT,
	DVB_DVB_SRC_DELSYS_SYS_DSS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS2,
	DVB_DVB_SRC_DELSYS_SYS_DVBH,
	DVB_DVB_SRC_DELSYS_SYS_ISDBT,
	DVB_DVB_SRC_DELSYS_SYS_ISDBS,
	DVB_DVB_SRC_DELSYS_SYS_ISDBC,
	DVB_DVB_SRC_DELSYS_SYS_ATSC,
	DVB_DVB_SRC_DELSYS_SYS_ATSCMH,
	DVB_DVB_SRC_DELSYS_SYS_DTMB,
	DVB_DVB_SRC_DELSYS_SYS_CMMB,
	DVB_DVB_SRC_DELSYS_SYS_DAB,
	DVB_DVB_SRC_DELSYS_SYS_DVBT2,
	DVB_DVB_SRC_DELSYS_SYS_TURBO,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C
} DVBDvbSrcDelsys;

#define DVB_TYPE_DVB_SRC_DELSYS (dvb_dvb_src_delsys_get_type ())
enum  {
	DVB_PARAMETER_0_PROPERTY,
	DVB_PARAMETER_DELSYS_PROPERTY,
	DVB_PARAMETER_FREQUENCY_PROPERTY,
	DVB_PARAMETER_NUM_PROPERTIES
};
static GParamSpec* dvb_parameter_properties[DVB_PARAMETER_NUM_PROPERTIES];

struct _DVBParameter {
	GObject parent_instance;
	DVBParameterPrivate * priv;
};

struct _DVBParameterClass {
	GObjectClass parent_class;
	void (*prepare) (DVBParameter* self, GstElement* source);
	gboolean (*add_scanning_data) (DVBParameter* self, GHashTable* data);
	gboolean (*equal) (DVBParameter* self, DVBParameter* param);
	gchar* (*to_string) (DVBParameter* self);
};

struct _DVBParameterPrivate {
	DVBDvbSrcDelsys _Delsys;
	guint _Frequency;
};

static gint DVBParameter_private_offset;
static gpointer dvb_parameter_parent_class = NULL;

VALA_EXTERN GType dvb_parameter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBParameter, g_object_unref)
VALA_EXTERN GType dvb_dvb_src_delsys_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void dvb_parameter_prepare (DVBParameter* self,
                            GstElement* source);
VALA_EXTERN gboolean dvb_parameter_add_scanning_data (DVBParameter* self,
                                          GHashTable* data);
VALA_EXTERN gboolean dvb_parameter_equal (DVBParameter* self,
                              DVBParameter* param);
VALA_EXTERN gchar* dvb_parameter_to_string (DVBParameter* self);
VALA_EXTERN DVBParameter* dvb_parameter_construct (GType object_type,
                                       DVBDvbSrcDelsys delsys);
static void dvb_parameter_real_prepare (DVBParameter* self,
                                 GstElement* source);
static gboolean dvb_parameter_real_add_scanning_data (DVBParameter* self,
                                               GHashTable* data);
static gboolean dvb_parameter_real_equal (DVBParameter* self,
                                   DVBParameter* param);
static gchar* dvb_parameter_real_to_string (DVBParameter* self);
VALA_EXTERN DVBDvbSrcDelsys dvb_parameter_get_Delsys (DVBParameter* self);
static void dvb_parameter_set_Delsys (DVBParameter* self,
                               DVBDvbSrcDelsys value);
VALA_EXTERN guint dvb_parameter_get_Frequency (DVBParameter* self);
VALA_EXTERN void dvb_parameter_set_Frequency (DVBParameter* self,
                                  guint value);
static void dvb_parameter_finalize (GObject * obj);
static GType dvb_parameter_get_type_once (void);
static void _vala_dvb_parameter_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_dvb_parameter_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
dvb_parameter_get_instance_private (DVBParameter* self)
{
	return G_STRUCT_MEMBER_P (self, DVBParameter_private_offset);
}

DVBParameter*
dvb_parameter_construct (GType object_type,
                         DVBDvbSrcDelsys delsys)
{
	DVBParameter * self = NULL;
	self = (DVBParameter*) g_object_new (object_type, "Delsys", delsys, NULL);
	return self;
}

static void
dvb_parameter_real_prepare (DVBParameter* self,
                            GstElement* source)
{
	g_critical ("Type `%s' does not implement abstract method `dvb_parameter_prepare'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
dvb_parameter_prepare (DVBParameter* self,
                       GstElement* source)
{
	DVBParameterClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = DVB_PARAMETER_GET_CLASS (self);
	if (_klass_->prepare) {
		_klass_->prepare (self, source);
	}
}

static gboolean
dvb_parameter_real_add_scanning_data (DVBParameter* self,
                                      GHashTable* data)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `dvb_parameter_add_scanning_data'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
dvb_parameter_add_scanning_data (DVBParameter* self,
                                 GHashTable* data)
{
	DVBParameterClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = DVB_PARAMETER_GET_CLASS (self);
	if (_klass_->add_scanning_data) {
		return _klass_->add_scanning_data (self, data);
	}
	return FALSE;
}

static gboolean
dvb_parameter_real_equal (DVBParameter* self,
                          DVBParameter* param)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `dvb_parameter_equal'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
dvb_parameter_equal (DVBParameter* self,
                     DVBParameter* param)
{
	DVBParameterClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = DVB_PARAMETER_GET_CLASS (self);
	if (_klass_->equal) {
		return _klass_->equal (self, param);
	}
	return FALSE;
}

static gchar*
dvb_parameter_real_to_string (DVBParameter* self)
{
	g_critical ("Type `%s' does not implement abstract method `dvb_parameter_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

gchar*
dvb_parameter_to_string (DVBParameter* self)
{
	DVBParameterClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = DVB_PARAMETER_GET_CLASS (self);
	if (_klass_->to_string) {
		return _klass_->to_string (self);
	}
	return NULL;
}

DVBDvbSrcDelsys
dvb_parameter_get_Delsys (DVBParameter* self)
{
	DVBDvbSrcDelsys result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_Delsys;
	return result;
}

static void
dvb_parameter_set_Delsys (DVBParameter* self,
                          DVBDvbSrcDelsys value)
{
	DVBDvbSrcDelsys old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_parameter_get_Delsys (self);
	if (old_value != value) {
		self->priv->_Delsys = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_parameter_properties[DVB_PARAMETER_DELSYS_PROPERTY]);
	}
}

guint
dvb_parameter_get_Frequency (DVBParameter* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_Frequency;
	return result;
}

void
dvb_parameter_set_Frequency (DVBParameter* self,
                             guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_parameter_get_Frequency (self);
	if (old_value != value) {
		self->priv->_Frequency = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_parameter_properties[DVB_PARAMETER_FREQUENCY_PROPERTY]);
	}
}

static void
dvb_parameter_class_init (DVBParameterClass * klass,
                          gpointer klass_data)
{
	dvb_parameter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBParameter_private_offset);
	((DVBParameterClass *) klass)->prepare = (void (*) (DVBParameter*, GstElement*)) dvb_parameter_real_prepare;
	((DVBParameterClass *) klass)->add_scanning_data = (gboolean (*) (DVBParameter*, GHashTable*)) dvb_parameter_real_add_scanning_data;
	((DVBParameterClass *) klass)->equal = (gboolean (*) (DVBParameter*, DVBParameter*)) dvb_parameter_real_equal;
	((DVBParameterClass *) klass)->to_string = (gchar* (*) (DVBParameter*)) dvb_parameter_real_to_string;
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_parameter_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_parameter_set_property;
	G_OBJECT_CLASS (klass)->finalize = dvb_parameter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_PARAMETER_DELSYS_PROPERTY, dvb_parameter_properties[DVB_PARAMETER_DELSYS_PROPERTY] = g_param_spec_enum ("Delsys", "Delsys", "Delsys", DVB_TYPE_DVB_SRC_DELSYS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_PARAMETER_FREQUENCY_PROPERTY, dvb_parameter_properties[DVB_PARAMETER_FREQUENCY_PROPERTY] = g_param_spec_uint ("Frequency", "Frequency", "Frequency", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
dvb_parameter_instance_init (DVBParameter * self,
                             gpointer klass)
{
	self->priv = dvb_parameter_get_instance_private (self);
}

static void
dvb_parameter_finalize (GObject * obj)
{
	DVBParameter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_PARAMETER, DVBParameter);
	G_OBJECT_CLASS (dvb_parameter_parent_class)->finalize (obj);
}

static GType
dvb_parameter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBParameterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_parameter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBParameter), 0, (GInstanceInitFunc) dvb_parameter_instance_init, NULL };
	GType dvb_parameter_type_id;
	dvb_parameter_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBParameter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	DVBParameter_private_offset = g_type_add_instance_private (dvb_parameter_type_id, sizeof (DVBParameterPrivate));
	return dvb_parameter_type_id;
}

GType
dvb_parameter_get_type (void)
{
	static volatile gsize dvb_parameter_type_id__once = 0;
	if (g_once_init_enter (&dvb_parameter_type_id__once)) {
		GType dvb_parameter_type_id;
		dvb_parameter_type_id = dvb_parameter_get_type_once ();
		g_once_init_leave (&dvb_parameter_type_id__once, dvb_parameter_type_id);
	}
	return dvb_parameter_type_id__once;
}

static void
_vala_dvb_parameter_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	DVBParameter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_PARAMETER, DVBParameter);
	switch (property_id) {
		case DVB_PARAMETER_DELSYS_PROPERTY:
		g_value_set_enum (value, dvb_parameter_get_Delsys (self));
		break;
		case DVB_PARAMETER_FREQUENCY_PROPERTY:
		g_value_set_uint (value, dvb_parameter_get_Frequency (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_parameter_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	DVBParameter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_PARAMETER, DVBParameter);
	switch (property_id) {
		case DVB_PARAMETER_DELSYS_PROPERTY:
		dvb_parameter_set_Delsys (self, g_value_get_enum (value));
		break;
		case DVB_PARAMETER_FREQUENCY_PROPERTY:
		dvb_parameter_set_Frequency (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

