/* Schedule.c generated by valac 0.56.18, the Vala compiler
 * generated from Schedule.vala, do not modify */

/*
 * Copyright (C) 2008-2011 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#define _DEFAULT_SOURCE
#define _XOPEN_SOURCE

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <time.h>

#define DVB_SCHEDULE_MATCH_THRESHOLD 100
#define DVB_SCHEDULE_MIN_EVENT_OVERLAP 0.5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_TYPE_ID_BUS_SCHEDULE (dvb_id_bus_schedule_get_type ())
#define DVB_ID_BUS_SCHEDULE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_ID_BUS_SCHEDULE, DVBIDBusSchedule))
#define DVB_IS_ID_BUS_SCHEDULE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_ID_BUS_SCHEDULE))
#define DVB_ID_BUS_SCHEDULE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_TYPE_ID_BUS_SCHEDULE, DVBIDBusScheduleIface))

typedef struct _DVBIDBusSchedule DVBIDBusSchedule;
typedef struct _DVBIDBusScheduleIface DVBIDBusScheduleIface;

#define DVB_TYPE_ID_BUS_SCHEDULE_PROXY (dvb_id_bus_schedule_proxy_get_type ())

#define DVB_TYPE_EVENT_INFO (dvb_event_info_get_type ())
typedef struct _DVBEventInfo DVBEventInfo;

#define DVB_TYPE_SCHEDULE (dvb_schedule_get_type ())
#define DVB_SCHEDULE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_SCHEDULE, DVBSchedule))
#define DVB_SCHEDULE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_SCHEDULE, DVBScheduleClass))
#define DVB_IS_SCHEDULE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_SCHEDULE))
#define DVB_IS_SCHEDULE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_SCHEDULE))
#define DVB_SCHEDULE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_SCHEDULE, DVBScheduleClass))

typedef struct _DVBSchedule DVBSchedule;
typedef struct _DVBScheduleClass DVBScheduleClass;
typedef struct _DVBSchedulePrivate DVBSchedulePrivate;

#define DVB_TYPE_CHANNEL (dvb_channel_get_type ())
#define DVB_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL, DVBChannel))
#define DVB_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL, DVBChannelClass))
#define DVB_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL))
#define DVB_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL))
#define DVB_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL, DVBChannelClass))

typedef struct _DVBChannel DVBChannel;
typedef struct _DVBChannelClass DVBChannelClass;

#define DVB_DATABASE_TYPE_EPG_STORE (dvb_database_epg_store_get_type ())
#define DVB_DATABASE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStore))
#define DVB_DATABASE_IS_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_EPG_STORE))
#define DVB_DATABASE_EPG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStoreIface))

typedef struct _DVBdatabaseEPGStore DVBdatabaseEPGStore;
typedef struct _DVBdatabaseEPGStoreIface DVBdatabaseEPGStoreIface;

#define DVB_TYPE_EVENT (dvb_event_get_type ())
#define DVB_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_EVENT, DVBEvent))
#define DVB_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_EVENT, DVBEventClass))
#define DVB_IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_EVENT))
#define DVB_IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_EVENT))
#define DVB_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_EVENT, DVBEventClass))

typedef struct _DVBEvent DVBEvent;
typedef struct _DVBEventClass DVBEventClass;

#define DVB_DATABASE_TYPE_SQL_ERROR (dvb_database_sql_error_get_type ())

#define DVB_TYPE_EVENT_STORAGE (dvb_event_storage_get_type ())
#define DVB_EVENT_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_EVENT_STORAGE, DVBEventStorage))
#define DVB_EVENT_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_EVENT_STORAGE, DVBEventStorageClass))
#define DVB_IS_EVENT_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_EVENT_STORAGE))
#define DVB_IS_EVENT_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_EVENT_STORAGE))
#define DVB_EVENT_STORAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_EVENT_STORAGE, DVBEventStorageClass))

typedef struct _DVBEventStorage DVBEventStorage;
typedef struct _DVBEventStorageClass DVBEventStorageClass;
enum  {
	DVB_SCHEDULE_0_PROPERTY,
	DVB_SCHEDULE_CHANNEL_PROPERTY,
	DVB_SCHEDULE_NUM_PROPERTIES
};
static GParamSpec* dvb_schedule_properties[DVB_SCHEDULE_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _dvb_event_unref0(var) ((var == NULL) ? NULL : (var = (dvb_event_unref (var), NULL)))
typedef struct _DvbScheduleRestoreData DvbScheduleRestoreData;

#define DVB_TYPE_EVENT_ELEMENT (dvb_event_element_get_type ())
#define DVB_EVENT_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_EVENT_ELEMENT, DVBEventElement))
#define DVB_EVENT_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_EVENT_ELEMENT, DVBEventElementClass))
#define DVB_IS_EVENT_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_EVENT_ELEMENT))
#define DVB_IS_EVENT_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_EVENT_ELEMENT))
#define DVB_EVENT_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_EVENT_ELEMENT, DVBEventElementClass))

typedef struct _DVBEventElement DVBEventElement;
typedef struct _DVBEventElementClass DVBEventElementClass;
typedef struct _DVBEventElementPrivate DVBEventElementPrivate;

#define DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE (dvb_database_sqlite_sqlite_database_get_type ())
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase))
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabaseClass))
#define DVB_DATABASE_SQLITE_IS_SQLITE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE))
#define DVB_DATABASE_SQLITE_IS_SQLITE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE))
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabaseClass))

typedef struct _DVBdatabasesqliteSqliteDatabase DVBdatabasesqliteSqliteDatabase;
typedef struct _DVBdatabasesqliteSqliteDatabaseClass DVBdatabasesqliteSqliteDatabaseClass;
typedef struct _DVBEventPrivate DVBEventPrivate;

#define DVB_EVENT_TYPE_AUDIO_COMPONENT (dvb_event_audio_component_get_type ())
#define DVB_EVENT_AUDIO_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_EVENT_TYPE_AUDIO_COMPONENT, DVBEventAudioComponent))
#define DVB_EVENT_AUDIO_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_EVENT_TYPE_AUDIO_COMPONENT, DVBEventAudioComponentClass))
#define DVB_EVENT_IS_AUDIO_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_EVENT_TYPE_AUDIO_COMPONENT))
#define DVB_EVENT_IS_AUDIO_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_EVENT_TYPE_AUDIO_COMPONENT))
#define DVB_EVENT_AUDIO_COMPONENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_EVENT_TYPE_AUDIO_COMPONENT, DVBEventAudioComponentClass))

typedef struct _DVBEventAudioComponent DVBEventAudioComponent;
typedef struct _DVBEventAudioComponentClass DVBEventAudioComponentClass;

#define DVB_EVENT_TYPE_VIDEO_COMPONENT (dvb_event_video_component_get_type ())
#define DVB_EVENT_VIDEO_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_EVENT_TYPE_VIDEO_COMPONENT, DVBEventVideoComponent))
#define DVB_EVENT_VIDEO_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_EVENT_TYPE_VIDEO_COMPONENT, DVBEventVideoComponentClass))
#define DVB_EVENT_IS_VIDEO_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_EVENT_TYPE_VIDEO_COMPONENT))
#define DVB_EVENT_IS_VIDEO_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_EVENT_TYPE_VIDEO_COMPONENT))
#define DVB_EVENT_VIDEO_COMPONENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_EVENT_TYPE_VIDEO_COMPONENT, DVBEventVideoComponentClass))

typedef struct _DVBEventVideoComponent DVBEventVideoComponent;
typedef struct _DVBEventVideoComponentClass DVBEventVideoComponentClass;

#define DVB_EVENT_TYPE_TELETEXT_COMPONENT (dvb_event_teletext_component_get_type ())
#define DVB_EVENT_TELETEXT_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_EVENT_TYPE_TELETEXT_COMPONENT, DVBEventTeletextComponent))
#define DVB_EVENT_TELETEXT_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_EVENT_TYPE_TELETEXT_COMPONENT, DVBEventTeletextComponentClass))
#define DVB_EVENT_IS_TELETEXT_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_EVENT_TYPE_TELETEXT_COMPONENT))
#define DVB_EVENT_IS_TELETEXT_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_EVENT_TYPE_TELETEXT_COMPONENT))
#define DVB_EVENT_TELETEXT_COMPONENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_EVENT_TYPE_TELETEXT_COMPONENT, DVBEventTeletextComponentClass))

typedef struct _DVBEventTeletextComponent DVBEventTeletextComponent;
typedef struct _DVBEventTeletextComponentClass DVBEventTeletextComponentClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define DVB_TYPE_FACTORY (dvb_factory_get_type ())
#define DVB_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_FACTORY, DVBFactory))
#define DVB_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_FACTORY, DVBFactoryClass))
#define DVB_IS_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_FACTORY))
#define DVB_IS_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_FACTORY))
#define DVB_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_FACTORY, DVBFactoryClass))

typedef struct _DVBFactory DVBFactory;
typedef struct _DVBFactoryClass DVBFactoryClass;

struct _DVBEventInfo {
	guint32 id;
	guint32 next;
	gchar* name;
	guint duration;
	gchar* short_description;
};

struct _DVBIDBusScheduleIface {
	GTypeInterface parent_iface;
	guint32* (*GetAllEvents) (DVBIDBusSchedule* self, gint* result_length1, GError** error);
	DVBEventInfo* (*GetAllEventInfos) (DVBIDBusSchedule* self, gint* result_length1, GError** error);
	gboolean (*GetInformations) (DVBIDBusSchedule* self, guint32 event_id, DVBEventInfo* event_info, GError** error);
	guint32 (*NowPlaying) (DVBIDBusSchedule* self, GError** error);
	guint32 (*Next) (DVBIDBusSchedule* self, guint32 event_id, GError** error);
	gboolean (*GetName) (DVBIDBusSchedule* self, guint32 event_id, gchar** name, GError** error);
	gboolean (*GetShortDescription) (DVBIDBusSchedule* self, guint32 event_id, gchar** description, GError** error);
	gboolean (*GetExtendedDescription) (DVBIDBusSchedule* self, guint32 event_id, gchar** description, GError** error);
	gboolean (*GetDuration) (DVBIDBusSchedule* self, guint32 event_id, guint* duration, GError** error);
	gboolean (*GetLocalStartTime) (DVBIDBusSchedule* self, guint32 event_id, guint** start_time, gint* start_time_length1, GError** error);
	gboolean (*GetLocalStartTimestamp) (DVBIDBusSchedule* self, guint32 event_id, gint64* timestamp, GError** error);
	gboolean (*IsRunning) (DVBIDBusSchedule* self, guint32 event_id, gboolean* running, GError** error);
	gboolean (*IsScrambled) (DVBIDBusSchedule* self, guint32 event_id, gboolean* scrambled, GError** error);
};

struct _DVBSchedule {
	GObject parent_instance;
	DVBSchedulePrivate * priv;
};

struct _DVBScheduleClass {
	GObjectClass parent_class;
};

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()

struct _DVBdatabaseEPGStoreIface {
	GTypeInterface parent_iface;
	gboolean (*add_or_update_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	DVBEvent* (*get_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_older_than) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	gboolean (*contains_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	GeeList* (*get_events) (DVBdatabaseEPGStore* self, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_of_group) (DVBdatabaseEPGStore* self, guint group_id, GError** error);
};

struct _DVBSchedulePrivate {
	DVBChannel* _channel;
	DVBdatabaseEPGStore* epgstore;
	DVBEventStorage* events;
	GRecMutex __lock_events;
};

struct _DvbScheduleRestoreData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DVBSchedule* self;
	GeeList* levents;
	GeeList* _tmp0_;
	DVBdatabaseEPGStore* _tmp1_;
	DVBChannel* _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	DVBChannel* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	GeeList* _tmp8_;
	GeeList* _tmp9_;
	GError* e1;
	DVBLoggingLogger* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	gint newest_expired;
	DVBEvent* event;
	gint i;
	gboolean _tmp13_;
	gint _tmp14_;
	GeeList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GeeList* _tmp18_;
	gpointer _tmp19_;
	DVBEvent* _tmp20_;
	DVBEventStorage* _tmp21_;
	DVBEvent* _tmp22_;
	GeeList* _tmp23_;
	gpointer _tmp24_;
	DVBdatabaseEPGStore* _tmp25_;
	DVBEvent* _tmp26_;
	DVBChannel* _tmp27_;
	guint _tmp28_;
	guint _tmp29_;
	DVBChannel* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	GError* e2;
	DVBLoggingLogger* _tmp33_;
	GError* _tmp34_;
	const gchar* _tmp35_;
	DVBLoggingLogger* _tmp36_;
	DVBEventStorage* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	DVBChannel* _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	GError* _inner_error0_;
};

struct _DVBEventElement {
	GObject parent_instance;
	DVBEventElementPrivate * priv;
	guint id;
	time_t starttime;
};

struct _DVBEventElementClass {
	GObjectClass parent_class;
};

struct _DVBEvent {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DVBEventPrivate * priv;
	guint id;
	guint year;
	guint month;
	guint hour;
	guint day;
	guint minute;
	guint second;
	guint duration;
	guint running_status;
	gboolean free_ca_mode;
	gchar* name;
	gchar* description;
	gchar* extended_description;
	GSList* audio_components;
	DVBEventVideoComponent* video_component;
	GSList* teletext_components;
};

struct _DVBEventClass {
	GTypeClass parent_class;
	void (*finalize) (DVBEvent *self);
};

static gint DVBSchedule_private_offset;
static gpointer dvb_schedule_parent_class = NULL;
static DVBLoggingLogger* dvb_schedule_log;
static DVBLoggingLogger* dvb_schedule_log = NULL;
static GRecMutex dvb_schedule_mutex;
static GRecMutex dvb_schedule_mutex = {0};
static DVBIDBusScheduleIface * dvb_schedule_dvb_id_bus_schedule_parent_iface = NULL;

VALA_EXTERN GType dvb_id_bus_schedule_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint dvb_id_bus_schedule_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN GType dvb_event_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DVBEventInfo* dvb_event_info_dup (const DVBEventInfo* self);
VALA_EXTERN void dvb_event_info_free (DVBEventInfo* self);
VALA_EXTERN void dvb_event_info_copy (const DVBEventInfo* self,
                          DVBEventInfo* dest);
VALA_EXTERN void dvb_event_info_destroy (DVBEventInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (DVBEventInfo, dvb_event_info_destroy)
VALA_EXTERN GType dvb_id_bus_schedule_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBIDBusSchedule, g_object_unref)
VALA_EXTERN GType dvb_schedule_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBSchedule, g_object_unref)
VALA_EXTERN GType dvb_channel_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBChannel, g_object_unref)
VALA_EXTERN gpointer dvb_event_ref (gpointer instance);
VALA_EXTERN void dvb_event_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_param_spec_event (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void dvb_value_set_event (GValue* value,
                          gpointer v_object);
VALA_EXTERN void dvb_value_take_event (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer dvb_value_get_event (const GValue* value);
VALA_EXTERN GType dvb_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEvent, dvb_event_unref)
VALA_EXTERN GQuark dvb_database_sql_error_quark (void);
VALA_EXTERN GType dvb_database_sql_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_database_epg_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseEPGStore, g_object_unref)
VALA_EXTERN GType dvb_event_storage_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEventStorage, g_object_unref)
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
static void dvb_schedule_restore_data_free (gpointer _data);
VALA_EXTERN void dvb_schedule_restore (DVBSchedule* self,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_);
VALA_EXTERN void dvb_schedule_restore_finish (DVBSchedule* self,
                                  GAsyncResult* _res_);
static gboolean dvb_schedule_restore_co (DvbScheduleRestoreData* _data_);
VALA_EXTERN GeeList* dvb_database_epg_store_get_events (DVBdatabaseEPGStore* self,
                                            guint channel_sid,
                                            guint group_id,
                                            GError** error);
VALA_EXTERN DVBChannel* dvb_schedule_get_channel (DVBSchedule* self);
VALA_EXTERN guint dvb_channel_get_Sid (DVBChannel* self);
VALA_EXTERN guint dvb_channel_get_GroupId (DVBChannel* self);
VALA_EXTERN void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN gboolean dvb_event_has_expired (DVBEvent* self);
VALA_EXTERN void dvb_event_storage_insert (DVBEventStorage* self,
                               DVBEvent* event);
VALA_EXTERN gboolean dvb_database_epg_store_remove_events_older_than (DVBdatabaseEPGStore* self,
                                                          DVBEvent* event,
                                                          guint channel_sid,
                                                          guint group_id,
                                                          GError** error);
VALA_EXTERN void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN gint dvb_event_storage_get_size (DVBEventStorage* self);
VALA_EXTERN DVBSchedule* dvb_schedule_new (DVBChannel* channel);
VALA_EXTERN DVBSchedule* dvb_schedule_construct (GType object_type,
                                     DVBChannel* channel);
VALA_EXTERN void dvb_schedule_remove_expired_events (DVBSchedule* self);
VALA_EXTERN GType dvb_event_element_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEventElement, g_object_unref)
VALA_EXTERN DVBEventElement* dvb_event_storage_get (DVBEventStorage* self,
                                        gint index);
VALA_EXTERN DVBEvent* dvb_schedule_get_event (DVBSchedule* self,
                                  guint event_id);
VALA_EXTERN const gchar* dvb_channel_get_Name (DVBChannel* self);
VALA_EXTERN void dvb_event_storage_remove_range (DVBEventStorage* self,
                                     gint start,
                                     gint end);
VALA_EXTERN DVBEvent* dvb_database_epg_store_get_event (DVBdatabaseEPGStore* self,
                                            guint event_id,
                                            guint channel_sid,
                                            guint group_id,
                                            GError** error);
VALA_EXTERN void dvb_schedule_add (DVBSchedule* self,
                       DVBEvent* event);
static void dvb_schedule_store_event (DVBSchedule* self,
                               DVBEvent* event,
                               GError** error);
VALA_EXTERN void dvb_schedule_add_all (DVBSchedule* self,
                           GeeCollection* new_events);
VALA_EXTERN GType dvb_database_sqlite_sqlite_database_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabasesqliteSqliteDatabase, g_object_unref)
VALA_EXTERN void dvb_database_sqlite_sqlite_database_begin_transaction (DVBdatabasesqliteSqliteDatabase* self,
                                                            GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_end_transaction (DVBdatabasesqliteSqliteDatabase* self,
                                                          GError** error);
static GeeList* dvb_schedule_get_overlapping_events (DVBSchedule* self,
                                              DVBEvent* event);
static gint dvb_schedule_match_events (DVBSchedule* self,
                                GeeList* events,
                                DVBEvent* ref_event);
VALA_EXTERN void dvb_event_storage_remove_all (DVBEventStorage* self,
                                   GeeList* events);
VALA_EXTERN gboolean dvb_database_epg_store_remove_event (DVBdatabaseEPGStore* self,
                                              guint event_id,
                                              guint channel_sid,
                                              guint group_id,
                                              GError** error);
VALA_EXTERN gpointer dvb_event_audio_component_ref (gpointer instance);
VALA_EXTERN void dvb_event_audio_component_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_event_param_spec_audio_component (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void dvb_event_value_set_audio_component (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void dvb_event_value_take_audio_component (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer dvb_event_value_get_audio_component (const GValue* value);
VALA_EXTERN GType dvb_event_audio_component_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEventAudioComponent, dvb_event_audio_component_unref)
VALA_EXTERN gpointer dvb_event_video_component_ref (gpointer instance);
VALA_EXTERN void dvb_event_video_component_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_event_param_spec_video_component (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void dvb_event_value_set_video_component (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void dvb_event_value_take_video_component (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer dvb_event_value_get_video_component (const GValue* value);
VALA_EXTERN GType dvb_event_video_component_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEventVideoComponent, dvb_event_video_component_unref)
VALA_EXTERN gpointer dvb_event_teletext_component_ref (gpointer instance);
VALA_EXTERN void dvb_event_teletext_component_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_event_param_spec_teletext_component (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
VALA_EXTERN void dvb_event_value_set_teletext_component (GValue* value,
                                             gpointer v_object);
VALA_EXTERN void dvb_event_value_take_teletext_component (GValue* value,
                                              gpointer v_object);
VALA_EXTERN gpointer dvb_event_value_get_teletext_component (const GValue* value);
VALA_EXTERN GType dvb_event_teletext_component_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEventTeletextComponent, dvb_event_teletext_component_unref)
VALA_EXTERN gboolean dvb_database_epg_store_add_or_update_event (DVBdatabaseEPGStore* self,
                                                     DVBEvent* event,
                                                     guint channel_sid,
                                                     guint group_id,
                                                     GError** error);
VALA_EXTERN gboolean dvb_event_storage_contains_event_with_id (DVBEventStorage* self,
                                                   guint event_id);
VALA_EXTERN GeeList* dvb_event_storage_get_overlapping_events (DVBEventStorage* self,
                                                   DVBEvent* event);
VALA_EXTERN gdouble dvb_event_get_overlap_percentage (DVBEvent* self,
                                          DVBEvent* other);
VALA_EXTERN time_t dvb_event_get_start_timestamp (DVBEvent* self);
VALA_EXTERN time_t dvb_event_get_end_timestamp (DVBEvent* self);
VALA_EXTERN glong dvb_utils_strdiff (const gchar* a,
                         const gchar* b,
                         glong* unmatched);
VALA_EXTERN gboolean dvb_schedule_contains (DVBSchedule* self,
                                guint event_id);
VALA_EXTERN DVBEvent* dvb_schedule_get_running_event (DVBSchedule* self);
VALA_EXTERN gboolean dvb_event_is_running (DVBEvent* self);
VALA_EXTERN DVBEvent* dvb_schedule_get_event_around (DVBSchedule* self,
                                         struct tm* start,
                                         guint duration);
static guint32* dvb_schedule_real_GetAllEvents (DVBIDBusSchedule* base,
                                         gint* result_length1,
                                         GError** error);
static DVBEventInfo* dvb_schedule_real_GetAllEventInfos (DVBIDBusSchedule* base,
                                                  gint* result_length1,
                                                  GError** error);
static void dvb_schedule_event_to_event_info (DVBEvent* event,
                                       DVBEventInfo* result);
static gboolean dvb_schedule_real_GetInformations (DVBIDBusSchedule* base,
                                            guint32 event_id,
                                            DVBEventInfo* event_info,
                                            GError** error);
VALA_EXTERN DVBEventElement* dvb_event_storage_get_by_id (DVBEventStorage* self,
                                              guint event_id);
VALA_EXTERN DVBEventElement* dvb_event_storage_next (DVBEventStorage* self,
                                         DVBEventElement* element);
static guint32 dvb_schedule_real_NowPlaying (DVBIDBusSchedule* base,
                                      GError** error);
static guint32 dvb_schedule_real_Next (DVBIDBusSchedule* base,
                                guint32 event_id,
                                GError** error);
static gboolean dvb_schedule_real_GetName (DVBIDBusSchedule* base,
                                    guint32 event_id,
                                    gchar** name,
                                    GError** error);
static DVBEvent* dvb_schedule_get_extended_event_by_id (DVBSchedule* self,
                                                 guint event_id);
static gboolean dvb_schedule_real_GetShortDescription (DVBIDBusSchedule* base,
                                                guint32 event_id,
                                                gchar** description,
                                                GError** error);
static gboolean dvb_schedule_real_GetExtendedDescription (DVBIDBusSchedule* base,
                                                   guint32 event_id,
                                                   gchar** description,
                                                   GError** error);
static gboolean dvb_schedule_real_GetDuration (DVBIDBusSchedule* base,
                                        guint32 event_id,
                                        guint* duration,
                                        GError** error);
static gboolean dvb_schedule_real_GetLocalStartTime (DVBIDBusSchedule* base,
                                              guint32 event_id,
                                              guint** start_time,
                                              gint* start_time_length1,
                                              GError** error);
VALA_EXTERN void dvb_event_get_local_start_time (DVBEvent* self,
                                     struct tm* result);
static guint* dvb_schedule_to_time_array (struct tm* local_time,
                                   gint* result_length1);
static gboolean dvb_schedule_real_GetLocalStartTimestamp (DVBIDBusSchedule* base,
                                                   guint32 event_id,
                                                   gint64* timestamp,
                                                   GError** error);
static gboolean dvb_schedule_real_IsRunning (DVBIDBusSchedule* base,
                                      guint32 event_id,
                                      gboolean* running,
                                      GError** error);
static gboolean dvb_schedule_real_IsScrambled (DVBIDBusSchedule* base,
                                        guint32 event_id,
                                        gboolean* scrambled,
                                        GError** error);
static void dvb_schedule_set_channel (DVBSchedule* self,
                               DVBChannel* value);
static GObject * dvb_schedule_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
VALA_EXTERN DVBEventStorage* dvb_event_storage_new (void);
VALA_EXTERN DVBEventStorage* dvb_event_storage_construct (GType object_type);
VALA_EXTERN DVBFactory* dvb_factory_new (void);
VALA_EXTERN DVBFactory* dvb_factory_construct (GType object_type);
VALA_EXTERN GType dvb_factory_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBFactory, g_object_unref)
VALA_EXTERN DVBdatabaseEPGStore* dvb_factory_get_epg_store (DVBFactory* self);
VALA_EXTERN guint32* dvb_id_bus_schedule_GetAllEvents (DVBIDBusSchedule* self,
                                           gint* result_length1,
                                           GError** error);
VALA_EXTERN DVBEventInfo* dvb_id_bus_schedule_GetAllEventInfos (DVBIDBusSchedule* self,
                                                    gint* result_length1,
                                                    GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_GetInformations (DVBIDBusSchedule* self,
                                              guint32 event_id,
                                              DVBEventInfo* event_info,
                                              GError** error);
VALA_EXTERN guint32 dvb_id_bus_schedule_NowPlaying (DVBIDBusSchedule* self,
                                        GError** error);
VALA_EXTERN guint32 dvb_id_bus_schedule_Next (DVBIDBusSchedule* self,
                                  guint32 event_id,
                                  GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_GetName (DVBIDBusSchedule* self,
                                      guint32 event_id,
                                      gchar** name,
                                      GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_GetShortDescription (DVBIDBusSchedule* self,
                                                  guint32 event_id,
                                                  gchar** description,
                                                  GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_GetExtendedDescription (DVBIDBusSchedule* self,
                                                     guint32 event_id,
                                                     gchar** description,
                                                     GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_GetDuration (DVBIDBusSchedule* self,
                                          guint32 event_id,
                                          guint* duration,
                                          GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_GetLocalStartTime (DVBIDBusSchedule* self,
                                                guint32 event_id,
                                                guint** start_time,
                                                gint* start_time_length1,
                                                GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_GetLocalStartTimestamp (DVBIDBusSchedule* self,
                                                     guint32 event_id,
                                                     gint64* timestamp,
                                                     GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_IsRunning (DVBIDBusSchedule* self,
                                        guint32 event_id,
                                        gboolean* running,
                                        GError** error);
VALA_EXTERN gboolean dvb_id_bus_schedule_IsScrambled (DVBIDBusSchedule* self,
                                          guint32 event_id,
                                          gboolean* scrambled,
                                          GError** error);
static void dvb_schedule_finalize (GObject * obj);
static GType dvb_schedule_get_type_once (void);
static void _vala_dvb_schedule_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_dvb_schedule_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
dvb_schedule_get_instance_private (DVBSchedule* self)
{
	return G_STRUCT_MEMBER_P (self, DVBSchedule_private_offset);
}

static void
dvb_schedule_restore_data_free (gpointer _data)
{
	DvbScheduleRestoreData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (DvbScheduleRestoreData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
dvb_schedule_restore (DVBSchedule* self,
                      GAsyncReadyCallback _callback_,
                      gpointer _user_data_)
{
	DvbScheduleRestoreData* _data_;
	DVBSchedule* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (DvbScheduleRestoreData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, dvb_schedule_restore_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	dvb_schedule_restore_co (_data_);
}

void
dvb_schedule_restore_finish (DVBSchedule* self,
                             GAsyncResult* _res_)
{
	DvbScheduleRestoreData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
dvb_schedule_restore_co (DvbScheduleRestoreData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_tmp1_ = _data_->self->priv->epgstore;
		_data_->_tmp2_ = _data_->self->priv->_channel;
		_data_->_tmp3_ = dvb_channel_get_Sid (_data_->_tmp2_);
		_data_->_tmp4_ = _data_->_tmp3_;
		_data_->_tmp5_ = _data_->self->priv->_channel;
		_data_->_tmp6_ = dvb_channel_get_GroupId (_data_->_tmp5_);
		_data_->_tmp7_ = _data_->_tmp6_;
		_data_->_tmp8_ = dvb_database_epg_store_get_events (_data_->_tmp1_, _data_->_tmp4_, _data_->_tmp7_, &_data_->_inner_error0_);
		_data_->_tmp0_ = _data_->_tmp8_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			_g_object_unref0 (_data_->levents);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp9_ = _data_->_tmp0_;
		_data_->_tmp0_ = NULL;
		_g_object_unref0 (_data_->levents);
		_data_->levents = _data_->_tmp9_;
		_g_object_unref0 (_data_->_tmp0_);
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		_data_->e1 = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp10_ = dvb_schedule_log;
		_data_->_tmp11_ = _data_->e1;
		_data_->_tmp12_ = _data_->_tmp11_->message;
		dvb_logging_logger_error (_data_->_tmp10_, "Schedule.vala:56: %s", _data_->_tmp12_);
		_g_error_free0 (_data_->e1);
		_g_object_unref0 (_data_->levents);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->levents);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->newest_expired = -1;
	{
		_data_->i = 0;
		{
			_data_->_tmp13_ = TRUE;
			while (TRUE) {
				if (!_data_->_tmp13_) {
					_data_->_tmp14_ = _data_->i;
					_data_->i = _data_->_tmp14_ + 1;
				}
				_data_->_tmp13_ = FALSE;
				_data_->_tmp15_ = _data_->levents;
				_data_->_tmp16_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp15_);
				_data_->_tmp17_ = _data_->_tmp16_;
				if (!(_data_->i < _data_->_tmp17_)) {
					break;
				}
				_data_->_tmp18_ = _data_->levents;
				_data_->_tmp19_ = gee_list_get (_data_->_tmp18_, _data_->i);
				_dvb_event_unref0 (_data_->event);
				_data_->event = (DVBEvent*) _data_->_tmp19_;
				_data_->_tmp20_ = _data_->event;
				if (dvb_event_has_expired (_data_->_tmp20_)) {
					_data_->newest_expired = _data_->i;
				} else {
					_data_->_tmp21_ = _data_->self->priv->events;
					_data_->_tmp22_ = _data_->event;
					dvb_event_storage_insert (_data_->_tmp21_, _data_->_tmp22_);
				}
			}
		}
	}
	if (_data_->newest_expired != -1) {
		_data_->_tmp23_ = _data_->levents;
		_data_->_tmp24_ = gee_list_get (_data_->_tmp23_, _data_->newest_expired);
		_dvb_event_unref0 (_data_->event);
		_data_->event = (DVBEvent*) _data_->_tmp24_;
		{
			_data_->_tmp25_ = _data_->self->priv->epgstore;
			_data_->_tmp26_ = _data_->event;
			_data_->_tmp27_ = _data_->self->priv->_channel;
			_data_->_tmp28_ = dvb_channel_get_Sid (_data_->_tmp27_);
			_data_->_tmp29_ = _data_->_tmp28_;
			_data_->_tmp30_ = _data_->self->priv->_channel;
			_data_->_tmp31_ = dvb_channel_get_GroupId (_data_->_tmp30_);
			_data_->_tmp32_ = _data_->_tmp31_;
			dvb_database_epg_store_remove_events_older_than (_data_->_tmp25_, _data_->_tmp26_, _data_->_tmp29_, _data_->_tmp32_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				if (_data_->_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					goto __catch1_dvb_database_sql_error;
				}
				_dvb_event_unref0 (_data_->event);
				_g_object_unref0 (_data_->levents);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		}
		goto __finally1;
		__catch1_dvb_database_sql_error:
		{
			_data_->e2 = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp33_ = dvb_schedule_log;
			_data_->_tmp34_ = _data_->e2;
			_data_->_tmp35_ = _data_->_tmp34_->message;
			dvb_logging_logger_error (_data_->_tmp33_, "Schedule.vala:78: %s", _data_->_tmp35_);
			_g_error_free0 (_data_->e2);
			_dvb_event_unref0 (_data_->event);
			_g_object_unref0 (_data_->levents);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_dvb_event_unref0 (_data_->event);
			_g_object_unref0 (_data_->levents);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	_data_->_tmp36_ = dvb_schedule_log;
	_data_->_tmp37_ = _data_->self->priv->events;
	_data_->_tmp38_ = dvb_event_storage_get_size (_data_->_tmp37_);
	_data_->_tmp39_ = _data_->_tmp38_;
	_data_->_tmp40_ = _data_->self->priv->_channel;
	_data_->_tmp41_ = dvb_channel_get_Sid (_data_->_tmp40_);
	_data_->_tmp42_ = _data_->_tmp41_;
	dvb_logging_logger_debug (_data_->_tmp36_, "Schedule.vala:83: Finished restoring %d EPG events for channel %u", _data_->_tmp39_, _data_->_tmp42_);
	_dvb_event_unref0 (_data_->event);
	_g_object_unref0 (_data_->levents);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

DVBSchedule*
dvb_schedule_construct (GType object_type,
                        DVBChannel* channel)
{
	DVBSchedule * self = NULL;
	g_return_val_if_fail (channel != NULL, NULL);
	self = (DVBSchedule*) g_object_new (object_type, "channel", channel, NULL);
	return self;
}

DVBSchedule*
dvb_schedule_new (DVBChannel* channel)
{
	return dvb_schedule_construct (DVB_TYPE_SCHEDULE, channel);
}

void
dvb_schedule_remove_expired_events (DVBSchedule* self)
{
	gint last_expired = 0;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	last_expired = -1;
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBLoggingLogger* _tmp13_;
			DVBChannel* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			DVBChannel* _tmp17_;
			guint _tmp18_;
			guint _tmp19_;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp1_ = FALSE;
					_tmp1_ = TRUE;
					while (TRUE) {
						DVBEventStorage* _tmp3_;
						gint _tmp4_;
						gint _tmp5_;
						DVBEventElement* element = NULL;
						DVBEventStorage* _tmp6_;
						DVBEventElement* _tmp7_;
						DVBEvent* e = NULL;
						DVBEventElement* _tmp8_;
						DVBEvent* _tmp9_;
						gboolean _tmp10_ = FALSE;
						DVBEvent* _tmp11_;
						if (!_tmp1_) {
							gint _tmp2_;
							_tmp2_ = i;
							i = _tmp2_ + 1;
						}
						_tmp1_ = FALSE;
						_tmp3_ = self->priv->events;
						_tmp4_ = dvb_event_storage_get_size (_tmp3_);
						_tmp5_ = _tmp4_;
						if (!(i < _tmp5_)) {
							break;
						}
						_tmp6_ = self->priv->events;
						_tmp7_ = dvb_event_storage_get (_tmp6_, i);
						element = _tmp7_;
						_tmp8_ = element;
						_tmp9_ = dvb_schedule_get_event (self, _tmp8_->id);
						e = _tmp9_;
						_tmp11_ = e;
						if (_tmp11_ != NULL) {
							DVBEvent* _tmp12_;
							_tmp12_ = e;
							_tmp10_ = dvb_event_has_expired (_tmp12_);
						} else {
							_tmp10_ = FALSE;
						}
						if (_tmp10_) {
							last_expired = i;
						} else {
							_dvb_event_unref0 (e);
							_g_object_unref0 (element);
							break;
						}
						_dvb_event_unref0 (e);
						_g_object_unref0 (element);
					}
				}
			}
			_tmp13_ = dvb_schedule_log;
			_tmp14_ = self->priv->_channel;
			_tmp15_ = dvb_channel_get_Name (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = self->priv->_channel;
			_tmp18_ = dvb_channel_get_Sid (_tmp17_);
			_tmp19_ = _tmp18_;
			dvb_logging_logger_debug (_tmp13_, "Schedule.vala:106: Removing expired events of channel %s (%u)", _tmp16_, _tmp19_);
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp20_ = FALSE;
					_tmp20_ = TRUE;
					while (TRUE) {
						DVBEventElement* element = NULL;
						DVBEventStorage* _tmp22_;
						DVBEventElement* _tmp23_;
						DVBEvent* event = NULL;
						DVBEventElement* _tmp24_;
						DVBEvent* _tmp25_;
						if (!_tmp20_) {
							gint _tmp21_;
							_tmp21_ = i;
							i = _tmp21_ + 1;
						}
						_tmp20_ = FALSE;
						if (!(i <= last_expired)) {
							break;
						}
						_tmp22_ = self->priv->events;
						_tmp23_ = dvb_event_storage_get (_tmp22_, i);
						element = _tmp23_;
						_tmp24_ = element;
						_tmp25_ = dvb_schedule_get_event (self, _tmp24_->id);
						event = _tmp25_;
						{
							DVBdatabaseEPGStore* _tmp26_;
							DVBEvent* _tmp27_;
							DVBChannel* _tmp28_;
							guint _tmp29_;
							guint _tmp30_;
							DVBChannel* _tmp31_;
							guint _tmp32_;
							guint _tmp33_;
							_tmp26_ = self->priv->epgstore;
							_tmp27_ = event;
							_tmp28_ = self->priv->_channel;
							_tmp29_ = dvb_channel_get_Sid (_tmp28_);
							_tmp30_ = _tmp29_;
							_tmp31_ = self->priv->_channel;
							_tmp32_ = dvb_channel_get_GroupId (_tmp31_);
							_tmp33_ = _tmp32_;
							dvb_database_epg_store_remove_events_older_than (_tmp26_, _tmp27_, _tmp30_, _tmp33_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
									goto __catch1_dvb_database_sql_error;
								}
								_dvb_event_unref0 (event);
								_g_object_unref0 (element);
								{
									DVBEventStorage* _tmp34_;
									_tmp34_ = self->priv->events;
									g_rec_mutex_unlock (&self->priv->__lock_events);
								}
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return;
							}
						}
						goto __finally1;
						__catch1_dvb_database_sql_error:
						{
							GError* e = NULL;
							DVBLoggingLogger* _tmp35_;
							GError* _tmp36_;
							const gchar* _tmp37_;
							e = _inner_error0_;
							_inner_error0_ = NULL;
							_tmp35_ = dvb_schedule_log;
							_tmp36_ = e;
							_tmp37_ = _tmp36_->message;
							dvb_logging_logger_error (_tmp35_, "Schedule.vala:116: %s", _tmp37_);
							_g_error_free0 (e);
						}
						__finally1:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_dvb_event_unref0 (event);
							_g_object_unref0 (element);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
						_dvb_event_unref0 (event);
						_g_object_unref0 (element);
					}
				}
			}
			if (last_expired > -1) {
				DVBEventStorage* _tmp38_;
				_tmp38_ = self->priv->events;
				dvb_event_storage_remove_range (_tmp38_, 0, last_expired);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp39_;
			_tmp39_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

DVBEvent*
dvb_schedule_get_event (DVBSchedule* self,
                        guint event_id)
{
	GError* _inner_error0_ = NULL;
	DVBEvent* result;
	g_return_val_if_fail (self != NULL, NULL);
	{
		DVBEvent* _tmp0_ = NULL;
		DVBdatabaseEPGStore* _tmp1_;
		DVBChannel* _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		DVBChannel* _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
		DVBEvent* _tmp8_;
		DVBEvent* _tmp9_;
		_tmp1_ = self->priv->epgstore;
		_tmp2_ = self->priv->_channel;
		_tmp3_ = dvb_channel_get_Sid (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = self->priv->_channel;
		_tmp6_ = dvb_channel_get_GroupId (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = dvb_database_epg_store_get_event (_tmp1_, event_id, _tmp4_, _tmp7_, &_inner_error0_);
		_tmp0_ = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				goto __catch0_dvb_database_sql_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp9_ = _tmp0_;
		_tmp0_ = NULL;
		result = _tmp9_;
		_dvb_event_unref0 (_tmp0_);
		return result;
	}
	goto __finally0;
	__catch0_dvb_database_sql_error:
	{
		GError* e = NULL;
		DVBLoggingLogger* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp10_ = dvb_schedule_log;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		dvb_logging_logger_error (_tmp10_, "Schedule.vala:131: %s", _tmp12_);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

/**
         * When an event with the same id already exists, it's replaced
         */
void
dvb_schedule_add (DVBSchedule* self,
                  DVBEvent* event)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	if (dvb_event_has_expired (event)) {
		return;
	}
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			{
				dvb_schedule_store_event (self, event, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
						goto __catch1_dvb_database_sql_error;
					}
					{
						DVBEventStorage* _tmp1_;
						_tmp1_ = self->priv->events;
						g_rec_mutex_unlock (&self->priv->__lock_events);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			goto __finally1;
			__catch1_dvb_database_sql_error:
			{
				GError* e = NULL;
				DVBLoggingLogger* _tmp2_;
				GError* _tmp3_;
				const gchar* _tmp4_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp2_ = dvb_schedule_log;
				_tmp3_ = e;
				_tmp4_ = _tmp3_->message;
				dvb_logging_logger_error (_tmp2_, "Schedule.vala:146: %s", _tmp4_);
				_g_error_free0 (e);
			}
			__finally1:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp5_;
			_tmp5_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

void
dvb_schedule_add_all (DVBSchedule* self,
                      GeeCollection* new_events)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_events != NULL);
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			{
				DVBdatabaseEPGStore* _tmp1_;
				DVBdatabaseEPGStore* _tmp10_;
				g_rec_mutex_lock (&dvb_schedule_mutex);
				_tmp1_ = self->priv->epgstore;
				dvb_database_sqlite_sqlite_database_begin_transaction (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase), &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
						goto __catch1_dvb_database_sql_error;
					}
					{
						DVBEventStorage* _tmp2_;
						_tmp2_ = self->priv->events;
						g_rec_mutex_unlock (&self->priv->__lock_events);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				{
					GeeIterator* _event_it = NULL;
					GeeIterator* _tmp3_;
					_tmp3_ = gee_iterable_iterator ((GeeIterable*) new_events);
					_event_it = _tmp3_;
					while (TRUE) {
						GeeIterator* _tmp4_;
						DVBEvent* event = NULL;
						GeeIterator* _tmp5_;
						gpointer _tmp6_;
						DVBEvent* _tmp7_;
						_tmp4_ = _event_it;
						if (!gee_iterator_next (_tmp4_)) {
							break;
						}
						_tmp5_ = _event_it;
						_tmp6_ = gee_iterator_get (_tmp5_);
						event = (DVBEvent*) _tmp6_;
						_tmp7_ = event;
						if (!dvb_event_has_expired (_tmp7_)) {
							DVBEvent* _tmp8_;
							_tmp8_ = event;
							dvb_schedule_store_event (self, _tmp8_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								_dvb_event_unref0 (event);
								_g_object_unref0 (_event_it);
								if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
									goto __catch1_dvb_database_sql_error;
								}
								{
									DVBEventStorage* _tmp9_;
									_tmp9_ = self->priv->events;
									g_rec_mutex_unlock (&self->priv->__lock_events);
								}
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return;
							}
						}
						_dvb_event_unref0 (event);
					}
					_g_object_unref0 (_event_it);
				}
				_tmp10_ = self->priv->epgstore;
				dvb_database_sqlite_sqlite_database_end_transaction (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase), &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
						goto __catch1_dvb_database_sql_error;
					}
					{
						DVBEventStorage* _tmp11_;
						_tmp11_ = self->priv->events;
						g_rec_mutex_unlock (&self->priv->__lock_events);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			goto __finally1;
			__catch1_dvb_database_sql_error:
			{
				GError* e = NULL;
				DVBLoggingLogger* _tmp12_;
				GError* _tmp13_;
				const gchar* _tmp14_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp12_ = dvb_schedule_log;
				_tmp13_ = e;
				_tmp14_ = _tmp13_->message;
				dvb_logging_logger_error (_tmp12_, "Schedule.vala:164: %s", _tmp14_);
				_g_error_free0 (e);
			}
			__finally1:
			{
				GError* _inner_error1_ = NULL;
				g_rec_mutex_unlock (&dvb_schedule_mutex);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp15_;
			_tmp15_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
dvb_schedule_store_event (DVBSchedule* self,
                          DVBEvent* event,
                          GError** error)
{
	GeeList* overlap = NULL;
	GeeList* _tmp0_;
	gint s = 0;
	GeeList* _tmp1_;
	DVBdatabaseEPGStore* _tmp20_;
	DVBChannel* _tmp21_;
	guint _tmp22_;
	guint _tmp23_;
	DVBChannel* _tmp24_;
	guint _tmp25_;
	guint _tmp26_;
	DVBEventStorage* _tmp27_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	_tmp0_ = dvb_schedule_get_overlapping_events (self, event);
	overlap = _tmp0_;
	_tmp1_ = overlap;
	s = dvb_schedule_match_events (self, _tmp1_, event);
	if (s > DVB_SCHEDULE_MATCH_THRESHOLD) {
		DVBEventStorage* _tmp2_;
		GeeList* _tmp3_;
		_tmp2_ = self->priv->events;
		_tmp3_ = overlap;
		dvb_event_storage_remove_all (_tmp2_, _tmp3_);
		{
			GeeList* _overlapping_event_list = NULL;
			GeeList* _tmp4_;
			gint _overlapping_event_size = 0;
			GeeList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _overlapping_event_index = 0;
			_tmp4_ = overlap;
			_overlapping_event_list = _tmp4_;
			_tmp5_ = _overlapping_event_list;
			_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_overlapping_event_size = _tmp7_;
			_overlapping_event_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				DVBEvent* overlapping_event = NULL;
				GeeList* _tmp10_;
				gpointer _tmp11_;
				DVBdatabaseEPGStore* _tmp12_;
				DVBEvent* _tmp13_;
				DVBChannel* _tmp14_;
				guint _tmp15_;
				guint _tmp16_;
				DVBChannel* _tmp17_;
				guint _tmp18_;
				guint _tmp19_;
				_overlapping_event_index = _overlapping_event_index + 1;
				_tmp8_ = _overlapping_event_index;
				_tmp9_ = _overlapping_event_size;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = _overlapping_event_list;
				_tmp11_ = gee_list_get (_tmp10_, _overlapping_event_index);
				overlapping_event = (DVBEvent*) _tmp11_;
				_tmp12_ = self->priv->epgstore;
				_tmp13_ = overlapping_event;
				_tmp14_ = self->priv->_channel;
				_tmp15_ = dvb_channel_get_Sid (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = self->priv->_channel;
				_tmp18_ = dvb_channel_get_GroupId (_tmp17_);
				_tmp19_ = _tmp18_;
				dvb_database_epg_store_remove_event (_tmp12_, _tmp13_->id, _tmp16_, _tmp19_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_dvb_event_unref0 (overlapping_event);
						_g_object_unref0 (overlap);
						return;
					} else {
						_dvb_event_unref0 (overlapping_event);
						_g_object_unref0 (overlap);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_dvb_event_unref0 (overlapping_event);
			}
		}
	}
	_tmp20_ = self->priv->epgstore;
	_tmp21_ = self->priv->_channel;
	_tmp22_ = dvb_channel_get_Sid (_tmp21_);
	_tmp23_ = _tmp22_;
	_tmp24_ = self->priv->_channel;
	_tmp25_ = dvb_channel_get_GroupId (_tmp24_);
	_tmp26_ = _tmp25_;
	dvb_database_epg_store_add_or_update_event (_tmp20_, event, _tmp23_, _tmp26_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (overlap);
			return;
		} else {
			_g_object_unref0 (overlap);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp27_ = self->priv->events;
	if (!dvb_event_storage_contains_event_with_id (_tmp27_, event->id)) {
		DVBEventStorage* _tmp28_;
		_tmp28_ = self->priv->events;
		dvb_event_storage_insert (_tmp28_, event);
	}
	_g_object_unref0 (overlap);
}

static GeeList*
dvb_schedule_get_overlapping_events (DVBSchedule* self,
                                     DVBEvent* event)
{
	GeeList* elements = NULL;
	DVBEventStorage* _tmp0_;
	GeeList* _tmp1_;
	GeeList* overlap = NULL;
	GeeArrayList* _tmp2_;
	GeeList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (event != NULL, NULL);
	_tmp0_ = self->priv->events;
	_tmp1_ = dvb_event_storage_get_overlapping_events (_tmp0_, event);
	elements = _tmp1_;
	_tmp2_ = gee_array_list_new (DVB_TYPE_EVENT, (GBoxedCopyFunc) dvb_event_ref, (GDestroyNotify) dvb_event_unref, NULL, NULL, NULL);
	overlap = (GeeList*) _tmp2_;
	{
		GeeList* _data_list = NULL;
		GeeList* _tmp3_;
		gint _data_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _data_index = 0;
		_tmp3_ = elements;
		_data_list = _tmp3_;
		_tmp4_ = _data_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_data_size = _tmp6_;
		_data_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			DVBEventElement* data = NULL;
			GeeList* _tmp9_;
			gpointer _tmp10_;
			DVBEvent* e = NULL;
			DVBEventElement* _tmp11_;
			DVBEvent* _tmp12_;
			gboolean _tmp13_ = FALSE;
			DVBEvent* _tmp14_;
			_data_index = _data_index + 1;
			_tmp7_ = _data_index;
			_tmp8_ = _data_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _data_list;
			_tmp10_ = gee_list_get (_tmp9_, _data_index);
			data = (DVBEventElement*) _tmp10_;
			_tmp11_ = data;
			_tmp12_ = dvb_schedule_get_event (self, _tmp11_->id);
			e = _tmp12_;
			_tmp14_ = e;
			if (_tmp14_ != NULL) {
				DVBEvent* _tmp15_;
				_tmp15_ = e;
				_tmp13_ = dvb_event_get_overlap_percentage (_tmp15_, event) >= DVB_SCHEDULE_MIN_EVENT_OVERLAP;
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				GeeList* _tmp16_;
				DVBEvent* _tmp17_;
				_tmp16_ = overlap;
				_tmp17_ = e;
				gee_collection_add ((GeeCollection*) _tmp16_, _tmp17_);
			}
			_dvb_event_unref0 (e);
			_g_object_unref0 (data);
		}
	}
	result = overlap;
	_g_object_unref0 (elements);
	return result;
}

static gint
dvb_schedule_match_events (DVBSchedule* self,
                           GeeList* events,
                           DVBEvent* ref_event)
{
	time_t ref_start = 0;
	time_t ref_end = 0;
	gdouble max_score = 0.0;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (events != NULL, 0);
	g_return_val_if_fail (ref_event != NULL, 0);
	ref_start = dvb_event_get_start_timestamp (ref_event);
	ref_end = dvb_event_get_end_timestamp (ref_event);
	max_score = (gdouble) 0;
	{
		GeeList* _event_list = NULL;
		gint _event_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _event_index = 0;
		_event_list = events;
		_tmp0_ = _event_list;
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
		_tmp2_ = _tmp1_;
		_event_size = _tmp2_;
		_event_index = -1;
		while (TRUE) {
			gint _tmp3_;
			gint _tmp4_;
			DVBEvent* event = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			gdouble score = 0.0;
			time_t e_start = 0;
			DVBEvent* _tmp7_;
			time_t e_end = 0;
			DVBEvent* _tmp8_;
			DVBEvent* _tmp9_;
			gboolean _tmp10_ = FALSE;
			const gchar* _tmp11_;
			_event_index = _event_index + 1;
			_tmp3_ = _event_index;
			_tmp4_ = _event_size;
			if (!(_tmp3_ < _tmp4_)) {
				break;
			}
			_tmp5_ = _event_list;
			_tmp6_ = gee_list_get (_tmp5_, _event_index);
			event = (DVBEvent*) _tmp6_;
			score = (gdouble) 0;
			_tmp7_ = event;
			e_start = dvb_event_get_start_timestamp (_tmp7_);
			_tmp8_ = event;
			e_end = dvb_event_get_end_timestamp (_tmp8_);
			score += fabs ((gdouble) (ref_start - e_start));
			score += fabs ((gdouble) (ref_end - e_end));
			_tmp9_ = event;
			score += fabs ((gdouble) (ref_event->duration - _tmp9_->duration)) / 60.0;
			_tmp11_ = ref_event->name;
			if (_tmp11_ != NULL) {
				DVBEvent* _tmp12_;
				const gchar* _tmp13_;
				_tmp12_ = event;
				_tmp13_ = _tmp12_->name;
				_tmp10_ = _tmp13_ != NULL;
			} else {
				_tmp10_ = FALSE;
			}
			if (_tmp10_) {
				glong unmatched = 0L;
				glong diff = 0L;
				const gchar* _tmp14_;
				DVBEvent* _tmp15_;
				const gchar* _tmp16_;
				glong _tmp17_ = 0L;
				glong _tmp18_;
				_tmp14_ = ref_event->name;
				_tmp15_ = event;
				_tmp16_ = _tmp15_->name;
				_tmp18_ = dvb_utils_strdiff (_tmp14_, _tmp16_, &_tmp17_);
				unmatched = _tmp17_;
				diff = _tmp18_;
				score += (gdouble) (10 * (diff + (5 * unmatched)));
			}
			if (score > max_score) {
				max_score = score;
			}
			_dvb_event_unref0 (event);
		}
	}
	result = (gint) max_score;
	return result;
}

gboolean
dvb_schedule_contains (DVBSchedule* self,
                       guint event_id)
{
	gboolean val = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp1_;
			_tmp1_ = self->priv->events;
			val = dvb_event_storage_contains_event_with_id (_tmp1_, event_id);
		}
		__finally0:
		{
			DVBEventStorage* _tmp2_;
			_tmp2_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp3_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp3_;
		}
	}
	result = val;
	return result;
}

static gpointer
_dvb_event_ref0 (gpointer self)
{
	return self ? dvb_event_ref (self) : NULL;
}

DVBEvent*
dvb_schedule_get_running_event (DVBSchedule* self)
{
	DVBEvent* running_event = NULL;
	GError* _inner_error0_ = NULL;
	DVBEvent* result;
	g_return_val_if_fail (self != NULL, NULL);
	running_event = NULL;
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			{
				DVBEventStorage* _element_list = NULL;
				DVBEventStorage* _tmp1_;
				gint _element_size = 0;
				DVBEventStorage* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _element_index = 0;
				_tmp1_ = self->priv->events;
				_element_list = _tmp1_;
				_tmp2_ = _element_list;
				_tmp3_ = dvb_event_storage_get_size (_tmp2_);
				_tmp4_ = _tmp3_;
				_element_size = _tmp4_;
				_element_index = -1;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					DVBEventElement* element = NULL;
					DVBEventStorage* _tmp7_;
					DVBEventElement* _tmp8_;
					DVBEvent* event = NULL;
					DVBEventElement* _tmp9_;
					DVBEvent* _tmp10_;
					gboolean _tmp11_ = FALSE;
					DVBEvent* _tmp12_;
					_element_index = _element_index + 1;
					_tmp5_ = _element_index;
					_tmp6_ = _element_size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = _element_list;
					_tmp8_ = dvb_event_storage_get (_tmp7_, _element_index);
					element = _tmp8_;
					_tmp9_ = element;
					_tmp10_ = dvb_schedule_get_event (self, _tmp9_->id);
					event = _tmp10_;
					_tmp12_ = event;
					if (_tmp12_ != NULL) {
						DVBEvent* _tmp13_;
						_tmp13_ = event;
						_tmp11_ = dvb_event_is_running (_tmp13_);
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						DVBEvent* _tmp14_;
						DVBEvent* _tmp15_;
						_tmp14_ = event;
						_tmp15_ = _dvb_event_ref0 (_tmp14_);
						_dvb_event_unref0 (running_event);
						running_event = _tmp15_;
						_dvb_event_unref0 (event);
						_g_object_unref0 (element);
						break;
					}
					_dvb_event_unref0 (event);
					_g_object_unref0 (element);
				}
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp16_;
			_tmp16_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_dvb_event_unref0 (running_event);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = running_event;
	return result;
}

/**
         * @start: local time of event
         * @duration: how long the event is
         * @returns: the event that starts after @start
         * and spans the given time period
         */
static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	localtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}

DVBEvent*
dvb_schedule_get_event_around (DVBSchedule* self,
                               struct tm* start,
                               guint duration)
{
	DVBEvent* _result_ = NULL;
	time_t timer_start = 0;
	time_t timer_end = 0;
	GError* _inner_error0_ = NULL;
	DVBEvent* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (start != NULL, NULL);
	_result_ = NULL;
	timer_start = mktime (start);
	timer_end = timer_start + (duration * 60);
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			time_t last_diff = 0;
			last_diff = (time_t) 0;
			{
				DVBEventStorage* _element_list = NULL;
				DVBEventStorage* _tmp1_;
				gint _element_size = 0;
				DVBEventStorage* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _element_index = 0;
				_tmp1_ = self->priv->events;
				_element_list = _tmp1_;
				_tmp2_ = _element_list;
				_tmp3_ = dvb_event_storage_get_size (_tmp2_);
				_tmp4_ = _tmp3_;
				_element_size = _tmp4_;
				_element_index = -1;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					DVBEventElement* element = NULL;
					DVBEventStorage* _tmp7_;
					DVBEventElement* _tmp8_;
					time_t event_start = 0;
					DVBEventElement* _tmp9_;
					struct tm _tmp10_ = {0};
					DVBEvent* event = NULL;
					DVBEventElement* _tmp11_;
					DVBEvent* _tmp12_;
					DVBEvent* _tmp13_;
					time_t event_end = 0;
					DVBEvent* _tmp14_;
					time_t _tmp15_ = 0;
					time_t min_end = 0;
					time_t _tmp16_ = 0;
					time_t max_start = 0;
					time_t overlap = 0;
					_element_index = _element_index + 1;
					_tmp5_ = _element_index;
					_tmp6_ = _element_size;
					if (!(_tmp5_ < _tmp6_)) {
						break;
					}
					_tmp7_ = _element_list;
					_tmp8_ = dvb_event_storage_get (_tmp7_, _element_index);
					element = _tmp8_;
					_tmp9_ = element;
					g_time_local (_tmp9_->starttime, &_tmp10_);
					event_start = timegm (&_tmp10_);
					_tmp11_ = element;
					_tmp12_ = dvb_schedule_get_event (self, _tmp11_->id);
					event = _tmp12_;
					_tmp13_ = event;
					if (_tmp13_ == NULL) {
						_dvb_event_unref0 (event);
						_g_object_unref0 (element);
						continue;
					}
					_tmp14_ = event;
					event_end = event_start + _tmp14_->duration;
					if (timer_end < event_end) {
						_tmp15_ = timer_end;
					} else {
						_tmp15_ = event_end;
					}
					min_end = _tmp15_;
					if (timer_start > event_start) {
						_tmp16_ = timer_start;
					} else {
						_tmp16_ = event_start;
					}
					max_start = _tmp16_;
					overlap = min_end - max_start;
					if (last_diff < overlap) {
						DVBEvent* _tmp17_;
						DVBEvent* _tmp18_;
						last_diff = overlap;
						_tmp17_ = event;
						_tmp18_ = _dvb_event_ref0 (_tmp17_);
						_dvb_event_unref0 (_result_);
						_result_ = _tmp18_;
					}
					if (event_start > timer_end) {
						_dvb_event_unref0 (event);
						_g_object_unref0 (element);
						break;
					}
					_dvb_event_unref0 (event);
					_g_object_unref0 (element);
				}
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp19_;
			_tmp19_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_dvb_event_unref0 (_result_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = _result_;
	return result;
}

static guint32*
dvb_schedule_real_GetAllEvents (DVBIDBusSchedule* base,
                                gint* result_length1,
                                GError** error)
{
	DVBSchedule * self;
	GeeArrayList* events = NULL;
	GeeArrayList* _tmp0_;
	guint32* event_ids = NULL;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	guint32* _tmp21_;
	gint event_ids_length1;
	gint _event_ids_size_;
	guint32* _tmp28_;
	gint _tmp28__length1;
	GError* _inner_error0_ = NULL;
	guint32* result;
	self = (DVBSchedule*) base;
	_tmp0_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
	events = _tmp0_;
	{
		DVBEventStorage* _tmp1_;
		_tmp1_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			{
				DVBEventStorage* _element_list = NULL;
				DVBEventStorage* _tmp2_;
				gint _element_size = 0;
				DVBEventStorage* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _element_index = 0;
				_tmp2_ = self->priv->events;
				_element_list = _tmp2_;
				_tmp3_ = _element_list;
				_tmp4_ = dvb_event_storage_get_size (_tmp3_);
				_tmp5_ = _tmp4_;
				_element_size = _tmp5_;
				_element_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					DVBEventElement* element = NULL;
					DVBEventStorage* _tmp8_;
					DVBEventElement* _tmp9_;
					DVBEvent* event = NULL;
					DVBEventElement* _tmp10_;
					DVBEvent* _tmp11_;
					gboolean _tmp12_ = FALSE;
					DVBEvent* _tmp13_;
					GeeArrayList* _tmp15_;
					DVBEventElement* _tmp16_;
					_element_index = _element_index + 1;
					_tmp6_ = _element_index;
					_tmp7_ = _element_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _element_list;
					_tmp9_ = dvb_event_storage_get (_tmp8_, _element_index);
					element = _tmp9_;
					_tmp10_ = element;
					_tmp11_ = dvb_schedule_get_event (self, _tmp10_->id);
					event = _tmp11_;
					_tmp13_ = event;
					if (_tmp13_ == NULL) {
						_tmp12_ = TRUE;
					} else {
						DVBEvent* _tmp14_;
						_tmp14_ = event;
						_tmp12_ = dvb_event_has_expired (_tmp14_);
					}
					if (_tmp12_) {
						_dvb_event_unref0 (event);
						_g_object_unref0 (element);
						continue;
					}
					_tmp15_ = events;
					_tmp16_ = element;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, (gpointer) ((guintptr) _tmp16_->id));
					_dvb_event_unref0 (event);
					_g_object_unref0 (element);
				}
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp17_;
			_tmp17_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (events);
				return NULL;
			} else {
				_g_object_unref0 (events);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp18_ = events;
	_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_new0 (guint32, _tmp20_);
	event_ids = _tmp21_;
	event_ids_length1 = _tmp20_;
	_event_ids_size_ = event_ids_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				guint32* _tmp24_;
				gint _tmp24__length1;
				guint32* _tmp25_;
				gint _tmp25__length1;
				GeeArrayList* _tmp26_;
				gpointer _tmp27_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp24_ = event_ids;
				_tmp24__length1 = event_ids_length1;
				if (!(i < _tmp24__length1)) {
					break;
				}
				_tmp25_ = event_ids;
				_tmp25__length1 = event_ids_length1;
				_tmp26_ = events;
				_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, i);
				_tmp25_[i] = (guint32) ((guintptr) _tmp27_);
			}
		}
	}
	_tmp28_ = event_ids;
	_tmp28__length1 = event_ids_length1;
	if (result_length1) {
		*result_length1 = _tmp28__length1;
	}
	result = _tmp28_;
	_g_object_unref0 (events);
	return result;
}

static DVBEventInfo*
dvb_schedule_real_GetAllEventInfos (DVBIDBusSchedule* base,
                                    gint* result_length1,
                                    GError** error)
{
	DVBSchedule * self;
	GeeArrayList* all_events = NULL;
	GeeArrayList* _tmp0_;
	gint n_events = 0;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	DVBEventInfo* event_infos = NULL;
	DVBEventInfo* _tmp21_;
	gint event_infos_length1;
	gint _event_infos_size_;
	gint i = 0;
	DVBEvent* event = NULL;
	DVBEventInfo* _tmp34_;
	gint _tmp34__length1;
	GError* _inner_error0_ = NULL;
	DVBEventInfo* result;
	self = (DVBSchedule*) base;
	_tmp0_ = gee_array_list_new (DVB_TYPE_EVENT, (GBoxedCopyFunc) dvb_event_ref, (GDestroyNotify) dvb_event_unref, NULL, NULL, NULL);
	all_events = _tmp0_;
	{
		DVBEventStorage* _tmp1_;
		_tmp1_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			{
				DVBEventStorage* _element_list = NULL;
				DVBEventStorage* _tmp2_;
				gint _element_size = 0;
				DVBEventStorage* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _element_index = 0;
				_tmp2_ = self->priv->events;
				_element_list = _tmp2_;
				_tmp3_ = _element_list;
				_tmp4_ = dvb_event_storage_get_size (_tmp3_);
				_tmp5_ = _tmp4_;
				_element_size = _tmp5_;
				_element_index = -1;
				while (TRUE) {
					gint _tmp6_;
					gint _tmp7_;
					DVBEventElement* element = NULL;
					DVBEventStorage* _tmp8_;
					DVBEventElement* _tmp9_;
					DVBEvent* event = NULL;
					DVBEventElement* _tmp10_;
					DVBEvent* _tmp11_;
					gboolean _tmp12_ = FALSE;
					DVBEvent* _tmp13_;
					_element_index = _element_index + 1;
					_tmp6_ = _element_index;
					_tmp7_ = _element_size;
					if (!(_tmp6_ < _tmp7_)) {
						break;
					}
					_tmp8_ = _element_list;
					_tmp9_ = dvb_event_storage_get (_tmp8_, _element_index);
					element = _tmp9_;
					_tmp10_ = element;
					_tmp11_ = dvb_schedule_get_event (self, _tmp10_->id);
					event = _tmp11_;
					_tmp13_ = event;
					if (_tmp13_ != NULL) {
						DVBEvent* _tmp14_;
						_tmp14_ = event;
						_tmp12_ = !dvb_event_has_expired (_tmp14_);
					} else {
						_tmp12_ = FALSE;
					}
					if (_tmp12_) {
						GeeArrayList* _tmp15_;
						DVBEvent* _tmp16_;
						_tmp15_ = all_events;
						_tmp16_ = event;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
					}
					_dvb_event_unref0 (event);
					_g_object_unref0 (element);
				}
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp17_;
			_tmp17_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_object_unref0 (all_events);
				return NULL;
			} else {
				_g_object_unref0 (all_events);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp18_ = all_events;
	_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
	_tmp20_ = _tmp19_;
	n_events = _tmp20_;
	_tmp21_ = g_new0 (DVBEventInfo, n_events);
	event_infos = _tmp21_;
	event_infos_length1 = n_events;
	_event_infos_size_ = event_infos_length1;
	i = 0;
	event = NULL;
	if (n_events > i) {
		GeeArrayList* _tmp22_;
		gpointer _tmp23_;
		_tmp22_ = all_events;
		_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, i);
		_dvb_event_unref0 (event);
		event = (DVBEvent*) _tmp23_;
	}
	while (TRUE) {
		DVBEvent* _tmp24_;
		DVBEventInfo* _tmp25_;
		gint _tmp25__length1;
		DVBEvent* _tmp26_;
		DVBEventInfo _tmp27_ = {0};
		gint _tmp33_;
		_tmp24_ = event;
		if (!(_tmp24_ != NULL)) {
			break;
		}
		_tmp25_ = event_infos;
		_tmp25__length1 = event_infos_length1;
		_tmp26_ = event;
		dvb_schedule_event_to_event_info (_tmp26_, &_tmp27_);
		dvb_event_info_destroy (&_tmp25_[i]);
		_tmp25_[i] = _tmp27_;
		if ((i + 1) == n_events) {
			DVBEventInfo* _tmp28_;
			gint _tmp28__length1;
			_tmp28_ = event_infos;
			_tmp28__length1 = event_infos_length1;
			_tmp28_[i].next = (guint32) 0;
			_dvb_event_unref0 (event);
			event = NULL;
		} else {
			GeeArrayList* _tmp29_;
			gpointer _tmp30_;
			DVBEventInfo* _tmp31_;
			gint _tmp31__length1;
			DVBEvent* _tmp32_;
			_tmp29_ = all_events;
			_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, i + 1);
			_dvb_event_unref0 (event);
			event = (DVBEvent*) _tmp30_;
			_tmp31_ = event_infos;
			_tmp31__length1 = event_infos_length1;
			_tmp32_ = event;
			_tmp31_[i].next = (guint32) _tmp32_->id;
		}
		_tmp33_ = i;
		i = _tmp33_ + 1;
	}
	_tmp34_ = event_infos;
	_tmp34__length1 = event_infos_length1;
	if (result_length1) {
		*result_length1 = _tmp34__length1;
	}
	result = _tmp34_;
	_dvb_event_unref0 (event);
	_g_object_unref0 (all_events);
	return result;
}

static gboolean
dvb_schedule_real_GetInformations (DVBIDBusSchedule* base,
                                   guint32 event_id,
                                   DVBEventInfo* event_info,
                                   GError** error)
{
	DVBSchedule * self;
	DVBEventInfo _vala_event_info = {0};
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	dvb_event_info_destroy (&_vala_event_info);
	memset (&_vala_event_info, 0, sizeof (DVBEventInfo));
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp1_;
			_tmp1_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp1_, (guint) event_id)) {
				DVBEventElement* element = NULL;
				DVBEventStorage* _tmp2_;
				DVBEventElement* _tmp3_;
				DVBEvent* event = NULL;
				DVBEventElement* _tmp4_;
				DVBEvent* _tmp5_;
				DVBEvent* _tmp6_;
				DVBEventInfo _tmp7_ = {0};
				DVBEventElement* next_element = NULL;
				DVBEventStorage* _tmp8_;
				DVBEventElement* _tmp9_;
				DVBEventElement* _tmp10_;
				DVBEventElement* _tmp11_;
				_tmp2_ = self->priv->events;
				_tmp3_ = dvb_event_storage_get_by_id (_tmp2_, (guint) event_id);
				element = _tmp3_;
				_tmp4_ = element;
				_tmp5_ = dvb_schedule_get_event (self, _tmp4_->id);
				event = _tmp5_;
				_tmp6_ = event;
				dvb_schedule_event_to_event_info (_tmp6_, &_tmp7_);
				dvb_event_info_destroy (&_vala_event_info);
				_vala_event_info = _tmp7_;
				_tmp8_ = self->priv->events;
				_tmp9_ = element;
				_tmp10_ = dvb_event_storage_next (_tmp8_, _tmp9_);
				next_element = _tmp10_;
				_tmp11_ = next_element;
				if (_tmp11_ == NULL) {
					_vala_event_info.next = (guint32) 0;
				} else {
					DVBEventElement* _tmp12_;
					DVBEventElement* _tmp13_;
					DVBEventElement* _tmp14_;
					_tmp12_ = next_element;
					_tmp13_ = _g_object_ref0 (_tmp12_);
					_g_object_unref0 (element);
					element = _tmp13_;
					_tmp14_ = element;
					_vala_event_info.next = (guint32) _tmp14_->id;
				}
				ret = TRUE;
				_g_object_unref0 (next_element);
				_dvb_event_unref0 (event);
				_g_object_unref0 (element);
			} else {
				gchar* _tmp15_;
				gchar* _tmp16_;
				_vala_event_info.id = (guint32) 0;
				_tmp15_ = g_strdup ("");
				_g_free0 (_vala_event_info.name);
				_vala_event_info.name = _tmp15_;
				_vala_event_info.duration = (guint) 0;
				_tmp16_ = g_strdup ("");
				_g_free0 (_vala_event_info.short_description);
				_vala_event_info.short_description = _tmp16_;
				_vala_event_info.next = (guint32) 0;
				ret = FALSE;
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp17_;
			_tmp17_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp18_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				dvb_event_info_destroy (&_vala_event_info);
				return _tmp18_;
			} else {
				gboolean _tmp19_ = FALSE;
				dvb_event_info_destroy (&_vala_event_info);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp19_;
			}
		}
	}
	result = ret;
	if (event_info) {
		*event_info = _vala_event_info;
	} else {
		dvb_event_info_destroy (&_vala_event_info);
	}
	return result;
}

static guint32
dvb_schedule_real_NowPlaying (DVBIDBusSchedule* base,
                              GError** error)
{
	DVBSchedule * self;
	DVBEvent* event = NULL;
	DVBEvent* _tmp0_;
	guint _tmp1_ = 0U;
	DVBEvent* _tmp2_;
	guint32 result;
	self = (DVBSchedule*) base;
	_tmp0_ = dvb_schedule_get_running_event (self);
	event = _tmp0_;
	_tmp2_ = event;
	if (_tmp2_ == NULL) {
		_tmp1_ = (guint) 0;
	} else {
		DVBEvent* _tmp3_;
		_tmp3_ = event;
		_tmp1_ = _tmp3_->id;
	}
	result = (guint32) _tmp1_;
	_dvb_event_unref0 (event);
	return result;
}

static guint32
dvb_schedule_real_Next (DVBIDBusSchedule* base,
                        guint32 event_id,
                        GError** error)
{
	DVBSchedule * self;
	guint32 next_event = 0U;
	GError* _inner_error0_ = NULL;
	guint32 result;
	self = (DVBSchedule*) base;
	next_event = (guint32) 0;
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp1_;
			_tmp1_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp1_, (guint) event_id)) {
				DVBEventElement* element = NULL;
				DVBEventStorage* _tmp2_;
				DVBEventElement* _tmp3_;
				DVBEventElement* next = NULL;
				DVBEventStorage* _tmp4_;
				DVBEventElement* _tmp5_;
				DVBEventElement* _tmp6_;
				DVBEventElement* _tmp7_;
				_tmp2_ = self->priv->events;
				_tmp3_ = dvb_event_storage_get_by_id (_tmp2_, (guint) event_id);
				element = _tmp3_;
				_tmp4_ = self->priv->events;
				_tmp5_ = element;
				_tmp6_ = dvb_event_storage_next (_tmp4_, _tmp5_);
				next = _tmp6_;
				_tmp7_ = next;
				if (_tmp7_ != NULL) {
					DVBEventElement* _tmp8_;
					_tmp8_ = next;
					next_event = (guint32) _tmp8_->id;
				}
				_g_object_unref0 (next);
				_g_object_unref0 (element);
			} else {
				DVBLoggingLogger* _tmp9_;
				_tmp9_ = dvb_schedule_log;
				dvb_logging_logger_debug (_tmp9_, "Schedule.vala:395: No event with id %u", (guint) event_id);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp10_;
			_tmp10_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				guint32 _tmp11_ = 0U;
				g_propagate_error (error, _inner_error0_);
				return _tmp11_;
			} else {
				guint32 _tmp12_ = 0U;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp12_;
			}
		}
	}
	result = next_event;
	return result;
}

static gboolean
dvb_schedule_real_GetName (DVBIDBusSchedule* base,
                           guint32 event_id,
                           gchar** name,
                           GError** error)
{
	DVBSchedule * self;
	gchar* _vala_name = NULL;
	gboolean ret = FALSE;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	ret = FALSE;
	_tmp0_ = g_strdup ("");
	_g_free0 (_vala_name);
	_vala_name = _tmp0_;
	{
		DVBEventStorage* _tmp1_;
		_tmp1_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp2_;
			_tmp2_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp2_, (guint) event_id)) {
				DVBEvent* event = NULL;
				DVBEvent* _tmp3_;
				gboolean _tmp4_ = FALSE;
				DVBEvent* _tmp5_;
				_tmp3_ = dvb_schedule_get_extended_event_by_id (self, (guint) event_id);
				event = _tmp3_;
				_tmp5_ = event;
				if (_tmp5_ != NULL) {
					DVBEvent* _tmp6_;
					const gchar* _tmp7_;
					_tmp6_ = event;
					_tmp7_ = _tmp6_->name;
					_tmp4_ = _tmp7_ != NULL;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					DVBEvent* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					_tmp8_ = event;
					_tmp9_ = _tmp8_->name;
					_tmp10_ = g_strdup (_tmp9_);
					_g_free0 (_vala_name);
					_vala_name = _tmp10_;
					ret = TRUE;
				}
				_dvb_event_unref0 (event);
			} else {
				DVBLoggingLogger* _tmp11_;
				_tmp11_ = dvb_schedule_log;
				dvb_logging_logger_debug (_tmp11_, "Schedule.vala:414: No event with id %u", (guint) event_id);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp12_;
			_tmp12_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp13_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				_g_free0 (_vala_name);
				return _tmp13_;
			} else {
				gboolean _tmp14_ = FALSE;
				_g_free0 (_vala_name);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp14_;
			}
		}
	}
	result = ret;
	if (name) {
		*name = _vala_name;
	} else {
		_g_free0 (_vala_name);
	}
	return result;
}

static gboolean
dvb_schedule_real_GetShortDescription (DVBIDBusSchedule* base,
                                       guint32 event_id,
                                       gchar** description,
                                       GError** error)
{
	DVBSchedule * self;
	gchar* _vala_description = NULL;
	gboolean ret = FALSE;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	ret = FALSE;
	_tmp0_ = g_strdup ("");
	_g_free0 (_vala_description);
	_vala_description = _tmp0_;
	{
		DVBEventStorage* _tmp1_;
		_tmp1_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp2_;
			_tmp2_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp2_, (guint) event_id)) {
				DVBEvent* event = NULL;
				DVBEvent* _tmp3_;
				gboolean _tmp4_ = FALSE;
				DVBEvent* _tmp5_;
				_tmp3_ = dvb_schedule_get_extended_event_by_id (self, (guint) event_id);
				event = _tmp3_;
				_tmp5_ = event;
				if (_tmp5_ != NULL) {
					DVBEvent* _tmp6_;
					const gchar* _tmp7_;
					_tmp6_ = event;
					_tmp7_ = _tmp6_->description;
					_tmp4_ = _tmp7_ != NULL;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					DVBEvent* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					_tmp8_ = event;
					_tmp9_ = _tmp8_->description;
					_tmp10_ = g_strdup (_tmp9_);
					_g_free0 (_vala_description);
					_vala_description = _tmp10_;
					ret = TRUE;
				}
				_dvb_event_unref0 (event);
			} else {
				DVBLoggingLogger* _tmp11_;
				_tmp11_ = dvb_schedule_log;
				dvb_logging_logger_debug (_tmp11_, "Schedule.vala:435: No event with id %u", (guint) event_id);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp12_;
			_tmp12_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp13_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				_g_free0 (_vala_description);
				return _tmp13_;
			} else {
				gboolean _tmp14_ = FALSE;
				_g_free0 (_vala_description);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp14_;
			}
		}
	}
	result = ret;
	if (description) {
		*description = _vala_description;
	} else {
		_g_free0 (_vala_description);
	}
	return result;
}

static gboolean
dvb_schedule_real_GetExtendedDescription (DVBIDBusSchedule* base,
                                          guint32 event_id,
                                          gchar** description,
                                          GError** error)
{
	DVBSchedule * self;
	gchar* _vala_description = NULL;
	gboolean ret = FALSE;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	ret = FALSE;
	_tmp0_ = g_strdup ("");
	_g_free0 (_vala_description);
	_vala_description = _tmp0_;
	{
		DVBEventStorage* _tmp1_;
		_tmp1_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp2_;
			_tmp2_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp2_, (guint) event_id)) {
				DVBEvent* event = NULL;
				DVBEvent* _tmp3_;
				gboolean _tmp4_ = FALSE;
				DVBEvent* _tmp5_;
				_tmp3_ = dvb_schedule_get_extended_event_by_id (self, (guint) event_id);
				event = _tmp3_;
				_tmp5_ = event;
				if (_tmp5_ != NULL) {
					DVBEvent* _tmp6_;
					const gchar* _tmp7_;
					_tmp6_ = event;
					_tmp7_ = _tmp6_->extended_description;
					_tmp4_ = _tmp7_ != NULL;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					DVBEvent* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					_tmp8_ = event;
					_tmp9_ = _tmp8_->extended_description;
					_tmp10_ = g_strdup (_tmp9_);
					_g_free0 (_vala_description);
					_vala_description = _tmp10_;
					ret = TRUE;
				}
				_dvb_event_unref0 (event);
			} else {
				DVBLoggingLogger* _tmp11_;
				_tmp11_ = dvb_schedule_log;
				dvb_logging_logger_debug (_tmp11_, "Schedule.vala:456: No event with id %u", (guint) event_id);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp12_;
			_tmp12_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp13_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				_g_free0 (_vala_description);
				return _tmp13_;
			} else {
				gboolean _tmp14_ = FALSE;
				_g_free0 (_vala_description);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp14_;
			}
		}
	}
	result = ret;
	if (description) {
		*description = _vala_description;
	} else {
		_g_free0 (_vala_description);
	}
	return result;
}

static gboolean
dvb_schedule_real_GetDuration (DVBIDBusSchedule* base,
                               guint32 event_id,
                               guint* duration,
                               GError** error)
{
	DVBSchedule * self;
	guint _vala_duration = 0U;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	ret = FALSE;
	_vala_duration = (guint) 0;
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp1_;
			_tmp1_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp1_, (guint) event_id)) {
				DVBEvent* event = NULL;
				DVBEvent* _tmp2_;
				DVBEvent* _tmp3_;
				_tmp2_ = dvb_schedule_get_extended_event_by_id (self, (guint) event_id);
				event = _tmp2_;
				_tmp3_ = event;
				if (_tmp3_ != NULL) {
					DVBEvent* _tmp4_;
					_tmp4_ = event;
					_vala_duration = _tmp4_->duration;
					ret = TRUE;
				}
				_dvb_event_unref0 (event);
			} else {
				DVBLoggingLogger* _tmp5_;
				_tmp5_ = dvb_schedule_log;
				dvb_logging_logger_debug (_tmp5_, "Schedule.vala:477: No event with id %u", (guint) event_id);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp6_;
			_tmp6_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp7_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp7_;
			} else {
				gboolean _tmp8_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp8_;
			}
		}
	}
	result = ret;
	if (duration) {
		*duration = _vala_duration;
	}
	return result;
}

static gboolean
dvb_schedule_real_GetLocalStartTime (DVBIDBusSchedule* base,
                                     guint32 event_id,
                                     guint** start_time,
                                     gint* start_time_length1,
                                     GError** error)
{
	DVBSchedule * self;
	guint* _vala_start_time = NULL;
	gint _vala_start_time_length1 = 0;
	gboolean ret = FALSE;
	guint* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	ret = FALSE;
	_tmp0_ = g_new0 (guint, 0);
	_vala_start_time = (g_free (_vala_start_time), NULL);
	_vala_start_time = _tmp0_;
	_vala_start_time_length1 = 0;
	{
		DVBEventStorage* _tmp1_;
		_tmp1_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp2_;
			_tmp2_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp2_, (guint) event_id)) {
				DVBEvent* event = NULL;
				DVBEvent* _tmp3_;
				DVBEvent* _tmp4_;
				_tmp3_ = dvb_schedule_get_extended_event_by_id (self, (guint) event_id);
				event = _tmp3_;
				_tmp4_ = event;
				if (_tmp4_ != NULL) {
					struct tm local_time = {0};
					DVBEvent* _tmp5_;
					struct tm _tmp6_ = {0};
					struct tm _tmp7_;
					gint _tmp8_ = 0;
					guint* _tmp9_;
					_tmp5_ = event;
					dvb_event_get_local_start_time (_tmp5_, &_tmp6_);
					local_time = _tmp6_;
					_tmp7_ = local_time;
					_tmp9_ = dvb_schedule_to_time_array (&_tmp7_, &_tmp8_);
					_vala_start_time = (g_free (_vala_start_time), NULL);
					_vala_start_time = _tmp9_;
					_vala_start_time_length1 = _tmp8_;
					ret = TRUE;
				}
				_dvb_event_unref0 (event);
			} else {
				DVBLoggingLogger* _tmp10_;
				_tmp10_ = dvb_schedule_log;
				dvb_logging_logger_debug (_tmp10_, "Schedule.vala:499: No event with id %u", (guint) event_id);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp11_;
			_tmp11_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp12_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				_vala_start_time = (g_free (_vala_start_time), NULL);
				return _tmp12_;
			} else {
				gboolean _tmp13_ = FALSE;
				_vala_start_time = (g_free (_vala_start_time), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp13_;
			}
		}
	}
	result = ret;
	if (start_time) {
		*start_time = _vala_start_time;
	} else {
		_vala_start_time = (g_free (_vala_start_time), NULL);
	}
	if (start_time_length1) {
		*start_time_length1 = _vala_start_time_length1;
	}
	return result;
}

static gboolean
dvb_schedule_real_GetLocalStartTimestamp (DVBIDBusSchedule* base,
                                          guint32 event_id,
                                          gint64* timestamp,
                                          GError** error)
{
	DVBSchedule * self;
	gint64 _vala_timestamp = 0LL;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	ret = FALSE;
	_vala_timestamp = (gint64) 0;
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp1_;
			_tmp1_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp1_, (guint) event_id)) {
				DVBEvent* event = NULL;
				DVBEvent* _tmp2_;
				DVBEvent* _tmp3_;
				_tmp2_ = dvb_schedule_get_extended_event_by_id (self, (guint) event_id);
				event = _tmp2_;
				_tmp3_ = event;
				if (_tmp3_ != NULL) {
					struct tm local_time = {0};
					DVBEvent* _tmp4_;
					struct tm _tmp5_ = {0};
					_tmp4_ = event;
					dvb_event_get_local_start_time (_tmp4_, &_tmp5_);
					local_time = _tmp5_;
					_vala_timestamp = (gint64) mktime (&local_time);
					ret = TRUE;
				}
				_dvb_event_unref0 (event);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp6_;
			_tmp6_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp7_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp7_;
			} else {
				gboolean _tmp8_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp8_;
			}
		}
	}
	result = ret;
	if (timestamp) {
		*timestamp = _vala_timestamp;
	}
	return result;
}

static gboolean
dvb_schedule_real_IsRunning (DVBIDBusSchedule* base,
                             guint32 event_id,
                             gboolean* running,
                             GError** error)
{
	DVBSchedule * self;
	gboolean _vala_running = FALSE;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	ret = FALSE;
	_vala_running = FALSE;
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp1_;
			_tmp1_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp1_, (guint) event_id)) {
				DVBEvent* event = NULL;
				DVBEvent* _tmp2_;
				DVBEvent* _tmp3_;
				_tmp2_ = dvb_schedule_get_extended_event_by_id (self, (guint) event_id);
				event = _tmp2_;
				_tmp3_ = event;
				if (_tmp3_ != NULL) {
					DVBEvent* _tmp4_;
					_tmp4_ = event;
					_vala_running = dvb_event_is_running (_tmp4_);
					ret = TRUE;
				}
				_dvb_event_unref0 (event);
			} else {
				DVBLoggingLogger* _tmp5_;
				_tmp5_ = dvb_schedule_log;
				dvb_logging_logger_debug (_tmp5_, "Schedule.vala:540: No event with id %u", (guint) event_id);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp6_;
			_tmp6_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp7_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp7_;
			} else {
				gboolean _tmp8_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp8_;
			}
		}
	}
	result = ret;
	if (running) {
		*running = _vala_running;
	}
	return result;
}

static gboolean
dvb_schedule_real_IsScrambled (DVBIDBusSchedule* base,
                               guint32 event_id,
                               gboolean* scrambled,
                               GError** error)
{
	DVBSchedule * self;
	gboolean _vala_scrambled = FALSE;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBSchedule*) base;
	ret = FALSE;
	_vala_scrambled = FALSE;
	{
		DVBEventStorage* _tmp0_;
		_tmp0_ = self->priv->events;
		g_rec_mutex_lock (&self->priv->__lock_events);
		{
			DVBEventStorage* _tmp1_;
			_tmp1_ = self->priv->events;
			if (dvb_event_storage_contains_event_with_id (_tmp1_, (guint) event_id)) {
				DVBEvent* event = NULL;
				DVBEvent* _tmp2_;
				DVBEvent* _tmp3_;
				_tmp2_ = dvb_schedule_get_extended_event_by_id (self, (guint) event_id);
				event = _tmp2_;
				_tmp3_ = event;
				if (_tmp3_ != NULL) {
					DVBEvent* _tmp4_;
					_tmp4_ = event;
					_vala_scrambled = !_tmp4_->free_ca_mode;
					ret = TRUE;
				}
				_dvb_event_unref0 (event);
			} else {
				DVBLoggingLogger* _tmp5_;
				_tmp5_ = dvb_schedule_log;
				dvb_logging_logger_debug (_tmp5_, "Schedule.vala:561: No event with id %u", (guint) event_id);
			}
		}
		__finally0:
		{
			DVBEventStorage* _tmp6_;
			_tmp6_ = self->priv->events;
			g_rec_mutex_unlock (&self->priv->__lock_events);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_DBUS_ERROR) {
				gboolean _tmp7_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp7_;
			} else {
				gboolean _tmp8_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp8_;
			}
		}
	}
	result = ret;
	if (scrambled) {
		*scrambled = _vala_scrambled;
	}
	return result;
}

static DVBEvent*
dvb_schedule_get_extended_event_by_id (DVBSchedule* self,
                                       guint event_id)
{
	DVBEventElement* element = NULL;
	DVBEventStorage* _tmp0_;
	DVBEventElement* _tmp1_;
	DVBEvent* _tmp2_;
	DVBEvent* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->events;
	_tmp1_ = dvb_event_storage_get_by_id (_tmp0_, event_id);
	element = _tmp1_;
	_tmp2_ = dvb_schedule_get_event (self, element->id);
	result = _tmp2_;
	_g_object_unref0 (element);
	return result;
}

static guint*
dvb_schedule_to_time_array (struct tm* local_time,
                            gint* result_length1)
{
	guint* start = NULL;
	guint* _tmp0_;
	gint start_length1;
	gint _start_size_;
	struct tm _tmp1_;
	struct tm _tmp2_;
	struct tm _tmp3_;
	struct tm _tmp4_;
	struct tm _tmp5_;
	struct tm _tmp6_;
	guint* _tmp7_;
	gint _tmp7__length1;
	guint* result;
	g_return_val_if_fail (local_time != NULL, NULL);
	_tmp0_ = g_new0 (guint, 6);
	start = _tmp0_;
	start_length1 = 6;
	_start_size_ = start_length1;
	_tmp1_ = *local_time;
	start[0] = (guint) (_tmp1_.tm_year + 1900);
	_tmp2_ = *local_time;
	start[1] = (guint) (_tmp2_.tm_mon + 1);
	_tmp3_ = *local_time;
	start[2] = (guint) _tmp3_.tm_mday;
	_tmp4_ = *local_time;
	start[3] = (guint) _tmp4_.tm_hour;
	_tmp5_ = *local_time;
	start[4] = (guint) _tmp5_.tm_min;
	_tmp6_ = *local_time;
	start[5] = (guint) _tmp6_.tm_sec;
	_tmp7_ = start;
	_tmp7__length1 = start_length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}

static void
dvb_schedule_event_to_event_info (DVBEvent* event,
                                  DVBEventInfo* result)
{
	DVBEventInfo event_info = {0};
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (event != NULL);
	memset (&event_info, 0, sizeof (DVBEventInfo));
	event_info.id = (guint32) event->id;
	_tmp0_ = event->name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (event_info.name);
	event_info.name = _tmp1_;
	event_info.duration = event->duration;
	_tmp2_ = event->description;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (event_info.short_description);
	event_info.short_description = _tmp3_;
	*result = event_info;
	return;
}

DVBChannel*
dvb_schedule_get_channel (DVBSchedule* self)
{
	DVBChannel* result;
	DVBChannel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_channel;
	result = _tmp0_;
	return result;
}

static void
dvb_schedule_set_channel (DVBSchedule* self,
                          DVBChannel* value)
{
	DVBChannel* old_value;
	g_return_if_fail (self != NULL);
	old_value = dvb_schedule_get_channel (self);
	if (old_value != value) {
		self->priv->_channel = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_schedule_properties[DVB_SCHEDULE_CHANNEL_PROPERTY]);
	}
}

static GObject *
dvb_schedule_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DVBSchedule * self;
	DVBEventStorage* _tmp0_;
	DVBFactory* _tmp1_;
	DVBFactory* _tmp2_;
	DVBdatabaseEPGStore* _tmp3_;
	parent_class = G_OBJECT_CLASS (dvb_schedule_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_SCHEDULE, DVBSchedule);
	_tmp0_ = dvb_event_storage_new ();
	_g_object_unref0 (self->priv->events);
	self->priv->events = _tmp0_;
	_tmp1_ = dvb_factory_new ();
	_tmp2_ = _tmp1_;
	_tmp3_ = dvb_factory_get_epg_store (_tmp2_);
	_g_object_unref0 (self->priv->epgstore);
	self->priv->epgstore = _tmp3_;
	_g_object_unref0 (_tmp2_);
	return obj;
}

static void
dvb_schedule_class_init (DVBScheduleClass * klass,
                         gpointer klass_data)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_schedule_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBSchedule_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_schedule_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_schedule_set_property;
	G_OBJECT_CLASS (klass)->constructor = dvb_schedule_constructor;
	G_OBJECT_CLASS (klass)->finalize = dvb_schedule_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_SCHEDULE_CHANNEL_PROPERTY, dvb_schedule_properties[DVB_SCHEDULE_CHANNEL_PROPERTY] = g_param_spec_object ("channel", "channel", "channel", DVB_TYPE_CHANNEL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_schedule_log = _tmp1_;
	g_rec_mutex_init (&dvb_schedule_mutex);
	dvb_schedule_mutex = dvb_schedule_mutex;
}

static void
dvb_schedule_dvb_id_bus_schedule_interface_init (DVBIDBusScheduleIface * iface,
                                                 gpointer iface_data)
{
	dvb_schedule_dvb_id_bus_schedule_parent_iface = g_type_interface_peek_parent (iface);
	iface->GetAllEvents = (guint32* (*) (DVBIDBusSchedule*, gint*, GError**)) dvb_schedule_real_GetAllEvents;
	iface->GetAllEventInfos = (DVBEventInfo* (*) (DVBIDBusSchedule*, gint*, GError**)) dvb_schedule_real_GetAllEventInfos;
	iface->GetInformations = (gboolean (*) (DVBIDBusSchedule*, guint32, DVBEventInfo*, GError**)) dvb_schedule_real_GetInformations;
	iface->NowPlaying = (guint32 (*) (DVBIDBusSchedule*, GError**)) dvb_schedule_real_NowPlaying;
	iface->Next = (guint32 (*) (DVBIDBusSchedule*, guint32, GError**)) dvb_schedule_real_Next;
	iface->GetName = (gboolean (*) (DVBIDBusSchedule*, guint32, gchar**, GError**)) dvb_schedule_real_GetName;
	iface->GetShortDescription = (gboolean (*) (DVBIDBusSchedule*, guint32, gchar**, GError**)) dvb_schedule_real_GetShortDescription;
	iface->GetExtendedDescription = (gboolean (*) (DVBIDBusSchedule*, guint32, gchar**, GError**)) dvb_schedule_real_GetExtendedDescription;
	iface->GetDuration = (gboolean (*) (DVBIDBusSchedule*, guint32, guint*, GError**)) dvb_schedule_real_GetDuration;
	iface->GetLocalStartTime = (gboolean (*) (DVBIDBusSchedule*, guint32, guint**, gint*, GError**)) dvb_schedule_real_GetLocalStartTime;
	iface->GetLocalStartTimestamp = (gboolean (*) (DVBIDBusSchedule*, guint32, gint64*, GError**)) dvb_schedule_real_GetLocalStartTimestamp;
	iface->IsRunning = (gboolean (*) (DVBIDBusSchedule*, guint32, gboolean*, GError**)) dvb_schedule_real_IsRunning;
	iface->IsScrambled = (gboolean (*) (DVBIDBusSchedule*, guint32, gboolean*, GError**)) dvb_schedule_real_IsScrambled;
}

static void
dvb_schedule_instance_init (DVBSchedule * self,
                            gpointer klass)
{
	self->priv = dvb_schedule_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_events);
}

static void
dvb_schedule_finalize (GObject * obj)
{
	DVBSchedule * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_SCHEDULE, DVBSchedule);
	_g_object_unref0 (self->priv->epgstore);
	g_rec_mutex_clear (&self->priv->__lock_events);
	_g_object_unref0 (self->priv->events);
	G_OBJECT_CLASS (dvb_schedule_parent_class)->finalize (obj);
}

/**
     * Represents a series of events of a channel
     */
static GType
dvb_schedule_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBScheduleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_schedule_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBSchedule), 0, (GInstanceInitFunc) dvb_schedule_instance_init, NULL };
	static const GInterfaceInfo dvb_id_bus_schedule_info = { (GInterfaceInitFunc) dvb_schedule_dvb_id_bus_schedule_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dvb_schedule_type_id;
	dvb_schedule_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBSchedule", &g_define_type_info, 0);
	g_type_add_interface_static (dvb_schedule_type_id, DVB_TYPE_ID_BUS_SCHEDULE, &dvb_id_bus_schedule_info);
	DVBSchedule_private_offset = g_type_add_instance_private (dvb_schedule_type_id, sizeof (DVBSchedulePrivate));
	return dvb_schedule_type_id;
}

GType
dvb_schedule_get_type (void)
{
	static volatile gsize dvb_schedule_type_id__once = 0;
	if (g_once_init_enter (&dvb_schedule_type_id__once)) {
		GType dvb_schedule_type_id;
		dvb_schedule_type_id = dvb_schedule_get_type_once ();
		g_once_init_leave (&dvb_schedule_type_id__once, dvb_schedule_type_id);
	}
	return dvb_schedule_type_id__once;
}

static void
_vala_dvb_schedule_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	DVBSchedule * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_SCHEDULE, DVBSchedule);
	switch (property_id) {
		case DVB_SCHEDULE_CHANNEL_PROPERTY:
		g_value_set_object (value, dvb_schedule_get_channel (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dvb_schedule_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	DVBSchedule * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_SCHEDULE, DVBSchedule);
	switch (property_id) {
		case DVB_SCHEDULE_CHANNEL_PROPERTY:
		dvb_schedule_set_channel (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

