/* EPGStore.c generated by valac 0.56.18, the Vala compiler
 * generated from EPGStore.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_DATABASE_TYPE_EPG_STORE (dvb_database_epg_store_get_type ())
#define DVB_DATABASE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStore))
#define DVB_DATABASE_IS_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_EPG_STORE))
#define DVB_DATABASE_EPG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStoreIface))

typedef struct _DVBdatabaseEPGStore DVBdatabaseEPGStore;
typedef struct _DVBdatabaseEPGStoreIface DVBdatabaseEPGStoreIface;

#define DVB_TYPE_EVENT (dvb_event_get_type ())
#define DVB_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_EVENT, DVBEvent))
#define DVB_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_EVENT, DVBEventClass))
#define DVB_IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_EVENT))
#define DVB_IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_EVENT))
#define DVB_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_EVENT, DVBEventClass))

typedef struct _DVBEvent DVBEvent;
typedef struct _DVBEventClass DVBEventClass;

#define DVB_DATABASE_TYPE_SQL_ERROR (dvb_database_sql_error_get_type ())

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()

struct _DVBdatabaseEPGStoreIface {
	GTypeInterface parent_iface;
	gboolean (*add_or_update_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	DVBEvent* (*get_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_older_than) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	gboolean (*contains_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	GeeList* (*get_events) (DVBdatabaseEPGStore* self, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_of_group) (DVBdatabaseEPGStore* self, guint group_id, GError** error);
};

VALA_EXTERN gpointer dvb_event_ref (gpointer instance);
VALA_EXTERN void dvb_event_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_param_spec_event (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void dvb_value_set_event (GValue* value,
                          gpointer v_object);
VALA_EXTERN void dvb_value_take_event (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer dvb_value_get_event (const GValue* value);
VALA_EXTERN GType dvb_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEvent, dvb_event_unref)
VALA_EXTERN GQuark dvb_database_sql_error_quark (void);
VALA_EXTERN GType dvb_database_sql_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_database_epg_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseEPGStore, g_object_unref)
VALA_EXTERN gboolean dvb_database_epg_store_add_or_update_event (DVBdatabaseEPGStore* self,
                                                     DVBEvent* event,
                                                     guint channel_sid,
                                                     guint group_id,
                                                     GError** error);
VALA_EXTERN DVBEvent* dvb_database_epg_store_get_event (DVBdatabaseEPGStore* self,
                                            guint event_id,
                                            guint channel_sid,
                                            guint group_id,
                                            GError** error);
VALA_EXTERN gboolean dvb_database_epg_store_remove_event (DVBdatabaseEPGStore* self,
                                              guint event_id,
                                              guint channel_sid,
                                              guint group_id,
                                              GError** error);
VALA_EXTERN gboolean dvb_database_epg_store_remove_events_older_than (DVBdatabaseEPGStore* self,
                                                          DVBEvent* event,
                                                          guint channel_sid,
                                                          guint group_id,
                                                          GError** error);
VALA_EXTERN gboolean dvb_database_epg_store_contains_event (DVBdatabaseEPGStore* self,
                                                DVBEvent* event,
                                                guint channel_sid,
                                                guint group_id,
                                                GError** error);
VALA_EXTERN GeeList* dvb_database_epg_store_get_events (DVBdatabaseEPGStore* self,
                                            guint channel_sid,
                                            guint group_id,
                                            GError** error);
VALA_EXTERN gboolean dvb_database_epg_store_remove_events_of_group (DVBdatabaseEPGStore* self,
                                                        guint group_id,
                                                        GError** error);
static GType dvb_database_epg_store_get_type_once (void);

gboolean
dvb_database_epg_store_add_or_update_event (DVBdatabaseEPGStore* self,
                                            DVBEvent* event,
                                            guint channel_sid,
                                            guint group_id,
                                            GError** error)
{
	DVBdatabaseEPGStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_EPG_STORE_GET_INTERFACE (self);
	if (_iface_->add_or_update_event) {
		return _iface_->add_or_update_event (self, event, channel_sid, group_id, error);
	}
	return FALSE;
}

DVBEvent*
dvb_database_epg_store_get_event (DVBdatabaseEPGStore* self,
                                  guint event_id,
                                  guint channel_sid,
                                  guint group_id,
                                  GError** error)
{
	DVBdatabaseEPGStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_DATABASE_EPG_STORE_GET_INTERFACE (self);
	if (_iface_->get_event) {
		return _iface_->get_event (self, event_id, channel_sid, group_id, error);
	}
	return NULL;
}

gboolean
dvb_database_epg_store_remove_event (DVBdatabaseEPGStore* self,
                                     guint event_id,
                                     guint channel_sid,
                                     guint group_id,
                                     GError** error)
{
	DVBdatabaseEPGStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_EPG_STORE_GET_INTERFACE (self);
	if (_iface_->remove_event) {
		return _iface_->remove_event (self, event_id, channel_sid, group_id, error);
	}
	return FALSE;
}

gboolean
dvb_database_epg_store_remove_events_older_than (DVBdatabaseEPGStore* self,
                                                 DVBEvent* event,
                                                 guint channel_sid,
                                                 guint group_id,
                                                 GError** error)
{
	DVBdatabaseEPGStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_EPG_STORE_GET_INTERFACE (self);
	if (_iface_->remove_events_older_than) {
		return _iface_->remove_events_older_than (self, event, channel_sid, group_id, error);
	}
	return FALSE;
}

gboolean
dvb_database_epg_store_contains_event (DVBdatabaseEPGStore* self,
                                       DVBEvent* event,
                                       guint channel_sid,
                                       guint group_id,
                                       GError** error)
{
	DVBdatabaseEPGStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_EPG_STORE_GET_INTERFACE (self);
	if (_iface_->contains_event) {
		return _iface_->contains_event (self, event, channel_sid, group_id, error);
	}
	return FALSE;
}

GeeList*
dvb_database_epg_store_get_events (DVBdatabaseEPGStore* self,
                                   guint channel_sid,
                                   guint group_id,
                                   GError** error)
{
	DVBdatabaseEPGStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_DATABASE_EPG_STORE_GET_INTERFACE (self);
	if (_iface_->get_events) {
		return _iface_->get_events (self, channel_sid, group_id, error);
	}
	return NULL;
}

gboolean
dvb_database_epg_store_remove_events_of_group (DVBdatabaseEPGStore* self,
                                               guint group_id,
                                               GError** error)
{
	DVBdatabaseEPGStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_EPG_STORE_GET_INTERFACE (self);
	if (_iface_->remove_events_of_group) {
		return _iface_->remove_events_of_group (self, group_id, error);
	}
	return FALSE;
}

static void
dvb_database_epg_store_default_init (DVBdatabaseEPGStoreIface * iface,
                                     gpointer iface_data)
{
}

static GType
dvb_database_epg_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBdatabaseEPGStoreIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_database_epg_store_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dvb_database_epg_store_type_id;
	dvb_database_epg_store_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBdatabaseEPGStore", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dvb_database_epg_store_type_id, G_TYPE_OBJECT);
	return dvb_database_epg_store_type_id;
}

GType
dvb_database_epg_store_get_type (void)
{
	static volatile gsize dvb_database_epg_store_type_id__once = 0;
	if (g_once_init_enter (&dvb_database_epg_store_type_id__once)) {
		GType dvb_database_epg_store_type_id;
		dvb_database_epg_store_type_id = dvb_database_epg_store_get_type_once ();
		g_once_init_leave (&dvb_database_epg_store_type_id__once, dvb_database_epg_store_type_id);
	}
	return dvb_database_epg_store_type_id__once;
}

