/* TimersStore.c generated by valac 0.56.18, the Vala compiler
 * generated from TimersStore.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_DATABASE_TYPE_TIMERS_STORE (dvb_database_timers_store_get_type ())
#define DVB_DATABASE_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_TIMERS_STORE, DVBdatabaseTimersStore))
#define DVB_DATABASE_IS_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_TIMERS_STORE))
#define DVB_DATABASE_TIMERS_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_TIMERS_STORE, DVBdatabaseTimersStoreIface))

typedef struct _DVBdatabaseTimersStore DVBdatabaseTimersStore;
typedef struct _DVBdatabaseTimersStoreIface DVBdatabaseTimersStoreIface;

#define DVB_TYPE_DEVICE_GROUP (dvb_device_group_get_type ())
#define DVB_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup))
#define DVB_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))
#define DVB_IS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE_GROUP))
#define DVB_IS_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE_GROUP))
#define DVB_DEVICE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))

typedef struct _DVBDeviceGroup DVBDeviceGroup;
typedef struct _DVBDeviceGroupClass DVBDeviceGroupClass;

#define DVB_TYPE_TIMER (dvb_timer_get_type ())
#define DVB_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_TIMER, DVBTimer))
#define DVB_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_TIMER, DVBTimerClass))
#define DVB_IS_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_TIMER))
#define DVB_IS_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_TIMER))
#define DVB_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_TIMER, DVBTimerClass))

typedef struct _DVBTimer DVBTimer;
typedef struct _DVBTimerClass DVBTimerClass;

#define DVB_DATABASE_TYPE_SQL_ERROR (dvb_database_sql_error_get_type ())

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()

struct _DVBdatabaseTimersStoreIface {
	GTypeInterface parent_iface;
	GeeList* (*get_all_timers_of_device_group) (DVBdatabaseTimersStore* self, DVBDeviceGroup* dev, GError** error);
	gboolean (*add_timer_to_device_group) (DVBdatabaseTimersStore* self, DVBTimer* timer, DVBDeviceGroup* dev, GError** error);
	gboolean (*remove_timer_from_device_group) (DVBdatabaseTimersStore* self, guint timer_id, DVBDeviceGroup* dev, GError** error);
	gboolean (*remove_all_timers_from_device_group) (DVBdatabaseTimersStore* self, guint group_id, GError** error);
	gboolean (*update_timer) (DVBdatabaseTimersStore* self, DVBTimer* timer, DVBDeviceGroup* dev, GError** error);
};

VALA_EXTERN GType dvb_device_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBDeviceGroup, g_object_unref)
VALA_EXTERN GType dvb_timer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBTimer, g_object_unref)
VALA_EXTERN GQuark dvb_database_sql_error_quark (void);
VALA_EXTERN GType dvb_database_sql_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType dvb_database_timers_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseTimersStore, g_object_unref)
VALA_EXTERN GeeList* dvb_database_timers_store_get_all_timers_of_device_group (DVBdatabaseTimersStore* self,
                                                                   DVBDeviceGroup* dev,
                                                                   GError** error);
VALA_EXTERN gboolean dvb_database_timers_store_add_timer_to_device_group (DVBdatabaseTimersStore* self,
                                                              DVBTimer* timer,
                                                              DVBDeviceGroup* dev,
                                                              GError** error);
VALA_EXTERN gboolean dvb_database_timers_store_remove_timer_from_device_group (DVBdatabaseTimersStore* self,
                                                                   guint timer_id,
                                                                   DVBDeviceGroup* dev,
                                                                   GError** error);
VALA_EXTERN gboolean dvb_database_timers_store_remove_all_timers_from_device_group (DVBdatabaseTimersStore* self,
                                                                        guint group_id,
                                                                        GError** error);
VALA_EXTERN gboolean dvb_database_timers_store_update_timer (DVBdatabaseTimersStore* self,
                                                 DVBTimer* timer,
                                                 DVBDeviceGroup* dev,
                                                 GError** error);
static GType dvb_database_timers_store_get_type_once (void);

GeeList*
dvb_database_timers_store_get_all_timers_of_device_group (DVBdatabaseTimersStore* self,
                                                          DVBDeviceGroup* dev,
                                                          GError** error)
{
	DVBdatabaseTimersStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = DVB_DATABASE_TIMERS_STORE_GET_INTERFACE (self);
	if (_iface_->get_all_timers_of_device_group) {
		return _iface_->get_all_timers_of_device_group (self, dev, error);
	}
	return NULL;
}

gboolean
dvb_database_timers_store_add_timer_to_device_group (DVBdatabaseTimersStore* self,
                                                     DVBTimer* timer,
                                                     DVBDeviceGroup* dev,
                                                     GError** error)
{
	DVBdatabaseTimersStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_TIMERS_STORE_GET_INTERFACE (self);
	if (_iface_->add_timer_to_device_group) {
		return _iface_->add_timer_to_device_group (self, timer, dev, error);
	}
	return FALSE;
}

gboolean
dvb_database_timers_store_remove_timer_from_device_group (DVBdatabaseTimersStore* self,
                                                          guint timer_id,
                                                          DVBDeviceGroup* dev,
                                                          GError** error)
{
	DVBdatabaseTimersStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_TIMERS_STORE_GET_INTERFACE (self);
	if (_iface_->remove_timer_from_device_group) {
		return _iface_->remove_timer_from_device_group (self, timer_id, dev, error);
	}
	return FALSE;
}

gboolean
dvb_database_timers_store_remove_all_timers_from_device_group (DVBdatabaseTimersStore* self,
                                                               guint group_id,
                                                               GError** error)
{
	DVBdatabaseTimersStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_TIMERS_STORE_GET_INTERFACE (self);
	if (_iface_->remove_all_timers_from_device_group) {
		return _iface_->remove_all_timers_from_device_group (self, group_id, error);
	}
	return FALSE;
}

gboolean
dvb_database_timers_store_update_timer (DVBdatabaseTimersStore* self,
                                        DVBTimer* timer,
                                        DVBDeviceGroup* dev,
                                        GError** error)
{
	DVBdatabaseTimersStoreIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DVB_DATABASE_TIMERS_STORE_GET_INTERFACE (self);
	if (_iface_->update_timer) {
		return _iface_->update_timer (self, timer, dev, error);
	}
	return FALSE;
}

static void
dvb_database_timers_store_default_init (DVBdatabaseTimersStoreIface * iface,
                                        gpointer iface_data)
{
}

static GType
dvb_database_timers_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBdatabaseTimersStoreIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_database_timers_store_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType dvb_database_timers_store_type_id;
	dvb_database_timers_store_type_id = g_type_register_static (G_TYPE_INTERFACE, "DVBdatabaseTimersStore", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (dvb_database_timers_store_type_id, G_TYPE_OBJECT);
	return dvb_database_timers_store_type_id;
}

GType
dvb_database_timers_store_get_type (void)
{
	static volatile gsize dvb_database_timers_store_type_id__once = 0;
	if (g_once_init_enter (&dvb_database_timers_store_type_id__once)) {
		GType dvb_database_timers_store_type_id;
		dvb_database_timers_store_type_id = dvb_database_timers_store_get_type_once ();
		g_once_init_leave (&dvb_database_timers_store_type_id__once, dvb_database_timers_store_type_id);
	}
	return dvb_database_timers_store_type_id__once;
}

