/* SqliteEPGStore.c generated by valac 0.56.18, the Vala compiler
 * generated from SqliteEPGStore.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <sqlite3.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <time.h>
#include <stdio.h>

#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_VERSION 2
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_CREATE_EVENTS_TABLE_STATEMENT "CREATE TABLE events (group_id INTEGER,\n" \
"            sid INTEGER,\n" \
"            event_id INTEGER,\n" \
"            starttime JULIAN,\n" \
"            duration INTEGER,\n" \
"            running_status INTEGER(2),\n" \
"            free_ca_mode INTEGER(1),\n" \
"            name VARCHAR(255),\n" \
"            description VARCHAR(255),\n" \
"            extended_description TEXT,\n" \
"            PRIMARY KEY (group_id, sid, event_id))"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_INSERT_EVENT_SQL "INSERT INTO events VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_DELETE_EVENT_STATEMENT "DELETE FROM events WHERE group_id=? AND sid=? AND event_id=?"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_SELECT_ALL_EVENTS_STATEMENT "SELECT event_id, datetime(starttime),\n" \
"            duration, running_status, free_ca_mode, name,\n" \
"            description, extended_description\n" \
"            FROM events WHERE group_id='%u' AND sid='%u'"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_SELECT_MINIMAL_EVENTS_STATEMENT "SELECT event_id, datetime(starttime),\n" \
"            duration FROM events WHERE group_id='%u' AND sid='%u'\n" \
"            ORDER BY starttime ASC"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_HAS_EVENT_STATEMENT "SELECT 1 FROM events WHERE group_id=? AND sid=? AND event_id=? LIMIT 1"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_UPDATE_EVENT_SQL "UPDATE events SET starttime=?, duration=?, running_status=?,\n" \
"            free_ca_mode=?, name=?, description=?,\n" \
"            extended_description=? WHERE group_id=? AND sid=? AND even" \
"t_id=?"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_TO_JULIAN_SQL "SELECT julianday(?)"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_SELECT_EVENT_SQL "SELECT event_id, datetime(starttime),\n" \
"            duration, running_status, free_ca_mode, name,\n" \
"            description, extended_description\n" \
"            FROM events WHERE group_id=? AND sid=? AND event_id=?"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_DELETE_EVENTS_GROUP "DELETE FROM events WHERE group_id=?"
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_DELETE_EXPIRED_EVENTS "DELETE FROM events WHERE starttime <= julianday(?, 'unixepoch')\n" \
"        AND sid=? AND group_id=?"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE (dvb_database_sqlite_sqlite_database_get_type ())
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase))
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabaseClass))
#define DVB_DATABASE_SQLITE_IS_SQLITE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE))
#define DVB_DATABASE_SQLITE_IS_SQLITE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE))
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabaseClass))

typedef struct _DVBdatabasesqliteSqliteDatabase DVBdatabasesqliteSqliteDatabase;
typedef struct _DVBdatabasesqliteSqliteDatabaseClass DVBdatabasesqliteSqliteDatabaseClass;
typedef struct _DVBdatabasesqliteSqliteDatabasePrivate DVBdatabasesqliteSqliteDatabasePrivate;

#define DVB_DATABASE_TYPE_SQL_ERROR (dvb_database_sql_error_get_type ())

#define DVB_DATABASE_TYPE_EPG_STORE (dvb_database_epg_store_get_type ())
#define DVB_DATABASE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStore))
#define DVB_DATABASE_IS_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_EPG_STORE))
#define DVB_DATABASE_EPG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStoreIface))

typedef struct _DVBdatabaseEPGStore DVBdatabaseEPGStore;
typedef struct _DVBdatabaseEPGStoreIface DVBdatabaseEPGStoreIface;

#define DVB_TYPE_EVENT (dvb_event_get_type ())
#define DVB_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_EVENT, DVBEvent))
#define DVB_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_EVENT, DVBEventClass))
#define DVB_IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_EVENT))
#define DVB_IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_EVENT))
#define DVB_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_EVENT, DVBEventClass))

typedef struct _DVBEvent DVBEvent;
typedef struct _DVBEventClass DVBEventClass;

#define DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE (dvb_database_sqlite_sqlite_epg_store_get_type ())
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE, DVBdatabasesqliteSqliteEPGStore))
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE, DVBdatabasesqliteSqliteEPGStoreClass))
#define DVB_DATABASE_SQLITE_IS_SQLITE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE))
#define DVB_DATABASE_SQLITE_IS_SQLITE_EPG_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE))
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE, DVBdatabasesqliteSqliteEPGStoreClass))

typedef struct _DVBdatabasesqliteSqliteEPGStore DVBdatabasesqliteSqliteEPGStore;
typedef struct _DVBdatabasesqliteSqliteEPGStoreClass DVBdatabasesqliteSqliteEPGStoreClass;
typedef struct _DVBdatabasesqliteSqliteEPGStorePrivate DVBdatabasesqliteSqliteEPGStorePrivate;
enum  {
	DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_0_PROPERTY,
	DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_NUM_PROPERTIES
};
static GParamSpec* dvb_database_sqlite_sqlite_epg_store_properties[DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _DVBEventPrivate DVBEventPrivate;

#define DVB_EVENT_TYPE_AUDIO_COMPONENT (dvb_event_audio_component_get_type ())
#define DVB_EVENT_AUDIO_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_EVENT_TYPE_AUDIO_COMPONENT, DVBEventAudioComponent))
#define DVB_EVENT_AUDIO_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_EVENT_TYPE_AUDIO_COMPONENT, DVBEventAudioComponentClass))
#define DVB_EVENT_IS_AUDIO_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_EVENT_TYPE_AUDIO_COMPONENT))
#define DVB_EVENT_IS_AUDIO_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_EVENT_TYPE_AUDIO_COMPONENT))
#define DVB_EVENT_AUDIO_COMPONENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_EVENT_TYPE_AUDIO_COMPONENT, DVBEventAudioComponentClass))

typedef struct _DVBEventAudioComponent DVBEventAudioComponent;
typedef struct _DVBEventAudioComponentClass DVBEventAudioComponentClass;

#define DVB_EVENT_TYPE_VIDEO_COMPONENT (dvb_event_video_component_get_type ())
#define DVB_EVENT_VIDEO_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_EVENT_TYPE_VIDEO_COMPONENT, DVBEventVideoComponent))
#define DVB_EVENT_VIDEO_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_EVENT_TYPE_VIDEO_COMPONENT, DVBEventVideoComponentClass))
#define DVB_EVENT_IS_VIDEO_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_EVENT_TYPE_VIDEO_COMPONENT))
#define DVB_EVENT_IS_VIDEO_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_EVENT_TYPE_VIDEO_COMPONENT))
#define DVB_EVENT_VIDEO_COMPONENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_EVENT_TYPE_VIDEO_COMPONENT, DVBEventVideoComponentClass))

typedef struct _DVBEventVideoComponent DVBEventVideoComponent;
typedef struct _DVBEventVideoComponentClass DVBEventVideoComponentClass;

#define DVB_EVENT_TYPE_TELETEXT_COMPONENT (dvb_event_teletext_component_get_type ())
#define DVB_EVENT_TELETEXT_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_EVENT_TYPE_TELETEXT_COMPONENT, DVBEventTeletextComponent))
#define DVB_EVENT_TELETEXT_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_EVENT_TYPE_TELETEXT_COMPONENT, DVBEventTeletextComponentClass))
#define DVB_EVENT_IS_TELETEXT_COMPONENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_EVENT_TYPE_TELETEXT_COMPONENT))
#define DVB_EVENT_IS_TELETEXT_COMPONENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_EVENT_TYPE_TELETEXT_COMPONENT))
#define DVB_EVENT_TELETEXT_COMPONENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_EVENT_TYPE_TELETEXT_COMPONENT, DVBEventTeletextComponentClass))

typedef struct _DVBEventTeletextComponent DVBEventTeletextComponent;
typedef struct _DVBEventTeletextComponentClass DVBEventTeletextComponentClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _dvb_event_unref0(var) ((var == NULL) ? NULL : (var = (dvb_event_unref (var), NULL)))
#define _dvb_event_video_component_unref0(var) ((var == NULL) ? NULL : (var = (dvb_event_video_component_unref (var), NULL)))

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()

struct _DVBdatabasesqliteSqliteDatabase {
	GObject parent_instance;
	DVBdatabasesqliteSqliteDatabasePrivate * priv;
	sqlite3* db;
};

struct _DVBdatabasesqliteSqliteDatabaseClass {
	GObjectClass parent_class;
	void (*create) (DVBdatabasesqliteSqliteDatabase* self, GError** error);
	void (*upgrade) (DVBdatabasesqliteSqliteDatabase* self, gint old_version, gint new_version, GError** error);
	void (*on_open) (DVBdatabasesqliteSqliteDatabase* self);
};

struct _DVBdatabaseEPGStoreIface {
	GTypeInterface parent_iface;
	gboolean (*add_or_update_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	DVBEvent* (*get_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_older_than) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	gboolean (*contains_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	GeeList* (*get_events) (DVBdatabaseEPGStore* self, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_of_group) (DVBdatabaseEPGStore* self, guint group_id, GError** error);
};

struct _DVBdatabasesqliteSqliteEPGStore {
	DVBdatabasesqliteSqliteDatabase parent_instance;
	DVBdatabasesqliteSqliteEPGStorePrivate * priv;
};

struct _DVBdatabasesqliteSqliteEPGStoreClass {
	DVBdatabasesqliteSqliteDatabaseClass parent_class;
};

struct _DVBdatabasesqliteSqliteEPGStorePrivate {
	sqlite3_stmt* to_julian_statement;
	sqlite3_stmt* insert_event_statement;
	sqlite3_stmt* update_event_statement;
	sqlite3_stmt* delete_event_statement;
	sqlite3_stmt* has_event_statement;
	sqlite3_stmt* select_event_statement;
	sqlite3_stmt* delete_events_group;
	sqlite3_stmt* delete_expired_events;
};

struct _DVBEvent {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DVBEventPrivate * priv;
	guint id;
	guint year;
	guint month;
	guint hour;
	guint day;
	guint minute;
	guint second;
	guint duration;
	guint running_status;
	gboolean free_ca_mode;
	gchar* name;
	gchar* description;
	gchar* extended_description;
	GSList* audio_components;
	DVBEventVideoComponent* video_component;
	GSList* teletext_components;
};

struct _DVBEventClass {
	GTypeClass parent_class;
	void (*finalize) (DVBEvent *self);
};

static gint DVBdatabasesqliteSqliteEPGStore_private_offset;
static gpointer dvb_database_sqlite_sqlite_epg_store_parent_class = NULL;
static DVBLoggingLogger* dvb_database_sqlite_sqlite_epg_store_log;
static DVBLoggingLogger* dvb_database_sqlite_sqlite_epg_store_log = NULL;
static DVBdatabaseEPGStoreIface * dvb_database_sqlite_sqlite_epg_store_dvb_database_epg_store_parent_iface = NULL;

VALA_EXTERN GType dvb_database_sqlite_sqlite_database_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabasesqliteSqliteDatabase, g_object_unref)
VALA_EXTERN GQuark dvb_database_sql_error_quark (void);
VALA_EXTERN GType dvb_database_sql_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer dvb_event_ref (gpointer instance);
VALA_EXTERN void dvb_event_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_param_spec_event (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void dvb_value_set_event (GValue* value,
                          gpointer v_object);
VALA_EXTERN void dvb_value_take_event (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer dvb_value_get_event (const GValue* value);
VALA_EXTERN GType dvb_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEvent, dvb_event_unref)
VALA_EXTERN GType dvb_database_epg_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabaseEPGStore, g_object_unref)
VALA_EXTERN GType dvb_database_sqlite_sqlite_epg_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBdatabasesqliteSqliteEPGStore, g_object_unref)
VALA_EXTERN void dvb_database_sqlite_sqlite_database_on_open (DVBdatabasesqliteSqliteDatabase* self);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_create (DVBdatabasesqliteSqliteDatabase* self,
                                                 GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_upgrade (DVBdatabasesqliteSqliteDatabase* self,
                                                  gint old_version,
                                                  gint new_version,
                                                  GError** error);
VALA_EXTERN GType dvb_logging_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogger, g_object_unref)
VALA_EXTERN GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBLoggingLogManager, g_object_unref)
VALA_EXTERN DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
VALA_EXTERN DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
VALA_EXTERN DVBdatabasesqliteSqliteEPGStore* dvb_database_sqlite_sqlite_epg_store_new (void);
VALA_EXTERN DVBdatabasesqliteSqliteEPGStore* dvb_database_sqlite_sqlite_epg_store_construct (GType object_type);
VALA_EXTERN DVBdatabasesqliteSqliteDatabase* dvb_database_sqlite_sqlite_database_construct (GType object_type,
                                                                                GFile* dbfile,
                                                                                gint version);
static void dvb_database_sqlite_sqlite_epg_store_real_on_open (DVBdatabasesqliteSqliteDatabase* base);
static void dvb_database_sqlite_sqlite_epg_store_real_create (DVBdatabasesqliteSqliteDatabase* base,
                                                       GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_exec_sql (DVBdatabasesqliteSqliteDatabase* self,
                                                   const gchar* sql,
                                                   GError** error);
static void dvb_database_sqlite_sqlite_epg_store_real_upgrade (DVBdatabasesqliteSqliteDatabase* base,
                                                        gint old_version,
                                                        gint new_version,
                                                        GError** error);
static gboolean dvb_database_sqlite_sqlite_epg_store_real_add_or_update_event (DVBdatabaseEPGStore* base,
                                                                        DVBEvent* event,
                                                                        guint channel_sid,
                                                                        guint group_id,
                                                                        GError** error);
VALA_EXTERN gpointer dvb_event_audio_component_ref (gpointer instance);
VALA_EXTERN void dvb_event_audio_component_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_event_param_spec_audio_component (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void dvb_event_value_set_audio_component (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void dvb_event_value_take_audio_component (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer dvb_event_value_get_audio_component (const GValue* value);
VALA_EXTERN GType dvb_event_audio_component_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEventAudioComponent, dvb_event_audio_component_unref)
VALA_EXTERN gpointer dvb_event_video_component_ref (gpointer instance);
VALA_EXTERN void dvb_event_video_component_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_event_param_spec_video_component (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void dvb_event_value_set_video_component (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void dvb_event_value_take_video_component (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer dvb_event_value_get_video_component (const GValue* value);
VALA_EXTERN GType dvb_event_video_component_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEventVideoComponent, dvb_event_video_component_unref)
VALA_EXTERN gpointer dvb_event_teletext_component_ref (gpointer instance);
VALA_EXTERN void dvb_event_teletext_component_unref (gpointer instance);
VALA_EXTERN GParamSpec* dvb_event_param_spec_teletext_component (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
VALA_EXTERN void dvb_event_value_set_teletext_component (GValue* value,
                                             gpointer v_object);
VALA_EXTERN void dvb_event_value_take_teletext_component (GValue* value,
                                              gpointer v_object);
VALA_EXTERN gpointer dvb_event_value_get_teletext_component (const GValue* value);
VALA_EXTERN GType dvb_event_teletext_component_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DVBEventTeletextComponent, dvb_event_teletext_component_unref)
VALA_EXTERN gchar* dvb_database_sqlite_utils_escape (const gchar* text);
static gdouble dvb_database_sqlite_sqlite_epg_store_to_julian (DVBdatabasesqliteSqliteEPGStore* self,
                                                        guint year,
                                                        guint month,
                                                        guint day,
                                                        guint hour,
                                                        guint minute,
                                                        guint second,
                                                        GError** error);
VALA_EXTERN void dvb_logging_logger_warning (DVBLoggingLogger* self,
                                 const gchar* format,
                                 ...)  G_GNUC_PRINTF(2,3) ;
VALA_EXTERN gboolean dvb_database_epg_store_contains_event (DVBdatabaseEPGStore* self,
                                                DVBEvent* event,
                                                guint channel_sid,
                                                guint group_id,
                                                GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_throw_last_error (DVBdatabasesqliteSqliteDatabase* self,
                                                           const gchar* errmsg,
                                                           GError** error);
VALA_EXTERN void dvb_database_sqlite_sqlite_database_throw_last_error_reset (DVBdatabasesqliteSqliteDatabase* self,
                                                                 sqlite3_stmt* stmnt,
                                                                 GError** error);
static DVBEvent* dvb_database_sqlite_sqlite_epg_store_real_get_event (DVBdatabaseEPGStore* base,
                                                               guint event_id,
                                                               guint channel_sid,
                                                               guint group_id,
                                                               GError** error);
static DVBEvent* dvb_database_sqlite_sqlite_epg_store_create_event_from_statement (DVBdatabasesqliteSqliteEPGStore* self,
                                                                            sqlite3_stmt* statement);
static gboolean dvb_database_sqlite_sqlite_epg_store_real_remove_event (DVBdatabaseEPGStore* base,
                                                                 guint event_id,
                                                                 guint channel_sid,
                                                                 guint group_id,
                                                                 GError** error);
static gboolean dvb_database_sqlite_sqlite_epg_store_real_remove_events_older_than (DVBdatabaseEPGStore* base,
                                                                             DVBEvent* event,
                                                                             guint channel_sid,
                                                                             guint group_id,
                                                                             GError** error);
VALA_EXTERN time_t dvb_event_get_end_timestamp (DVBEvent* self);
static gboolean dvb_database_sqlite_sqlite_epg_store_real_contains_event (DVBdatabaseEPGStore* base,
                                                                   DVBEvent* event,
                                                                   guint channel_sid,
                                                                   guint group_id,
                                                                   GError** error);
static GeeList* dvb_database_sqlite_sqlite_epg_store_real_get_events (DVBdatabaseEPGStore* base,
                                                               guint channel_sid,
                                                               guint group_id,
                                                               GError** error);
static DVBEvent* dvb_database_sqlite_sqlite_epg_store_create_minimal_event (DVBdatabasesqliteSqliteEPGStore* self,
                                                                     sqlite3_stmt* statement);
static gboolean dvb_database_sqlite_sqlite_epg_store_real_remove_events_of_group (DVBdatabaseEPGStore* base,
                                                                           guint group_id,
                                                                           GError** error);
VALA_EXTERN DVBEvent* dvb_event_new (void);
VALA_EXTERN DVBEvent* dvb_event_construct (GType object_type);
VALA_EXTERN gchar* dvb_database_sqlite_utils_unescape (const gchar* text);
static void _dvb_event_audio_component_unref0_ (gpointer var);
static inline void _g_slist_free__dvb_event_audio_component_unref0_ (GSList* self);
static void _dvb_event_teletext_component_unref0_ (gpointer var);
static inline void _g_slist_free__dvb_event_teletext_component_unref0_ (GSList* self);
VALA_EXTERN gboolean dvb_database_epg_store_add_or_update_event (DVBdatabaseEPGStore* self,
                                                     DVBEvent* event,
                                                     guint channel_sid,
                                                     guint group_id,
                                                     GError** error);
VALA_EXTERN DVBEvent* dvb_database_epg_store_get_event (DVBdatabaseEPGStore* self,
                                            guint event_id,
                                            guint channel_sid,
                                            guint group_id,
                                            GError** error);
VALA_EXTERN gboolean dvb_database_epg_store_remove_event (DVBdatabaseEPGStore* self,
                                              guint event_id,
                                              guint channel_sid,
                                              guint group_id,
                                              GError** error);
VALA_EXTERN gboolean dvb_database_epg_store_remove_events_older_than (DVBdatabaseEPGStore* self,
                                                          DVBEvent* event,
                                                          guint channel_sid,
                                                          guint group_id,
                                                          GError** error);
VALA_EXTERN GeeList* dvb_database_epg_store_get_events (DVBdatabaseEPGStore* self,
                                            guint channel_sid,
                                            guint group_id,
                                            GError** error);
VALA_EXTERN gboolean dvb_database_epg_store_remove_events_of_group (DVBdatabaseEPGStore* self,
                                                        guint group_id,
                                                        GError** error);
static void dvb_database_sqlite_sqlite_epg_store_finalize (GObject * obj);
static GType dvb_database_sqlite_sqlite_epg_store_get_type_once (void);

static inline gpointer
dvb_database_sqlite_sqlite_epg_store_get_instance_private (DVBdatabasesqliteSqliteEPGStore* self)
{
	return G_STRUCT_MEMBER_P (self, DVBdatabasesqliteSqliteEPGStore_private_offset);
}

DVBdatabasesqliteSqliteEPGStore*
dvb_database_sqlite_sqlite_epg_store_construct (GType object_type)
{
	DVBdatabasesqliteSqliteEPGStore * self = NULL;
	GFile* cache_dir = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* our_cache = NULL;
	GFile* _tmp2_;
	GFile* database_file = NULL;
	GFile* _tmp3_;
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_file_new_for_path (_tmp0_);
	cache_dir = _tmp1_;
	_tmp2_ = g_file_get_child (cache_dir, "gnome-dvb-daemon");
	our_cache = _tmp2_;
	_tmp3_ = g_file_get_child (our_cache, "eventsdb.sqlite3");
	database_file = _tmp3_;
	self = (DVBdatabasesqliteSqliteEPGStore*) dvb_database_sqlite_sqlite_database_construct (object_type, database_file, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_VERSION);
	_g_object_unref0 (database_file);
	_g_object_unref0 (our_cache);
	_g_object_unref0 (cache_dir);
	return self;
}

DVBdatabasesqliteSqliteEPGStore*
dvb_database_sqlite_sqlite_epg_store_new (void)
{
	return dvb_database_sqlite_sqlite_epg_store_construct (DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE);
}

static void
dvb_database_sqlite_sqlite_epg_store_real_on_open (DVBdatabasesqliteSqliteDatabase* base)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	sqlite3* _tmp4_;
	sqlite3_stmt* _tmp5_ = NULL;
	sqlite3* _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3* _tmp8_;
	sqlite3_stmt* _tmp9_ = NULL;
	sqlite3* _tmp10_;
	sqlite3_stmt* _tmp11_ = NULL;
	sqlite3* _tmp12_;
	sqlite3_stmt* _tmp13_ = NULL;
	sqlite3* _tmp14_;
	sqlite3_stmt* _tmp15_ = NULL;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	_tmp0_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	sqlite3_prepare (_tmp0_, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_TO_JULIAN_SQL, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (self->priv->to_julian_statement);
	self->priv->to_julian_statement = _tmp1_;
	_tmp2_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	sqlite3_prepare (_tmp2_, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_INSERT_EVENT_SQL, -1, &_tmp3_, NULL);
	_sqlite3_finalize0 (self->priv->insert_event_statement);
	self->priv->insert_event_statement = _tmp3_;
	_tmp4_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	sqlite3_prepare (_tmp4_, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_UPDATE_EVENT_SQL, -1, &_tmp5_, NULL);
	_sqlite3_finalize0 (self->priv->update_event_statement);
	self->priv->update_event_statement = _tmp5_;
	_tmp6_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	sqlite3_prepare (_tmp6_, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_DELETE_EVENT_STATEMENT, -1, &_tmp7_, NULL);
	_sqlite3_finalize0 (self->priv->delete_event_statement);
	self->priv->delete_event_statement = _tmp7_;
	_tmp8_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	sqlite3_prepare (_tmp8_, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_HAS_EVENT_STATEMENT, -1, &_tmp9_, NULL);
	_sqlite3_finalize0 (self->priv->has_event_statement);
	self->priv->has_event_statement = _tmp9_;
	_tmp10_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	sqlite3_prepare (_tmp10_, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_SELECT_EVENT_SQL, -1, &_tmp11_, NULL);
	_sqlite3_finalize0 (self->priv->select_event_statement);
	self->priv->select_event_statement = _tmp11_;
	_tmp12_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	sqlite3_prepare (_tmp12_, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_DELETE_EVENTS_GROUP, -1, &_tmp13_, NULL);
	_sqlite3_finalize0 (self->priv->delete_events_group);
	self->priv->delete_events_group = _tmp13_;
	_tmp14_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	sqlite3_prepare (_tmp14_, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_DELETE_EXPIRED_EVENTS, -1, &_tmp15_, NULL);
	_sqlite3_finalize0 (self->priv->delete_expired_events);
	self->priv->delete_expired_events = _tmp15_;
}

static void
dvb_database_sqlite_sqlite_epg_store_real_create (DVBdatabasesqliteSqliteDatabase* base,
                                                  GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	GError* _inner_error0_ = NULL;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	dvb_database_sqlite_sqlite_database_exec_sql ((DVBdatabasesqliteSqliteDatabase*) self, DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_CREATE_EVENTS_TABLE_STATEMENT, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	dvb_database_sqlite_sqlite_database_exec_sql ((DVBdatabasesqliteSqliteDatabase*) self, "PRAGMA synchronous=OFF", &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
dvb_database_sqlite_sqlite_epg_store_real_upgrade (DVBdatabasesqliteSqliteDatabase* base,
                                                   gint old_version,
                                                   gint new_version,
                                                   GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	GError* _inner_error0_ = NULL;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	if (old_version == 1) {
		dvb_database_sqlite_sqlite_database_exec_sql ((DVBdatabasesqliteSqliteDatabase*) self, "PRAGMA synchronous=OFF", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

static gboolean
dvb_database_sqlite_sqlite_epg_store_real_add_or_update_event (DVBdatabaseEPGStore* base,
                                                               DVBEvent* event,
                                                               guint channel_sid,
                                                               guint group_id,
                                                               GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	gint _tmp0_ = 0;
	gint free_ca_mode = 0;
	gchar* name = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* desc = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* ext_desc = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gdouble julian_start = 0.0;
	gboolean _tmp10_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->free_ca_mode) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = 0;
	}
	free_ca_mode = _tmp0_;
	_tmp1_ = event->name;
	_tmp2_ = dvb_database_sqlite_utils_escape (_tmp1_);
	name = _tmp2_;
	_tmp3_ = event->description;
	_tmp4_ = dvb_database_sqlite_utils_escape (_tmp3_);
	desc = _tmp4_;
	_tmp5_ = event->extended_description;
	_tmp6_ = dvb_database_sqlite_utils_escape (_tmp5_);
	ext_desc = _tmp6_;
	julian_start = dvb_database_sqlite_sqlite_epg_store_to_julian (self, event->year, event->month, event->day, event->hour, event->minute, event->second, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
			gboolean _tmp7_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_free0 (ext_desc);
			_g_free0 (desc);
			_g_free0 (name);
			return _tmp7_;
		} else {
			gboolean _tmp8_ = FALSE;
			_g_free0 (ext_desc);
			_g_free0 (desc);
			_g_free0 (name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp8_;
		}
	}
	if (julian_start <= ((gdouble) 0)) {
		DVBLoggingLogger* _tmp9_;
		_tmp9_ = dvb_database_sqlite_sqlite_epg_store_log;
		dvb_logging_logger_warning (_tmp9_, "SqliteEPGStore.vala:150: Failed to convert start time");
		result = FALSE;
		_g_free0 (ext_desc);
		_g_free0 (desc);
		_g_free0 (name);
		return result;
	}
	_tmp10_ = dvb_database_epg_store_contains_event ((DVBdatabaseEPGStore*) self, event, channel_sid, group_id, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
			gboolean _tmp11_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			_g_free0 (ext_desc);
			_g_free0 (desc);
			_g_free0 (name);
			return _tmp11_;
		} else {
			gboolean _tmp12_ = FALSE;
			_g_free0 (ext_desc);
			_g_free0 (desc);
			_g_free0 (name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp12_;
		}
	}
	if (_tmp10_) {
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_ = FALSE;
		sqlite3_stmt* _tmp22_;
		sqlite3_stmt* _tmp43_;
		sqlite3_stmt* _tmp47_;
		_tmp22_ = self->priv->update_event_statement;
		if (sqlite3_bind_double (_tmp22_, 1, julian_start) != SQLITE_OK) {
			_tmp21_ = TRUE;
		} else {
			sqlite3_stmt* _tmp23_;
			_tmp23_ = self->priv->update_event_statement;
			_tmp21_ = sqlite3_bind_int (_tmp23_, 2, (gint) event->duration) != SQLITE_OK;
		}
		if (_tmp21_) {
			_tmp20_ = TRUE;
		} else {
			sqlite3_stmt* _tmp24_;
			_tmp24_ = self->priv->update_event_statement;
			_tmp20_ = sqlite3_bind_int (_tmp24_, 3, (gint) event->running_status) != SQLITE_OK;
		}
		if (_tmp20_) {
			_tmp19_ = TRUE;
		} else {
			sqlite3_stmt* _tmp25_;
			_tmp25_ = self->priv->update_event_statement;
			_tmp19_ = sqlite3_bind_int (_tmp25_, 4, free_ca_mode) != SQLITE_OK;
		}
		if (_tmp19_) {
			_tmp18_ = TRUE;
		} else {
			sqlite3_stmt* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			GDestroyNotify _tmp29_;
			_tmp26_ = self->priv->update_event_statement;
			_tmp27_ = name;
			_tmp28_ = g_strdup (_tmp27_);
			_tmp29_ = g_free;
			_tmp18_ = sqlite3_bind_text (_tmp26_, 5, _tmp28_, -1, _tmp29_) != SQLITE_OK;
		}
		if (_tmp18_) {
			_tmp17_ = TRUE;
		} else {
			sqlite3_stmt* _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			GDestroyNotify _tmp33_;
			_tmp30_ = self->priv->update_event_statement;
			_tmp31_ = desc;
			_tmp32_ = g_strdup (_tmp31_);
			_tmp33_ = g_free;
			_tmp17_ = sqlite3_bind_text (_tmp30_, 6, _tmp32_, -1, _tmp33_) != SQLITE_OK;
		}
		if (_tmp17_) {
			_tmp16_ = TRUE;
		} else {
			sqlite3_stmt* _tmp34_;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			GDestroyNotify _tmp37_;
			_tmp34_ = self->priv->update_event_statement;
			_tmp35_ = ext_desc;
			_tmp36_ = g_strdup (_tmp35_);
			_tmp37_ = g_free;
			_tmp16_ = sqlite3_bind_text (_tmp34_, 7, _tmp36_, -1, _tmp37_) != SQLITE_OK;
		}
		if (_tmp16_) {
			_tmp15_ = TRUE;
		} else {
			sqlite3_stmt* _tmp38_;
			_tmp38_ = self->priv->update_event_statement;
			_tmp15_ = sqlite3_bind_int (_tmp38_, 8, (gint) group_id) != SQLITE_OK;
		}
		if (_tmp15_) {
			_tmp14_ = TRUE;
		} else {
			sqlite3_stmt* _tmp39_;
			_tmp39_ = self->priv->update_event_statement;
			_tmp14_ = sqlite3_bind_int (_tmp39_, 9, (gint) channel_sid) != SQLITE_OK;
		}
		if (_tmp14_) {
			_tmp13_ = TRUE;
		} else {
			sqlite3_stmt* _tmp40_;
			_tmp40_ = self->priv->update_event_statement;
			_tmp13_ = sqlite3_bind_int (_tmp40_, 10, (gint) event->id) != SQLITE_OK;
		}
		if (_tmp13_) {
			dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					gboolean _tmp41_ = FALSE;
					g_propagate_error (error, _inner_error0_);
					_g_free0 (ext_desc);
					_g_free0 (desc);
					_g_free0 (name);
					return _tmp41_;
				} else {
					gboolean _tmp42_ = FALSE;
					_g_free0 (ext_desc);
					_g_free0 (desc);
					_g_free0 (name);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp42_;
				}
			}
			result = FALSE;
			_g_free0 (ext_desc);
			_g_free0 (desc);
			_g_free0 (name);
			return result;
		}
		_tmp43_ = self->priv->update_event_statement;
		if (sqlite3_step (_tmp43_) != SQLITE_DONE) {
			sqlite3_stmt* _tmp44_;
			_tmp44_ = self->priv->update_event_statement;
			dvb_database_sqlite_sqlite_database_throw_last_error_reset ((DVBdatabasesqliteSqliteDatabase*) self, _tmp44_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					gboolean _tmp45_ = FALSE;
					g_propagate_error (error, _inner_error0_);
					_g_free0 (ext_desc);
					_g_free0 (desc);
					_g_free0 (name);
					return _tmp45_;
				} else {
					gboolean _tmp46_ = FALSE;
					_g_free0 (ext_desc);
					_g_free0 (desc);
					_g_free0 (name);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp46_;
				}
			}
			result = FALSE;
			_g_free0 (ext_desc);
			_g_free0 (desc);
			_g_free0 (name);
			return result;
		}
		_tmp47_ = self->priv->update_event_statement;
		sqlite3_reset (_tmp47_);
	} else {
		gboolean _tmp48_ = FALSE;
		gboolean _tmp49_ = FALSE;
		gboolean _tmp50_ = FALSE;
		gboolean _tmp51_ = FALSE;
		gboolean _tmp52_ = FALSE;
		gboolean _tmp53_ = FALSE;
		gboolean _tmp54_ = FALSE;
		gboolean _tmp55_ = FALSE;
		gboolean _tmp56_ = FALSE;
		sqlite3_stmt* _tmp57_;
		sqlite3_stmt* _tmp78_;
		sqlite3_stmt* _tmp82_;
		_tmp57_ = self->priv->insert_event_statement;
		if (sqlite3_bind_int (_tmp57_, 1, (gint) group_id) != SQLITE_OK) {
			_tmp56_ = TRUE;
		} else {
			sqlite3_stmt* _tmp58_;
			_tmp58_ = self->priv->insert_event_statement;
			_tmp56_ = sqlite3_bind_int (_tmp58_, 2, (gint) channel_sid) != SQLITE_OK;
		}
		if (_tmp56_) {
			_tmp55_ = TRUE;
		} else {
			sqlite3_stmt* _tmp59_;
			_tmp59_ = self->priv->insert_event_statement;
			_tmp55_ = sqlite3_bind_int (_tmp59_, 3, (gint) event->id) != SQLITE_OK;
		}
		if (_tmp55_) {
			_tmp54_ = TRUE;
		} else {
			sqlite3_stmt* _tmp60_;
			_tmp60_ = self->priv->insert_event_statement;
			_tmp54_ = sqlite3_bind_double (_tmp60_, 4, julian_start) != SQLITE_OK;
		}
		if (_tmp54_) {
			_tmp53_ = TRUE;
		} else {
			sqlite3_stmt* _tmp61_;
			_tmp61_ = self->priv->insert_event_statement;
			_tmp53_ = sqlite3_bind_int (_tmp61_, 5, (gint) event->duration) != SQLITE_OK;
		}
		if (_tmp53_) {
			_tmp52_ = TRUE;
		} else {
			sqlite3_stmt* _tmp62_;
			_tmp62_ = self->priv->insert_event_statement;
			_tmp52_ = sqlite3_bind_int (_tmp62_, 6, (gint) event->running_status) != SQLITE_OK;
		}
		if (_tmp52_) {
			_tmp51_ = TRUE;
		} else {
			sqlite3_stmt* _tmp63_;
			_tmp63_ = self->priv->insert_event_statement;
			_tmp51_ = sqlite3_bind_int (_tmp63_, 7, free_ca_mode) != SQLITE_OK;
		}
		if (_tmp51_) {
			_tmp50_ = TRUE;
		} else {
			sqlite3_stmt* _tmp64_;
			const gchar* _tmp65_;
			gchar* _tmp66_;
			GDestroyNotify _tmp67_;
			_tmp64_ = self->priv->insert_event_statement;
			_tmp65_ = name;
			_tmp66_ = g_strdup (_tmp65_);
			_tmp67_ = g_free;
			_tmp50_ = sqlite3_bind_text (_tmp64_, 8, _tmp66_, -1, _tmp67_) != SQLITE_OK;
		}
		if (_tmp50_) {
			_tmp49_ = TRUE;
		} else {
			sqlite3_stmt* _tmp68_;
			const gchar* _tmp69_;
			gchar* _tmp70_;
			GDestroyNotify _tmp71_;
			_tmp68_ = self->priv->insert_event_statement;
			_tmp69_ = desc;
			_tmp70_ = g_strdup (_tmp69_);
			_tmp71_ = g_free;
			_tmp49_ = sqlite3_bind_text (_tmp68_, 9, _tmp70_, -1, _tmp71_) != SQLITE_OK;
		}
		if (_tmp49_) {
			_tmp48_ = TRUE;
		} else {
			sqlite3_stmt* _tmp72_;
			const gchar* _tmp73_;
			gchar* _tmp74_;
			GDestroyNotify _tmp75_;
			_tmp72_ = self->priv->insert_event_statement;
			_tmp73_ = ext_desc;
			_tmp74_ = g_strdup (_tmp73_);
			_tmp75_ = g_free;
			_tmp48_ = sqlite3_bind_text (_tmp72_, 10, _tmp74_, -1, _tmp75_) != SQLITE_OK;
		}
		if (_tmp48_) {
			dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					gboolean _tmp76_ = FALSE;
					g_propagate_error (error, _inner_error0_);
					_g_free0 (ext_desc);
					_g_free0 (desc);
					_g_free0 (name);
					return _tmp76_;
				} else {
					gboolean _tmp77_ = FALSE;
					_g_free0 (ext_desc);
					_g_free0 (desc);
					_g_free0 (name);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp77_;
				}
			}
			result = FALSE;
			_g_free0 (ext_desc);
			_g_free0 (desc);
			_g_free0 (name);
			return result;
		}
		_tmp78_ = self->priv->insert_event_statement;
		if (sqlite3_step (_tmp78_) != SQLITE_DONE) {
			sqlite3_stmt* _tmp79_;
			_tmp79_ = self->priv->insert_event_statement;
			dvb_database_sqlite_sqlite_database_throw_last_error_reset ((DVBdatabasesqliteSqliteDatabase*) self, _tmp79_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
					gboolean _tmp80_ = FALSE;
					g_propagate_error (error, _inner_error0_);
					_g_free0 (ext_desc);
					_g_free0 (desc);
					_g_free0 (name);
					return _tmp80_;
				} else {
					gboolean _tmp81_ = FALSE;
					_g_free0 (ext_desc);
					_g_free0 (desc);
					_g_free0 (name);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp81_;
				}
			}
			result = FALSE;
			_g_free0 (ext_desc);
			_g_free0 (desc);
			_g_free0 (name);
			return result;
		}
		_tmp82_ = self->priv->insert_event_statement;
		sqlite3_reset (_tmp82_);
	}
	result = TRUE;
	_g_free0 (ext_desc);
	_g_free0 (desc);
	_g_free0 (name);
	return result;
}

static DVBEvent*
dvb_database_sqlite_sqlite_epg_store_real_get_event (DVBdatabaseEPGStore* base,
                                                     guint event_id,
                                                     guint channel_sid,
                                                     guint group_id,
                                                     GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	sqlite3_stmt* _tmp2_;
	gint rc = 0;
	sqlite3_stmt* _tmp5_;
	gboolean _tmp6_ = FALSE;
	DVBEvent* event = NULL;
	sqlite3_stmt* _tmp10_;
	GError* _inner_error0_ = NULL;
	DVBEvent* result;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	_tmp2_ = self->priv->select_event_statement;
	if (sqlite3_bind_int (_tmp2_, 1, (gint) group_id) != SQLITE_OK) {
		_tmp1_ = TRUE;
	} else {
		sqlite3_stmt* _tmp3_;
		_tmp3_ = self->priv->select_event_statement;
		_tmp1_ = sqlite3_bind_int (_tmp3_, 2, (gint) channel_sid) != SQLITE_OK;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		sqlite3_stmt* _tmp4_;
		_tmp4_ = self->priv->select_event_statement;
		_tmp0_ = sqlite3_bind_int (_tmp4_, 3, (gint) event_id) != SQLITE_OK;
	}
	if (_tmp0_) {
		dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		result = NULL;
		return result;
	}
	_tmp5_ = self->priv->select_event_statement;
	rc = sqlite3_step (_tmp5_);
	if (rc != SQLITE_ROW) {
		_tmp6_ = rc != SQLITE_DONE;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		sqlite3_stmt* _tmp7_;
		_tmp7_ = self->priv->select_event_statement;
		dvb_database_sqlite_sqlite_database_throw_last_error_reset ((DVBdatabasesqliteSqliteDatabase*) self, _tmp7_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		result = NULL;
		return result;
	}
	event = NULL;
	if (rc != SQLITE_DONE) {
		sqlite3_stmt* _tmp8_;
		DVBEvent* _tmp9_;
		_tmp8_ = self->priv->select_event_statement;
		_tmp9_ = dvb_database_sqlite_sqlite_epg_store_create_event_from_statement (self, _tmp8_);
		_dvb_event_unref0 (event);
		event = _tmp9_;
	}
	_tmp10_ = self->priv->select_event_statement;
	sqlite3_reset (_tmp10_);
	result = event;
	return result;
}

static gboolean
dvb_database_sqlite_sqlite_epg_store_real_remove_event (DVBdatabaseEPGStore* base,
                                                        guint event_id,
                                                        guint channel_sid,
                                                        guint group_id,
                                                        GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	_tmp2_ = self->priv->delete_event_statement;
	if (sqlite3_bind_int (_tmp2_, 1, (gint) group_id) != SQLITE_OK) {
		_tmp1_ = TRUE;
	} else {
		sqlite3_stmt* _tmp3_;
		_tmp3_ = self->priv->delete_event_statement;
		_tmp1_ = sqlite3_bind_int (_tmp3_, 2, (gint) channel_sid) != SQLITE_OK;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		sqlite3_stmt* _tmp4_;
		_tmp4_ = self->priv->delete_event_statement;
		_tmp0_ = sqlite3_bind_int (_tmp4_, 3, (gint) event_id) != SQLITE_OK;
	}
	if (_tmp0_) {
		dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gboolean _tmp5_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp5_;
			} else {
				gboolean _tmp6_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp6_;
			}
		}
		result = FALSE;
		return result;
	}
	_tmp7_ = self->priv->delete_event_statement;
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
		sqlite3_stmt* _tmp8_;
		_tmp8_ = self->priv->delete_event_statement;
		dvb_database_sqlite_sqlite_database_throw_last_error_reset ((DVBdatabasesqliteSqliteDatabase*) self, _tmp8_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gboolean _tmp9_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp9_;
			} else {
				gboolean _tmp10_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp10_;
			}
		}
		result = FALSE;
		return result;
	}
	_tmp11_ = self->priv->delete_event_statement;
	sqlite3_reset (_tmp11_);
	result = TRUE;
	return result;
}

static gboolean
dvb_database_sqlite_sqlite_epg_store_real_remove_events_older_than (DVBdatabaseEPGStore* base,
                                                                    DVBEvent* event,
                                                                    guint channel_sid,
                                                                    guint group_id,
                                                                    GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	time_t timestamp = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	sqlite3_stmt* _tmp2_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp11_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	timestamp = dvb_event_get_end_timestamp (event);
	_tmp2_ = self->priv->delete_expired_events;
	if (sqlite3_bind_int64 (_tmp2_, 1, (gint64) timestamp) != SQLITE_OK) {
		_tmp1_ = TRUE;
	} else {
		sqlite3_stmt* _tmp3_;
		_tmp3_ = self->priv->delete_expired_events;
		_tmp1_ = sqlite3_bind_int (_tmp3_, 2, (gint) channel_sid) != SQLITE_OK;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		sqlite3_stmt* _tmp4_;
		_tmp4_ = self->priv->delete_expired_events;
		_tmp0_ = sqlite3_bind_int (_tmp4_, 3, (gint) group_id) != SQLITE_OK;
	}
	if (_tmp0_) {
		dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gboolean _tmp5_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp5_;
			} else {
				gboolean _tmp6_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp6_;
			}
		}
		result = FALSE;
		return result;
	}
	_tmp7_ = self->priv->delete_expired_events;
	if (sqlite3_step (_tmp7_) != SQLITE_DONE) {
		sqlite3_stmt* _tmp8_;
		_tmp8_ = self->priv->delete_expired_events;
		dvb_database_sqlite_sqlite_database_throw_last_error_reset ((DVBdatabasesqliteSqliteDatabase*) self, _tmp8_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gboolean _tmp9_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp9_;
			} else {
				gboolean _tmp10_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp10_;
			}
		}
		result = FALSE;
		return result;
	}
	_tmp11_ = self->priv->delete_expired_events;
	sqlite3_reset (_tmp11_);
	result = TRUE;
	return result;
}

static gboolean
dvb_database_sqlite_sqlite_epg_store_real_contains_event (DVBdatabaseEPGStore* base,
                                                          DVBEvent* event,
                                                          guint channel_sid,
                                                          guint group_id,
                                                          GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	sqlite3_stmt* _tmp2_;
	gint c = 0;
	sqlite3_stmt* _tmp9_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp2_ = self->priv->has_event_statement;
	if (sqlite3_bind_int (_tmp2_, 1, (gint) group_id) != SQLITE_OK) {
		_tmp1_ = TRUE;
	} else {
		sqlite3_stmt* _tmp3_;
		_tmp3_ = self->priv->has_event_statement;
		_tmp1_ = sqlite3_bind_int (_tmp3_, 2, (gint) channel_sid) != SQLITE_OK;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		sqlite3_stmt* _tmp4_;
		_tmp4_ = self->priv->has_event_statement;
		_tmp0_ = sqlite3_bind_int (_tmp4_, 3, (gint) event->id) != SQLITE_OK;
	}
	if (_tmp0_) {
		dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gboolean _tmp5_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp5_;
			} else {
				gboolean _tmp6_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp6_;
			}
		}
		result = FALSE;
		return result;
	}
	c = 0;
	while (TRUE) {
		sqlite3_stmt* _tmp7_;
		sqlite3_stmt* _tmp8_;
		_tmp7_ = self->priv->has_event_statement;
		if (!(sqlite3_step (_tmp7_) == SQLITE_ROW)) {
			break;
		}
		_tmp8_ = self->priv->has_event_statement;
		c = sqlite3_column_int (_tmp8_, 0);
	}
	_tmp9_ = self->priv->has_event_statement;
	sqlite3_reset (_tmp9_);
	result = c > 0;
	return result;
}

static GeeList*
dvb_database_sqlite_sqlite_epg_store_real_get_events (DVBdatabaseEPGStore* base,
                                                      guint channel_sid,
                                                      guint group_id,
                                                      GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	GeeList* events = NULL;
	GeeArrayList* _tmp0_;
	sqlite3* _tmp1_;
	gchar* statement_str = NULL;
	gchar* _tmp3_;
	sqlite3_stmt* statement = NULL;
	sqlite3* _tmp4_;
	const gchar* _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	gint _tmp7_;
	GError* _inner_error0_ = NULL;
	GeeList* result;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	_tmp0_ = gee_array_list_new (DVB_TYPE_EVENT, (GBoxedCopyFunc) dvb_event_ref, (GDestroyNotify) dvb_event_unref, NULL, NULL, NULL);
	events = (GeeList*) _tmp0_;
	_tmp1_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	if (_tmp1_ == NULL) {
		DVBLoggingLogger* _tmp2_;
		_tmp2_ = dvb_database_sqlite_sqlite_epg_store_log;
		dvb_logging_logger_warning (_tmp2_, "SqliteEPGStore.vala:295: DB not initialized");
		result = events;
		return result;
	}
	_tmp3_ = g_strdup_printf (DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_SELECT_MINIMAL_EVENTS_STATEMENT, group_id, channel_sid);
	statement_str = _tmp3_;
	_tmp4_ = ((DVBdatabasesqliteSqliteDatabase*) self)->db;
	_tmp5_ = statement_str;
	_tmp7_ = sqlite3_prepare (_tmp4_, _tmp5_, -1, &_tmp6_, NULL);
	_sqlite3_finalize0 (statement);
	statement = _tmp6_;
	if (_tmp7_ != SQLITE_OK) {
		dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_sqlite3_finalize0 (statement);
				_g_free0 (statement_str);
				_g_object_unref0 (events);
				return NULL;
			} else {
				_sqlite3_finalize0 (statement);
				_g_free0 (statement_str);
				_g_object_unref0 (events);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		result = events;
		_sqlite3_finalize0 (statement);
		_g_free0 (statement_str);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp8_;
		DVBEvent* event = NULL;
		sqlite3_stmt* _tmp9_;
		DVBEvent* _tmp10_;
		GeeList* _tmp11_;
		DVBEvent* _tmp12_;
		_tmp8_ = statement;
		if (!(sqlite3_step (_tmp8_) == SQLITE_ROW)) {
			break;
		}
		_tmp9_ = statement;
		_tmp10_ = dvb_database_sqlite_sqlite_epg_store_create_minimal_event (self, _tmp9_);
		event = _tmp10_;
		_tmp11_ = events;
		_tmp12_ = event;
		gee_collection_add ((GeeCollection*) _tmp11_, _tmp12_);
		_dvb_event_unref0 (event);
	}
	result = events;
	_sqlite3_finalize0 (statement);
	_g_free0 (statement_str);
	return result;
}

static gboolean
dvb_database_sqlite_sqlite_epg_store_real_remove_events_of_group (DVBdatabaseEPGStore* base,
                                                                  guint group_id,
                                                                  GError** error)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp3_;
	sqlite3_stmt* _tmp7_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	self = (DVBdatabasesqliteSqliteEPGStore*) base;
	_tmp0_ = self->priv->delete_events_group;
	if (sqlite3_bind_int (_tmp0_, 1, (gint) group_id) != SQLITE_OK) {
		dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gboolean _tmp1_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp1_;
			} else {
				gboolean _tmp2_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp2_;
			}
		}
		result = FALSE;
		return result;
	}
	_tmp3_ = self->priv->delete_events_group;
	if (sqlite3_step (_tmp3_) != SQLITE_DONE) {
		sqlite3_stmt* _tmp4_;
		_tmp4_ = self->priv->delete_events_group;
		dvb_database_sqlite_sqlite_database_throw_last_error_reset ((DVBdatabasesqliteSqliteDatabase*) self, _tmp4_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gboolean _tmp5_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp5_;
			} else {
				gboolean _tmp6_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp6_;
			}
		}
		result = FALSE;
		return result;
	}
	_tmp7_ = self->priv->delete_events_group;
	sqlite3_reset (_tmp7_);
	result = TRUE;
	return result;
}

static DVBEvent*
dvb_database_sqlite_sqlite_epg_store_create_minimal_event (DVBdatabasesqliteSqliteEPGStore* self,
                                                           sqlite3_stmt* statement)
{
	DVBEvent* event = NULL;
	DVBEvent* _tmp0_;
	const gchar* starttime = NULL;
	const gchar* _tmp1_;
	DVBEvent* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (statement != NULL, NULL);
	_tmp0_ = dvb_event_new ();
	event = _tmp0_;
	event->id = (guint) sqlite3_column_int (statement, 0);
	_tmp1_ = (const gchar*) sqlite3_column_text (statement, 1);
	starttime = _tmp1_;
	sscanf (starttime, "%04u-%02u-%02u %02u:%02u:%02u", &event->year, &event->month, &event->day, &event->hour, &event->minute, &event->second);
	event->duration = (guint) sqlite3_column_int (statement, 2);
	result = event;
	return result;
}

static void
_dvb_event_audio_component_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (dvb_event_audio_component_unref (var), NULL));
}

static inline void
_g_slist_free__dvb_event_audio_component_unref0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _dvb_event_audio_component_unref0_);
}

static void
_dvb_event_teletext_component_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (dvb_event_teletext_component_unref (var), NULL));
}

static inline void
_g_slist_free__dvb_event_teletext_component_unref0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _dvb_event_teletext_component_unref0_);
}

static DVBEvent*
dvb_database_sqlite_sqlite_epg_store_create_event_from_statement (DVBdatabasesqliteSqliteEPGStore* self,
                                                                  sqlite3_stmt* statement)
{
	DVBEvent* event = NULL;
	DVBEvent* _tmp0_;
	const gchar* starttime = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	DVBEvent* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (statement != NULL, NULL);
	_tmp0_ = dvb_event_new ();
	event = _tmp0_;
	event->id = (guint) sqlite3_column_int (statement, 0);
	_tmp1_ = (const gchar*) sqlite3_column_text (statement, 1);
	starttime = _tmp1_;
	sscanf (starttime, "%04u-%02u-%02u %02u:%02u:%02u", &event->year, &event->month, &event->day, &event->hour, &event->minute, &event->second);
	event->duration = (guint) sqlite3_column_int (statement, 2);
	event->running_status = (guint) sqlite3_column_int (statement, 3);
	event->free_ca_mode = sqlite3_column_int (statement, 4) == 1;
	_tmp2_ = (const gchar*) sqlite3_column_text (statement, 5);
	_tmp3_ = dvb_database_sqlite_utils_unescape (_tmp2_);
	_g_free0 (event->name);
	event->name = _tmp3_;
	_tmp4_ = (const gchar*) sqlite3_column_text (statement, 6);
	_tmp5_ = dvb_database_sqlite_utils_unescape (_tmp4_);
	_g_free0 (event->description);
	event->description = _tmp5_;
	_tmp6_ = (const gchar*) sqlite3_column_text (statement, 7);
	_tmp7_ = dvb_database_sqlite_utils_unescape (_tmp6_);
	_g_free0 (event->extended_description);
	event->extended_description = _tmp7_;
	(event->audio_components == NULL) ? NULL : (event->audio_components = (_g_slist_free__dvb_event_audio_component_unref0_ (event->audio_components), NULL));
	event->audio_components = NULL;
	_dvb_event_video_component_unref0 (event->video_component);
	event->video_component = NULL;
	(event->teletext_components == NULL) ? NULL : (event->teletext_components = (_g_slist_free__dvb_event_teletext_component_unref0_ (event->teletext_components), NULL));
	event->teletext_components = NULL;
	result = event;
	return result;
}

static gdouble
dvb_database_sqlite_sqlite_epg_store_to_julian (DVBdatabasesqliteSqliteEPGStore* self,
                                                guint year,
                                                guint month,
                                                guint day,
                                                guint hour,
                                                guint minute,
                                                guint second,
                                                GError** error)
{
	gchar* datetime_str = NULL;
	gchar* _tmp0_;
	sqlite3_stmt* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GDestroyNotify _tmp4_;
	sqlite3_stmt* _tmp7_;
	gdouble val = 0.0;
	sqlite3_stmt* _tmp10_;
	sqlite3_stmt* _tmp11_;
	GError* _inner_error0_ = NULL;
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = g_strdup_printf ("%04u-%02u-%02u %02u:%02u:%02u", year, month, day, hour, minute, second);
	datetime_str = _tmp0_;
	_tmp1_ = self->priv->to_julian_statement;
	_tmp2_ = datetime_str;
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = g_free;
	if (sqlite3_bind_text (_tmp1_, 1, _tmp3_, -1, _tmp4_) != SQLITE_OK) {
		dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gdouble _tmp5_ = -1.0;
				g_propagate_error (error, _inner_error0_);
				_g_free0 (datetime_str);
				return _tmp5_;
			} else {
				gdouble _tmp6_ = -1.0;
				_g_free0 (datetime_str);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp6_;
			}
		}
		result = (gdouble) 0;
		_g_free0 (datetime_str);
		return result;
	}
	_tmp7_ = self->priv->to_julian_statement;
	if (sqlite3_step (_tmp7_) != SQLITE_ROW) {
		dvb_database_sqlite_sqlite_database_throw_last_error ((DVBdatabasesqliteSqliteDatabase*) self, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DVB_DATABASE_SQL_ERROR) {
				gdouble _tmp8_ = -1.0;
				g_propagate_error (error, _inner_error0_);
				_g_free0 (datetime_str);
				return _tmp8_;
			} else {
				gdouble _tmp9_ = -1.0;
				_g_free0 (datetime_str);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp9_;
			}
		}
		result = (gdouble) 0;
		_g_free0 (datetime_str);
		return result;
	}
	_tmp10_ = self->priv->to_julian_statement;
	val = sqlite3_column_double (_tmp10_, 0);
	_tmp11_ = self->priv->to_julian_statement;
	sqlite3_reset (_tmp11_);
	result = val;
	_g_free0 (datetime_str);
	return result;
}

static void
dvb_database_sqlite_sqlite_epg_store_class_init (DVBdatabasesqliteSqliteEPGStoreClass * klass,
                                                 gpointer klass_data)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_database_sqlite_sqlite_epg_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DVBdatabasesqliteSqliteEPGStore_private_offset);
	((DVBdatabasesqliteSqliteDatabaseClass *) klass)->on_open = (void (*) (DVBdatabasesqliteSqliteDatabase*)) dvb_database_sqlite_sqlite_epg_store_real_on_open;
	((DVBdatabasesqliteSqliteDatabaseClass *) klass)->create = (void (*) (DVBdatabasesqliteSqliteDatabase*, GError**)) dvb_database_sqlite_sqlite_epg_store_real_create;
	((DVBdatabasesqliteSqliteDatabaseClass *) klass)->upgrade = (void (*) (DVBdatabasesqliteSqliteDatabase*, gint, gint, GError**)) dvb_database_sqlite_sqlite_epg_store_real_upgrade;
	G_OBJECT_CLASS (klass)->finalize = dvb_database_sqlite_sqlite_epg_store_finalize;
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_database_sqlite_sqlite_epg_store_log = _tmp1_;
}

static void
dvb_database_sqlite_sqlite_epg_store_dvb_database_epg_store_interface_init (DVBdatabaseEPGStoreIface * iface,
                                                                            gpointer iface_data)
{
	dvb_database_sqlite_sqlite_epg_store_dvb_database_epg_store_parent_iface = g_type_interface_peek_parent (iface);
	iface->add_or_update_event = (gboolean (*) (DVBdatabaseEPGStore*, DVBEvent*, guint, guint, GError**)) dvb_database_sqlite_sqlite_epg_store_real_add_or_update_event;
	iface->get_event = (DVBEvent* (*) (DVBdatabaseEPGStore*, guint, guint, guint, GError**)) dvb_database_sqlite_sqlite_epg_store_real_get_event;
	iface->remove_event = (gboolean (*) (DVBdatabaseEPGStore*, guint, guint, guint, GError**)) dvb_database_sqlite_sqlite_epg_store_real_remove_event;
	iface->remove_events_older_than = (gboolean (*) (DVBdatabaseEPGStore*, DVBEvent*, guint, guint, GError**)) dvb_database_sqlite_sqlite_epg_store_real_remove_events_older_than;
	iface->contains_event = (gboolean (*) (DVBdatabaseEPGStore*, DVBEvent*, guint, guint, GError**)) dvb_database_sqlite_sqlite_epg_store_real_contains_event;
	iface->get_events = (GeeList* (*) (DVBdatabaseEPGStore*, guint, guint, GError**)) dvb_database_sqlite_sqlite_epg_store_real_get_events;
	iface->remove_events_of_group = (gboolean (*) (DVBdatabaseEPGStore*, guint, GError**)) dvb_database_sqlite_sqlite_epg_store_real_remove_events_of_group;
}

static void
dvb_database_sqlite_sqlite_epg_store_instance_init (DVBdatabasesqliteSqliteEPGStore * self,
                                                    gpointer klass)
{
	self->priv = dvb_database_sqlite_sqlite_epg_store_get_instance_private (self);
}

static void
dvb_database_sqlite_sqlite_epg_store_finalize (GObject * obj)
{
	DVBdatabasesqliteSqliteEPGStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE, DVBdatabasesqliteSqliteEPGStore);
	_sqlite3_finalize0 (self->priv->to_julian_statement);
	_sqlite3_finalize0 (self->priv->insert_event_statement);
	_sqlite3_finalize0 (self->priv->update_event_statement);
	_sqlite3_finalize0 (self->priv->delete_event_statement);
	_sqlite3_finalize0 (self->priv->has_event_statement);
	_sqlite3_finalize0 (self->priv->select_event_statement);
	_sqlite3_finalize0 (self->priv->delete_events_group);
	_sqlite3_finalize0 (self->priv->delete_expired_events);
	G_OBJECT_CLASS (dvb_database_sqlite_sqlite_epg_store_parent_class)->finalize (obj);
}

static GType
dvb_database_sqlite_sqlite_epg_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DVBdatabasesqliteSqliteEPGStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_database_sqlite_sqlite_epg_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBdatabasesqliteSqliteEPGStore), 0, (GInstanceInitFunc) dvb_database_sqlite_sqlite_epg_store_instance_init, NULL };
	static const GInterfaceInfo dvb_database_epg_store_info = { (GInterfaceInitFunc) dvb_database_sqlite_sqlite_epg_store_dvb_database_epg_store_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType dvb_database_sqlite_sqlite_epg_store_type_id;
	dvb_database_sqlite_sqlite_epg_store_type_id = g_type_register_static (DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, "DVBdatabasesqliteSqliteEPGStore", &g_define_type_info, 0);
	g_type_add_interface_static (dvb_database_sqlite_sqlite_epg_store_type_id, DVB_DATABASE_TYPE_EPG_STORE, &dvb_database_epg_store_info);
	DVBdatabasesqliteSqliteEPGStore_private_offset = g_type_add_instance_private (dvb_database_sqlite_sqlite_epg_store_type_id, sizeof (DVBdatabasesqliteSqliteEPGStorePrivate));
	return dvb_database_sqlite_sqlite_epg_store_type_id;
}

GType
dvb_database_sqlite_sqlite_epg_store_get_type (void)
{
	static volatile gsize dvb_database_sqlite_sqlite_epg_store_type_id__once = 0;
	if (g_once_init_enter (&dvb_database_sqlite_sqlite_epg_store_type_id__once)) {
		GType dvb_database_sqlite_sqlite_epg_store_type_id;
		dvb_database_sqlite_sqlite_epg_store_type_id = dvb_database_sqlite_sqlite_epg_store_get_type_once ();
		g_once_init_leave (&dvb_database_sqlite_sqlite_epg_store_type_id__once, dvb_database_sqlite_sqlite_epg_store_type_id);
	}
	return dvb_database_sqlite_sqlite_epg_store_type_id__once;
}

